import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.awt.Component.*;
import java.awt.TextField.*;

/**
* Esta Classe permite criar Grids para facilitar o posicionamento dos componentes em tela
* @author Ivan Nagy
* @since 2002-10-17
**/
public class AddGridComponente extends Panel
{
	/**
	* @param GridBagLayout
	* @param Contraint
	* @param Linhas
	* @param Colunas
	**/
	public AddGridComponente(GridBagLayout pGrid,GridBagConstraints pConstraint,
	                           int pRow,int pColumn)
	{
		setLayout(pGrid);
		setFont(new Font("Courier New", Font.PLAIN, 12));
		setDimensionaGrid(pGrid,pConstraint,pRow,pColumn);
	}

	/**
	* Adiciona os componentes a grid
	* @param Componente
	* @param GridBagLayout
	* @param Contraint
	* @param Linhas
	* @param Colunas
	* @param Linhas que utilizara
	* @param Colunas que utilizara
	**/
	public void addComponente(Component pComponente,
							  GridBagLayout pGrid,GridBagConstraints pConstraint,
                              int pRow,int pColumn,int pHeight,int pWidth)
	{
		pConstraint.fill = GridBagConstraints.BOTH;

		//Posiciona a linha
		pConstraint.gridy = pRow;

		//Posiciona a coluna
		pConstraint.gridx = pColumn;

		//Ocupacao da linha
		pConstraint.gridheight = pHeight;

		//Ocupacao da coluna
		pConstraint.gridwidth = pWidth;

        pGrid.setConstraints(pComponente, pConstraint);

        add(pComponente);
	}

	public void setDimensionaGrid(GridBagLayout pGrid,GridBagConstraints pConstraint,
	                           int pRow,int pColumn)
	{
		//Dimensiona Linhas
		for ( int i = 0; i <= pRow; i++ )
			addComponente(new Label(" "),pGrid,pConstraint,i,0,1,1);

		//Dimensiona Colunas
		for ( int i = 0; i <= pColumn; i++ )
			addComponente(new Label(" "),pGrid,pConstraint,0,i,1,1);

	}
}