/**
* Tratamento do Cadastro Pessoa Fisica
* @author Ivan Nagy
* @since 2002-10-17
**/
public final class CPF
{

	public CPF(){}

	/**
	* Retorna true para CPF valido ou false para CPF invalido.
	* Devera receber o numero do CPF sem formatacao-- o metodo
	* ira ignorar os numeros multiplos de 0,1,2,3,4,5,6,7,8 e 9
	* @param CPF
	* @return true para numero valido--false para numero invalido
	**/
	public static boolean isCPF( String pCPF ) throws Exception
	{
		int soma = 0;
		int resto = 0;

		try
		{
			/***** Verifica se digitado e' sequencia de numeros repetidos *****/
			if( pCPF.length() != 11 || pCPF.equals( "00000000000" ) || pCPF.equals( "11111111111" ) ||
				pCPF.equals( "22222222222" ) || pCPF.equals( "33333333333" ) || pCPF.equals( "44444444444" ) ||
				pCPF.equals( "55555555555" ) || pCPF.equals( "66666666666" ) || pCPF.equals( "77777777777" ) ||
				pCPF.equals( "88888888888" ) || pCPF.equals( "99999999999" ) )
				return false;

			for( int i = 0; i < 9; i++ )
			{
				soma += Integer.parseInt( pCPF.substring( i,i + 1 ) ) * ( 10 - i );
			}

			resto = 11 - ( soma % 11 );

			resto = ( resto % 10 );

			if( resto != Integer.parseInt( pCPF.substring( 9,10 ) ) )
				return false;

			soma = 0;

			for( int i = 0; i < 10; i++ )
			{
				soma += Integer.parseInt( pCPF.substring( i,i + 1 ) ) * ( 11 - i );
			}

			resto = 11 - ( soma % 11 );

			resto = ( resto % 10 );

			if( resto != Integer.parseInt( pCPF.substring( 10,11 ) ) )
				return false;

			return true;
		}
		catch( Exception exp )
		{
			throw new Exception( "CPF invalido" );
		}
	}
}

