import java.awt.*;
import java.net.*;
import java.awt.event.*;
import java.applet.Applet;
import java.applet.AppletContext;
import javax.swing.*;
import java.io.PrintStream;
import java.io.DataInputStream;
import java.io.IOException;

/**
* Esta Classe esta responsavel para efetuar o cadastramento de clientes
* @author Ivan Nagy
* @since 2002-10-17
**/
public class Cadastro extends Applet implements ActionListener
{
	private static final Parametro param = new Parametro();
	private JButton btConsultar, btNovo, btGravar;
	private List lstLogradouro, lstEstado, lstProfissao, lstEstadoCiv,
				 lstEscola, lstBanco, lstHistorico,lstDoc1,lstDoc2;
	private String 	codLogr[], codEstado[], codProfissao[],
					codEstadoCiv[], codEscola[], codBanco[], codHistorico[],
					codDoc1[],codDoc2[];
	private ClienteInformacao dados;
	private ClienteFiscal fiscal;
	private ClienteComplemento compl;

	private static final CheckString clsCheckString = new CheckString();
	private static final CNPJ clsCNPJ = new CNPJ();
	private static final CPF clsCPF = new CPF();
	private static final Calendario clsCalendario = new Calendario();
	private static final CalculaCDCelular clsCalculaCDCelular = new CalculaCDCelular();

	private TextField txtCelular;
	private TextField txtCD;

	private Status clsStatus;
	private int mtamanho = 20;

	private String mRCli="S",mRFis="S",mRCom="S";

	public void init()
	{
		Titulo titulo1 = new Titulo("Celular e Codigo de Segurana",20,20);
		Titulo titulo4 = new Titulo("Informao do cliente",20,20);
		Titulo titulo2 = new Titulo("Documentos fiscais",20,20);
		Titulo titulo3 = new Titulo("Informaes complementares",20,20);

		clsStatus = new Status( "",20,20 );

		JPanel pnlJButton = new JPanel(new FlowLayout(FlowLayout.CENTER));
		pnlJButton.setBorder( BorderFactory.createEtchedBorder() );
		pnlJButton.setBackground(param.get_BackColor());
		pnlJButton.setForeground(param.get_ForeColor());

		btConsultar  = new JButton("Consultar");
		btConsultar.setForeground(Color.black);
		btConsultar.setFont(param.get_Fonte());

		btNovo     =   new JButton("  Novo   ");
		btNovo.setForeground(Color.black);
		btNovo.setFont(param.get_Fonte());

		btGravar   =   new JButton(" Enviar  ");
		btGravar.setForeground(Color.black);
		btGravar.setFont(param.get_Fonte());

		btConsultar.addActionListener(this);
		btNovo.addActionListener(this);
		btGravar.addActionListener(this);
		pnlJButton.add(btNovo);
		pnlJButton.add(btGravar);

		lstLogradouro = new List();
		lstEstado = new List();
		lstProfissao = new List();
		lstEstadoCiv = new List();
		lstEscola = new List();
		lstBanco = new List();
		lstHistorico = new List();

		Label lblCelular = new Label(" Celular:");
		Label lblCD = new Label("CD:");

		//********************************
		txtCelular = new TextField();
		txtCelular.setName("txtCelular");
		txtCelular.setBackground(Color.white);
		txtCelular.setForeground(Color.black);
		txtCelular.setFont(param.get_Fonte());
		//********************************
		txtCD = new TextField();
		txtCD.setName("txtCD");
		txtCD.setBackground(Color.white);
		txtCD.setForeground(Color.black);
		txtCD.setFont(param.get_Fonte());

		String wparam = getParameter("param1");

		//******* Obtm logradouros
		obtLogradouros( wparam );
		//*************************

		//******* Obtm Estados
		obtEstados( wparam );
		//*********************

		//******* Obtm Profisso
		obtProfissao( wparam );
		//***********************

		//******* Obtm estado civil
		obtEstadoCiv( wparam );
		//**************************

		//******* Obtm escolaridade
		obtEscolaridade( wparam );
		//**************************

		//******* Obtm Bancos
		obtBanco( wparam );
		//********************

		//******* Obtm Histricos
		obtHistorico( wparam );
		//********************

		//******* Obtm Histricos
		obtTipoDocumento( wparam );
		//********************

		//******* Obtm Restricao
		//obtRestricao( wparam );

		dados = new ClienteInformacao(	this,lstLogradouro,
							lstEstado,
							lstHistorico,lstDoc1,lstDoc2,
							codLogr,
							codEstado,
							codHistorico,codDoc1,codDoc2);

		fiscal = new ClienteFiscal();

		compl = new ClienteComplemento(lstProfissao,
								lstEstadoCiv,
								lstEscola,
								lstBanco,
								codProfissao,
								codEstadoCiv,
								codEscola,
								codBanco);

		// ************ Painis *****************

		// ********** Celular *******
		JPanel pnlCelular = new JPanel(new BorderLayout( 1,1 ) );
		pnlCelular.setBackground(param.get_BackColor());
		pnlCelular.setForeground(param.get_ForeColor());

		txtCelular.setFont(param.getFonteGrande());
		txtCD.setFont(param.getFonteGrande());

		GridBagConstraints gbcConstraints = new GridBagConstraints();
		GridBagLayout gblCelular = new GridBagLayout();
		AddGridComponente grdAddCelular = new AddGridComponente(gblCelular,gbcConstraints,2,22);
		pnlCelular.add( grdAddCelular,"Center" );
		pnlCelular.add( titulo4,"South" );

		grdAddCelular.addComponente(lblCelular,gblCelular,gbcConstraints,1,1,1,1);
		grdAddCelular.addComponente(txtCelular,gblCelular,gbcConstraints,1,4,1,6);
		grdAddCelular.addComponente(lblCD,gblCelular,gbcConstraints,1,11,1,1);
		grdAddCelular.addComponente(txtCD,gblCelular,gbcConstraints,1,12,1,1);
		grdAddCelular.addComponente(btConsultar,gblCelular,gbcConstraints,1,15,1,5);

		Panel pnlAux = new Panel( new BorderLayout( 1,1 ) );
		pnlAux.add( pnlCelular,"North" );
		pnlAux.add( dados,"Center");

		Panel pnlInfo = new Panel(new BorderLayout(5,5));
		pnlInfo.add(titulo1,"North");
		pnlInfo.add(pnlAux,"Center");

		Panel pnl1 = new Panel(new BorderLayout(5,5));
		pnl1.add(titulo2,"North");
		pnl1.add(fiscal,"Center");

		Panel pnlInfo1 = new Panel(new BorderLayout(5,5));
		pnlInfo1.add(pnlInfo,"North");
		pnlInfo1.add(pnl1,"Center");

		Panel pnl2 = new Panel(new BorderLayout(5,5));
		pnl2.add(titulo3,"North");
		pnl2.add(compl,"Center");

		Panel pnlInfo2 = new Panel(new BorderLayout(5,5));
		pnlInfo2.add(pnlInfo1,"North");
		pnlInfo2.add(pnl2,"Center");
		pnlInfo2.add(pnlJButton,"South");
		//setLayout(new GridLayout(1,1));
		setLayout( new BorderLayout( 1, 1 ) );
		add(pnlInfo2,BorderLayout.CENTER );
		add(clsStatus,BorderLayout.SOUTH );
		setBackground(param.get_BackColor());
		setForeground(param.get_ForeColor());
		setFont(param.get_Fonte());
		// **************************************

		changeLookAndFeel( );

		//trataRestricao( "S" );

		txtCelular.requestFocus();
	}

	public String getCelular()
	{
		return txtCelular.getText();
	}

	public String getCD()
	{
		return txtCD.getText();
	}

	public void setCelular(String celular)
	{
		txtCelular.setText(celular);
	}

	public void setCD(String celular)
	{
		txtCD.setText(celular);
	}


	/****************
	Obtm logradouros
	*****************/
	void obtLogradouros( String pStr )
	{
		int pos, tam, qtd;
		String cod, descr,logr;

		int wtam_max = 7;

		try
		{
			logr = " = |" + param.xml_get( pStr,"LOGR" );
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
			return;
		}

		if( logr.length() <= 0 )
			return;

		try
		{
			tam=logr.length();

			/************************
			Obtem qtd. de Logradouros
			*************************/
			for(pos=0, qtd=0;; qtd++)
			{
				cod = param.getSubstring("=",logr, pos);
				pos=pos+cod.length()+1;
				descr = param.getSubstring("|",logr, pos);
				pos=pos+descr.length()+1;
				if (pos >= tam) break;
			}

			/**********
			Cria arrays
			***********/
			codLogr = new String[qtd+1];
			lstLogradouro = new List();

			/**********
			Monta Lista
			***********/
			for(pos=0, qtd=0;; qtd++)
			{
				cod = param.getSubstring("=",logr, pos);
				pos=pos+cod.length()+1;
				descr = param.getSubstring("|",logr, pos);
				pos=pos+descr.length()+1;
				codLogr[qtd] = cod;

				descr = descr.trim();
				if( descr.length() > wtam_max )
					descr = descr.substring( 0,wtam_max ) + "...";

				lstLogradouro.add(descr.replace('_',' '));

				if (pos >= tam) break;
			}
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
		}
	}

	/************
	Obtm Estados
	*************/
	void obtEstados( String pStr )
	{
		int pos, tam, qtd;
		String cod, descr;
		String estados;

		try
		{
			estados = " = |" + param.xml_get( pStr,"UF" );
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
			return;
		}

		if( estados.length() <= 0 )
			return;


		try
		{
			tam=estados.length();

			/********************
			Obtem qtd. de Estados
			*********************/
			for(pos=0, qtd=0;; qtd++)
			{
				cod = param.getSubstring("=",estados, pos);
				pos=pos+cod.length()+1;
				descr = param.getSubstring("|",estados, pos);
				pos=pos+descr.length()+1;
				if (pos >= tam) break;
			}

			/**********
			Cria arrays
			***********/
			codEstado = new String[qtd+1];
			lstEstado = new List();

			/**********
			Monta Lista
			***********/
			for(pos=0, qtd=0;; qtd++)
			{
				cod = param.getSubstring("=",estados, pos);
				pos=pos+cod.length()+1;
				descr = param.getSubstring("|",estados, pos);
				pos=pos+descr.length()+1;
				codEstado[qtd] = cod;

				descr = descr.trim();
				if( descr.length() > mtamanho )
					descr = descr.substring( 0,mtamanho ) + "...";

				lstEstado.add(descr.replace('_',' '));

				if (pos >= tam) break;
			}
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
		}
	}

	/***************
	Obtm profissoes
	****************/
	void obtProfissao( String pStr )
	{
		int pos, tam, qtd;
		String cod, descr;
		String profissao;

		try
		{
			profissao = " = |" + param.xml_get( pStr,"PROF" );
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
			return;
		}


		if( profissao.length() <= 0 )
			return;

		try
		{
			tam=profissao.length();

			/***********************
			Obtem qtd. de Profisses
			************************/
			for(pos=0, qtd=0;; qtd++)
			{
				cod = param.getSubstring("=",profissao, pos);
				pos=pos+cod.length()+1;
				descr = param.getSubstring("|",profissao, pos);
				pos=pos+descr.length()+1;
				if (pos >= tam) break;
			}

			/**********
			Cria arrays
			***********/
			codProfissao = new String[qtd+1];
			lstProfissao = new List();

			/**********
			Monta Lista
			***********/
			for(pos=0, qtd=0;; qtd++)
			{
				cod = param.getSubstring("=",profissao, pos);
				pos=pos+cod.length()+1;
				descr = param.getSubstring("|",profissao, pos);
				pos=pos+descr.length()+1;
				codProfissao[qtd] = cod;

				descr = descr.trim();
				if( descr.length() > mtamanho )
					descr = descr.substring( 0,mtamanho ) + "...";

				lstProfissao.add(descr.replace('_',' '));

				if (pos >= tam) break;
			}
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
		}
	}

	/******************
	Obtm Estados civis
	*******************/
	void obtEstadoCiv( String pStr )
	{
		int pos, tam, qtd;
		String cod, descr;
		String estciv;

		try
		{
			estciv = " = |" + param.xml_get( pStr,"ECIVIL" );
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
			return;
		}


		if( estciv.length() <= 0 )
			return;

		try
		{
			tam=estciv.length();

			/**************************
			Obtem qtd. de Estados civis
			***************************/
			for(pos=0, qtd=0;; qtd++)
			{
				cod = param.getSubstring("=",estciv, pos);
				pos=pos+cod.length()+1;
				descr = param.getSubstring("|",estciv, pos);
				pos=pos+descr.length()+1;
				if (pos >= tam) break;
			}

			/**********
			Cria arrays
			***********/
			codEstadoCiv = new String[qtd+1];
			lstEstadoCiv = new List();

			/**********
			Monta Lista
			***********/
			for(pos=0, qtd=0;; qtd++)
			{
				cod = param.getSubstring("=",estciv, pos);
				pos=pos+cod.length()+1;
				descr = param.getSubstring("|",estciv, pos);
				pos=pos+descr.length()+1;
				codEstadoCiv[qtd] = cod;

				descr = descr.trim();
				if( descr.length() > mtamanho )
					descr = descr.substring( 0,mtamanho ) + "...";

				lstEstadoCiv.add(descr.replace('_',' '));

				if (pos >= tam) break;
			}
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
		}
	}

	/*****************
	Obtm escolaridade
	******************/
	void obtEscolaridade( String pStr )
	{
		int pos, tam, qtd;
		String cod, descr;
		String escola;

		try
		{
			escola = " = |" + param.xml_get( pStr,"ESCOLA" );
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
			return;
		}

		if( escola.length() <= 0 )
			return;

		try
		{
			tam=escola.length();

			/**************************
			Obtem qtd. de escolaridades
			***************************/
			for(pos=0, qtd=0;; qtd++)
			{
				cod = param.getSubstring("=",escola, pos);
				pos=pos+cod.length()+1;
				descr = param.getSubstring("|",escola, pos);
				pos=pos+descr.length()+1;
				if (pos >= tam) break;
			}

			/**********
			Cria arrays
			***********/
			codEscola = new String[qtd+1];
			lstEscola = new List();

			/**********
			Monta Lista
			***********/
			for(pos=0, qtd=0;; qtd++)
			{
				cod = param.getSubstring("=",escola, pos);
				pos=pos+cod.length()+1;
				descr = param.getSubstring("|",escola, pos);
				pos=pos+descr.length()+1;
				codEscola[qtd] = cod;

				descr = descr.trim();
				if( descr.length() > mtamanho )
					descr = descr.substring( 0,mtamanho ) + "...";

				lstEscola.add(descr.replace('_',' '));

				if (pos >= tam) break;
			}
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
		}
	}

	/***********
	Obtm Bancos
	************/
	void obtBanco( String pStr )
	{
		int pos, tam, qtd;
		String cod, descr;
		String banco;

		try
		{
			banco = " = |" + param.xml_get( pStr,"BANCO" );
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
			return;
		}

		if( banco.length() <= 0 )
			return;

		try
		{
			tam=banco.length();

			/*******************
			Obtem qtd. de Bancos
			********************/
			for(pos=0, qtd=0;; qtd++)
			{
				cod = param.getSubstring("=",banco, pos);
				pos=pos+cod.length()+1;
				descr = param.getSubstring("|",banco, pos);
				pos=pos+descr.length()+1;
				if (pos >= tam) break;
			}

			/**********
			Cria arrays
			***********/
			codBanco = new String[qtd+1];
			lstBanco = new List();

			/**********
			Monta Lista
			***********/
			for(pos=0, qtd=0;; qtd++)
			{
				cod = param.getSubstring("=",banco, pos);
				pos=pos+cod.length()+1;
				descr = param.getSubstring("|",banco, pos);
				pos=pos+descr.length()+1;
				codBanco[qtd] = cod;

				descr = descr.trim();
				if( descr.length() > mtamanho )
					descr = descr.substring( 0,mtamanho ) + "...";

				lstBanco.add(descr.replace('_',' '));

				if (pos >= tam) break;
			}
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
		}
	}

	/***********
	Obtm Histricos
	************/
	void obtHistorico( String pStr )
	{
		int pos, tam, qtd;
		String cod, descr;
		String hist;

		try
		{
			hist= param.xml_get( pStr,"HIST" );
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
			return;
		}


		if( hist.length() <= 0 )
			return;

		try
		{
			tam=hist.length();

			/***********************
			Obtem qtd. de Histricos
			************************/
			for(pos=0, qtd=0;; qtd++)
			{
				cod = param.getSubstring("=",hist, pos);
				pos=pos+cod.length()+1;
				descr = param.getSubstring("|",hist, pos);
				pos=pos+descr.length()+1;
				if (pos >= tam) break;
			}

			/**********
			Cria arrays
			***********/
			codHistorico = new String[qtd+1];
			lstHistorico = new List();

			/**********
			Monta Lista
			***********/
			for(pos=0, qtd=0;; qtd++)
			{
				cod = param.getSubstring("=",hist, pos);
				pos=pos+cod.length()+1;
				descr = param.getSubstring("|",hist, pos);
				pos=pos+descr.length()+1;
				codHistorico[qtd] = cod;

				descr = descr.trim();
				if( descr.length() > mtamanho )
					descr = descr.substring( 0,mtamanho ) + "...";

				lstHistorico.add(descr.replace('_',' '));

				if (pos >= tam) break;
			}
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
		}
	}

	/***********
	Obtm Tipo Documento
	************/
	void obtTipoDocumento( String pStr )
	{
		int tam, qtd1,qtd2;

		qtd1=0;
		qtd2=0;

		String cod, descr,codaux;
		String hist;

		try
		{
			hist = param.xml_get( pStr,"DOC" );
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
			return;
		}

		try
		{
			tam=hist.length();

			/***********************
			Obtem qtd. de Documentos
			************************/
			for(int wpos=0;;)
			{
				codaux = param.getSubstring("=",hist, wpos);
				wpos=wpos+codaux.length()+1;
				cod = param.getSubstring("=",hist, wpos);
				wpos=wpos+cod.length()+1;
				descr = param.getSubstring("|",hist, wpos);
				wpos=wpos+descr.length()+1;

				if( codaux.equals( "E" ) )
					qtd1++;
				else
					qtd2++;

				if ( wpos >= tam )
					break;
			}

			/**********
			Cria arrays
			***********/
			codDoc1 = new String[qtd1 + 1];
			lstDoc1 = new List();
			codDoc2 = new String[qtd2 + 1];
			lstDoc2 = new List();

			/**********
			Monta Lista
			***********/
			qtd1=0;
			qtd2=0;

			//Carregando Pessoa Fisica
			for(int wpos=0;;)
			{
				codaux = param.getSubstring("=",hist, wpos);
				wpos=wpos+codaux.length()+1;
				cod = param.getSubstring("=",hist, wpos);
				wpos=wpos+cod.length()+1;
				descr = param.getSubstring("|",hist, wpos);
				wpos=wpos+descr.length()+1;

				descr = descr.trim();
				if( descr.length() > mtamanho )
					descr = descr.substring( 0,mtamanho ) + "...";

				if( codaux.equals( "E" )  )
				{
					codDoc1[qtd1] = cod;
					lstDoc1.add( cod + "-" + descr.replace('_',' '));
					qtd1++;
				}
				else
				{
					codDoc2[qtd2] = cod;
					lstDoc2.add( cod + "-" + descr.replace('_',' '));
					qtd2++;
				}

				if (wpos >= tam) break;
			}
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
		}
	}

	/**************************************
	Obter a restricao de acesso para o cadastramento
	Se RCLI="S" nao alterar dados do cliente
	Se RCOM="S" nao visualizar dados complementares
	Se RFIS="S" nao alterar dados fiscais
	***************************************/
	void obtRestricao( String pStr )
	{
		try
		{
			mRCli = param.xml_get( pStr,"RCLI" );
			mRFis = param.xml_get( pStr,"RFIS" );
			mRCom = param.xml_get( pStr,"RCOM" );

			if( mRCli.length() <=0 || mRFis.length() <=0 || mRCom.length() <=0 ||
			  ( !mRCli.equals( "S" ) && !mRCli.equals( "N" ) ) ||
			  ( !mRFis.equals( "S" ) && !mRFis.equals( "N" ) ) ||
			  ( !mRCom.equals( "S" ) && !mRCom.equals( "N" ) ) )
			{
				JOptionPane.showMessageDialog( this,
				"ERRO NA PARAMETRIZACAO DAS RESTRICOES DE ACESSO","Ateno",
				JOptionPane.ERROR_MESSAGE );

				mRCli = "S";
				mRFis = "S";
				mRCom = "S";
				btGravar.setEnabled( false );
			}
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
			return;
		}
	}

	void trataRestricao( String pCli_Novo )
	{
		dados.setEnabled( true );
		fiscal.setEnabled( true );
		compl.setVisible( true );

		if( pCli_Novo.equals( "S" ) )
			return;

		if( mRCli.equals( "S" ) )
		{
			dados.setEnabled( false );
		}

		if( mRCom.equals( "S" ) )
		{
			JOptionPane.showMessageDialog( this,
			 "CONSULTA DE DADOS COMPLEMENTARES SOMENTE ATRAVES DO CALL CENTER PELO APLICATIVO SIEBEL",
			 "Ateno",JOptionPane.INFORMATION_MESSAGE );
			compl.setVisible( false );
		}

		if( mRFis.equals( "S" ) )
		{
			fiscal.setEnabled( false );
		}
	}


	/**************************************
	Tratamento do evento do clique no boto
	***************************************/
	public void actionPerformed (ActionEvent e )
	{
		if ( e.getSource() == btConsultar )
		{
			try
			{

				if( txtCelular.getText().length() == 0 )
				{
					JOptionPane.showMessageDialog( this,"Celular no pode ser nulo.","Ateno",
					        JOptionPane.WARNING_MESSAGE );
					txtCelular.requestFocus();
					return;
				}

				if( txtCelular.getText().length() != 10 )
				{
					JOptionPane.showMessageDialog( this,"Celular invlido.","Ateno",
					        JOptionPane.WARNING_MESSAGE );
					txtCelular.requestFocus();
					return;
				}

				if( txtCD.getText().length() == 0 )
				{
					JOptionPane.showMessageDialog( this,"CD no pode ser nulo.","Ateno",
					        JOptionPane.WARNING_MESSAGE );
					txtCD.requestFocus();
					return;
				}

				if( clsCalculaCDCelular.isCD( txtCelular.getText(),txtCD.getText() ) == false )
				{
					JOptionPane.showMessageDialog( this,"Cdigo de Segurana ( CD ) invlido.","Ateno",
					        JOptionPane.WARNING_MESSAGE );
					setCD("");
					txtCD.requestFocus();
					return;
				}
				clsStatus.setMensag( "Pesquisando..." );
				repaint();
				consultaCelular( txtCelular.getText() );
				clsStatus.setMensag( " " );
			}
			catch(Exception ex){}
		}
		else if ( e.getSource() == btNovo )
		{
			setCelular( "" );
			setCD( "" );
			dados.reset();
			fiscal.reset();
			compl.reset();
			//trataRestricao( "S" );
			repaint();
		}
		else if ( e.getSource() == btGravar )
		{
			if( CheckStringGrava() == true )
			{
				clsStatus.setMensag( "Enviando informao. Aguarde..." );
				repaint();
				enviaInformacao();
				clsStatus.setMensag( " " );
			}
		}
		else
		{
			//Cancelar
		}
	}

	/************************************************
	Consulta celular e carrega as informaes na tela
	*************************************************/
	private void consultaCelular(String celular)
	{
		String result;
		//String contexto = "?transacao=1&celular=" + celular + "&" + param.getCtrl();;
		String contexto = "?param=<TRANSACAO>1</TRANSACAO><CELULAR>" + celular.toString() + "</CELULAR>"
					+ param.getCtrl();
		final int etx=0x03;

		try
		{
			URL urlClienteInformacao = new URL(param.get_Middleware()+contexto);
			URLConnection connection = urlClienteInformacao.openConnection();
			DataInputStream in = new DataInputStream(connection.getInputStream());
			StringBuffer arq = new StringBuffer();
			try
			{
				while(true)
				{
					result = in.readLine();
					if(result.length() == 0) break;

					arq.append(result);
					if(result.indexOf(etx) > 0) break;
				}
			}
			catch (Exception ex) {};
			in.close();

			String status = param.xml_get(arq.toString(),"ERR_MENS");
			int erro = Integer.parseInt(param.xml_get(arq.toString(),"ERR"));
			if(status != null)
			{
				if ( status.equals("OK") )
				{
					mostraInformacao(arq.toString());
					//trataRestricao( "N" );
				}
				else
				{
					//trataRestricao( "S" );
					dados.reset();
					fiscal.reset();
					compl.reset();
					repaint();
					JOptionPane.showMessageDialog(this, status, "Aviso", JOptionPane.WARNING_MESSAGE);
					txtCelular.requestFocus();
				}
			}
			else
			{
				JOptionPane.showMessageDialog(this, "Sem resposta", "Erro", JOptionPane.ERROR_MESSAGE);
			}
		}
		catch(MalformedURLException mue)
		{
			System.out.println("Illegal URL: " + mue);
		}
		catch(IOException ioe)
		{
			System.out.println("IOException: " + ioe);
		}
		catch(Exception e)
		{
			System.out.println("Error: " + e);
		}
	}

	/*******************************
	Mostra as informaes nos campos
	********************************/
	private void mostraInformacao( String buffer )
	{
		dados.setNome(param.xml_get(buffer,"NOM"));
		dados.setLogradouro(param.xml_get(buffer,"LOGR"));
		dados.setCompl1(param.xml_get(buffer,"END"));
		dados.setCompl2(param.xml_get(buffer,"CMPL"));
		dados.setNum(param.xml_get(buffer,"NUM"));
		dados.setBairro(param.xml_get(buffer,"BRO"));
		dados.setCidade(param.xml_get(buffer,"CID"));
		dados.setUF(param.xml_get(buffer,"UF"));
		dados.setCEP(param.xml_get(buffer,"CEP"));

		/***** Pessoa de ser setadas antes do tipo de doc *****/
		dados.setPessoa( param.xml_get(buffer,"TIPO_PESSOA") );
		dados.setTipoDoc1( param.xml_get(buffer,"DOCTIPO1") );
		dados.setTipoDoc2( param.xml_get(buffer,"DOCTIPO2") );
		dados.setDoc1( param.xml_get(buffer,"DOCNUM1") );
		dados.setDoc2( param.xml_get(buffer,"DOCNUM2") );
		dados.setContato(param.xml_get(buffer,"NMCONT"));
		dados.setTelef(param.xml_get(buffer,"PHCONT"));
		dados.setEmissao(param.xml_get(buffer,"DTEXP"));
		dados.setOrgaoExp(param.xml_get(buffer,"OE"));
		dados.setEstado(param.xml_get(buffer,"ESTEXP"));
		dados.setEmail(param.xml_get(buffer,"EMAIL"));
		dados.setSexo(param.xml_get(buffer,"SEX"));
		setCelular(param.xml_get(buffer,"CELULAR"));
		dados.setAtivacao(param.xml_get(buffer,"DTATV"));
		dados.setHistorico(param.xml_get(buffer,"HIST"));

		fiscal.setLocal(param.xml_get(buffer,"ESTAB_NM"));
		fiscal.setNotaFisc(param.xml_get(buffer,"ESTAB_NF"));
		fiscal.setCNPJ(param.xml_get(buffer,"ESTAB_CNPJ"));
		fiscal.setInscEst(param.xml_get(buffer,"ESTAB_IE"));

		compl.setProfissao(param.xml_get(buffer,"PROF"));
		compl.setEstadoCiv(param.xml_get(buffer,"ECIVIL"));
		compl.setEscola(param.xml_get(buffer,"ESCOLA"));
		compl.setDepend(param.xml_get(buffer,"NDEP"));
		compl.setDataNasc(param.xml_get(buffer,"DTNSC"));
		compl.setBanco(param.xml_get(buffer,"BANCO"));
		compl.setTelefone(param.xml_get(buffer,"TELEF"));
		compl.setFax(param.xml_get(buffer,"FAX"));
		compl.setConfidencial(param.xml_get(buffer,"CONFID"));

		repaint();
	}

	/*******************************
	Envia as informaes dos campos
	********************************/
	private void enviaInformacao()
	{
		String result;
		final int etx=0x03;

		try
		{
			URL urlClienteInformacao = new URL(param.get_Middleware() + montaContexto());

			URLConnection connection = urlClienteInformacao.openConnection();
			DataInputStream in = new DataInputStream(connection.getInputStream());
			StringBuffer arq = new StringBuffer();
			try
			{
				while(true)
				{
					result = in.readLine();
					if(result.length() == 0) break;

					arq.append(result);
					if(result.indexOf(etx) > 0) break;
				}
			}
			catch (Exception ex) {};
			in.close();
			String status = param.xml_get(arq.toString(),"ERR_MENS");
			int erro = Integer.parseInt(param.xml_get(arq.toString(),"ERR"));
			if(status != null)
			{
				if ( status.equals("OK") )
				{
					JOptionPane.showMessageDialog(this, "Cliente cadastrado com sucesso !", "Sucesso!",
										JOptionPane.INFORMATION_MESSAGE);

					//trataRestricao( "S" );
					setCelular( "" );
					setCD( "" );
					dados.reset();
					fiscal.reset();
					compl.reset();
					repaint();
				}
				else
				{
					JOptionPane.showMessageDialog(this, status, "Aviso", JOptionPane.ERROR_MESSAGE);
				}
			}
			else
			{
				JOptionPane.showMessageDialog(this, "Sem resposta", "Erro", JOptionPane.ERROR_MESSAGE);
			}
		}
		catch(MalformedURLException mue)
		{
			System.out.println("Illegal URL: " + mue);
		}
		catch(IOException ioe)
		{
			System.out.println("IOException: " + ioe);
		}
		catch(Exception e)
		{
			System.out.println("Error: " + e);
		}
	}

	private String montaContexto()
	{
		String contexto;
		StringBuffer wbuf = new StringBuffer();

		wbuf.append( "?param=" );
		wbuf.append( param.xml_transac( 2 ) );
		wbuf.append( param.xml_str( "CELULAR",getCelular() ) );
		wbuf.append( param.xml_str( "NOM",dados.getNome() ) );
		wbuf.append( param.xml_str( "LOGR",dados.getLogradouro() ) );
		wbuf.append( param.xml_str( "END",dados.getCompl1() ) );
		wbuf.append( param.xml_str( "CMPL",dados.getCompl2() ) );
		wbuf.append( param.xml_str( "NUM",dados.getNum() ) );
		wbuf.append( param.xml_str( "BRO",dados.getBairro() ) );

		wbuf.append( param.xml_str( "CID",dados.getCidade() ) );
		wbuf.append( param.xml_str( "UF",dados.getUF() ) );
		wbuf.append( param.xml_str( "CEP",dados.getCEP() ) );
		wbuf.append( param.xml_str( "TIPO_PESSOA",dados.getPessoa() ) );

		if( dados.getDoc1().length() > 0 )
			wbuf.append( param.xml_str( "DOCTIPO1",dados.getTipoDoc1() ) );
		else
			wbuf.append( param.xml_str( "DOCTIPO1","" ) );

		if( dados.getDoc2().length() > 0 )
			wbuf.append( param.xml_str( "DOCTIPO2",dados.getTipoDoc2() ) );
		else
			wbuf.append( param.xml_str( "DOCTIPO2","" ) );

		wbuf.append( param.xml_str( "DOCNUM1",dados.getDoc1() ) );
		wbuf.append( param.xml_str( "DOCNUM2",dados.getDoc2() ) );
		wbuf.append( param.xml_str( "NMCONT",dados.getContato() ) );
		wbuf.append( param.xml_str( "PHCONT",dados.getTelef() ) );
		wbuf.append( param.xml_str( "DTEXP",dados.getEmissao() ) );
		wbuf.append( param.xml_str( "OE",dados.getOrgaoExp() ) );
		wbuf.append( param.xml_str( "ESTEXP",dados.getEstado() ) );
		wbuf.append( param.xml_str( "EMAIL",dados.getEmail() ) );
		wbuf.append( param.xml_str( "SEX",dados.getSexo() ) );
		wbuf.append( param.xml_str( "DTATV",dados.getAtivacao() ) );
		wbuf.append( param.xml_str( "HIST",dados.getHistorico() ) );
		wbuf.append( param.xml_str( "ESTAB_NM",fiscal.getLocal() ) );
		wbuf.append( param.xml_str( "ESTAB_NF",fiscal.getNotaFisc() ) );
		wbuf.append( param.xml_str( "ESTAB_CNPJ",fiscal.getCNPJ() ) );
		wbuf.append( param.xml_str( "ESTAB_IE",fiscal.getInscEst() ) );
		wbuf.append( param.xml_str( "PROF",compl.getProfissao() ) );
		wbuf.append( param.xml_str( "ECIVIL",compl.getEstadoCiv() ) );
		wbuf.append( param.xml_str( "ESCOLA",compl.getEscola() ) );
		wbuf.append( param.xml_str( "NDEP",compl.getDepend() ) );
		wbuf.append( param.xml_str( "DTNSC",compl.getDataNasc() ) );

		wbuf.append( param.xml_str( "BANCO",compl.getBanco()) );
		wbuf.append( param.xml_str( "FAX",compl.getFax() ) );
		wbuf.append( param.xml_str( "TELEF",compl.getTelefone() ) );
		wbuf.append( param.xml_str( "CONFID",compl.getConfidencial() ) );

		contexto=wbuf.toString().replace( '\n','+' );
		contexto=contexto.replace( ' ','+' );
		return contexto;
	}

	public boolean CheckStringGrava()
	{
		String waux;

		waux = dados.getNome();
		if( clsCheckString.isNull( waux ) == false )
		{
			getMessageCheck( "Nome obrigatrio" );
			return false;
		}
		if( clsCheckString.isCharacEspec( waux ) == false )
		{
			getMessageCheck( "Nome no pode possuir caracteres especiais somente caracteres de A-Z/a-z/0-9" );
			return false;
		}

		waux = dados.getCompl1();
		if( clsCheckString.isNull( waux ) == false )
		{
			getMessageCheck( "Endereo obrigatrio" );
			return false;
		}

		waux = dados.getNum();
		if( clsCheckString.isNull( waux ) == false )
		{
			getMessageCheck( "Numero obrigatrio" );
			return false;
		}
		if( clsCheckString.isCharacEspec( waux ) == false )
		{
			getMessageCheck( "Numero no pode possuir caracteres especiais somente caracteres de A-Z/a-z/0-9" );
			return false;
		}

		waux = dados.getBairro();
		if( clsCheckString.isNull( waux ) == false )
		{
			getMessageCheck( "Bairro obrigatrio" );
			return false;
		}
		if( clsCheckString.isCharacEspec( waux ) == false )
		{
			getMessageCheck( "Bairro no pode possuir caracteres especiais somente caracteres de A-Z/a-z/0-9" );
			return false;
		}

		waux = dados.getCidade();
		if( clsCheckString.isNull( waux ) == false )
		{
			getMessageCheck( "Cidade obrigatrio" );
			return false;
		}

		waux = dados.getCEP();
		if( clsCheckString.isNull( waux ) == false )
		{
			getMessageCheck( "CEP obrigatrio" );
			return false;
		}
		if( clsCheckString.isNumeric( waux ) == false )
		{
			getMessageCheck( "CEP deve conter apenas numeros" );
			return false;
		}

		waux = dados.getDoc1() + dados.getDoc2();
		if( clsCheckString.isNull( waux ) == false )
		{
			getMessageCheck( "Documento obrigatrio" );
			return false;
		}
		if( clsCheckString.isCharacEspec( waux ) == false )
		{
			getMessageCheck( "Documentos no pode possuir caracteres especiais \n somente caracteres de A-Z/a-z/0-9" );
			return false;
		}
		if( dados.getPessoa().equals( "F" ) )
		{
			if( dados.getTipoDoc2().equals( "CPF" ) )
			{
				waux = dados.getDoc2();
				if( clsCheckString.isNull( waux ) == true )
				{
					try
					{
						if( clsCPF.isCPF( waux ) == false )
						{
							getMessageCheck( "O CPF no  um nmero valido" );
							return false;
						}
					}
					catch( Exception exp )
					{
						getMessageCheck( exp.getMessage() );
						return false;
					}
				}
			}

			waux = dados.getDoc1();
			if( dados.getTipoDoc1().equals( "RG" ) && clsCheckString.isNull( waux ) == true )
			{
				waux = dados.getFormatEmissao();
				if( clsCheckString.isNull( waux ) == false )
				{
					getMessageCheck( "Emisso obrigatrio" );
					return false;
				}
				try
				{
					if( clsCalendario.isDate( waux, "dd-mm-yyyy" ) == false )
					{
						getMessageCheck( "Data invlida" );
						return false;
					}
				}
				catch( Exception exp )
				{
					getMessageCheck( "Data invlida" );
					return false;
				}


				waux = dados.getOrgaoExp();
				if( clsCheckString.isNull( waux ) == false )
				{
					getMessageCheck( "Orgo Exp. obrigatrio" );
					return false;
				}
			}
			else
			{
				dados.setOrgaoExp( "" );
				dados.setEmissao( "" );
				dados.setEstado( "" );
			}
		}
		else
		{
			waux = dados.getDoc2();
			if( clsCheckString.isNull( waux ) == false )
			{
				getMessageCheck( "CNPJ obrigatrio" );
				return false;
			}
			try
			{
				if( clsCNPJ.isCNPJ( waux ) == false )
				{
					getMessageCheck( "O CNPJ no  um nmero valido" );
					return false;
				}
			}
			catch( Exception exp )
			{
				getMessageCheck( exp.getMessage() );
				return false;
			}
		}

		waux = getCelular();
		if( clsCheckString.isNull( waux ) == false )
		{
			getMessageCheck( "Celular obrigatrio" );
			return false;
		}
		if( clsCheckString.isNumeric( waux ) == false )
		{
			getMessageCheck( "Celular deve conter apenas numeros" );
			return false;
		}

		waux = getCD();
		if( clsCheckString.isNull( waux ) == false )
		{
			getMessageCheck( "CD obrigatrio" );
			return false;
		}
		if( clsCheckString.isNumeric( waux ) == false )
		{
			getMessageCheck( "CD deve conter apenas numeros" );
			return false;
		}

		try
		{
			if( !txtCD.getText().equals( clsCalculaCDCelular.getCD( txtCelular.getText() ) ) )
			{
				JOptionPane.showMessageDialog( this,"Cdigo de Segurana ( CD ) invlido.","Ateno",
						JOptionPane.WARNING_MESSAGE );
				txtCD.selectAll();
				txtCD.requestFocus();
				return false;
			}
		}
		catch( Exception exp ){}

		waux = dados.getEmail();
		if( clsCheckString.isNull( waux ) == true )
		{
			if( clsCheckString.checkDigit( waux,"@" ) == false )
			{
				getMessageCheck( "E-mail invlido" );
				return false;
			}
			if( clsCheckString.checkDigit( waux,"." ) == false )
			{
				getMessageCheck( "E-mail invlido" );
				return false;
			}
		}

		waux = fiscal.getCNPJ();
		if( clsCheckString.isNull( waux ) == true )
		{
			try
			{
				if( clsCNPJ.isCNPJ( waux ) == false )
				{
					getMessageCheck( "O CNPJ no  um nmero valido" );
					return false;
				}
			}
			catch( Exception exp )
			{
				getMessageCheck( exp.getMessage() );
				return false;
			}
		}

		waux = fiscal.getInscEst();
		if( clsCheckString.isNull( waux ) == true )
		{
			if( clsCheckString.isNumeric( waux ) == false )
			{
				getMessageCheck( "Inscrio Estadual deve conter apenas numeros" );
				return false;
			}
		}

		waux = compl.getFormatDataNasc();
		if( clsCheckString.isNull( waux ) == true )
		{
			try
			{
				if( clsCalendario.isDate( waux, "dd-mm-yyyy" ) == false )
				{
					getMessageCheck( "Data invlida" );
					return false;
				}
			}
			catch( Exception exp ){}
		}

		waux = compl.getDepend();
		if( clsCheckString.isNull( waux ) == true )
		{
			if( clsCheckString.isNumeric( waux ) == false )
			{
				getMessageCheck( "Dependentes deve conter apenas numeros" );
				return false;
			}
		}

		waux = compl.getTelefone();

		if( clsCheckString.isNull( waux ) == true )
		{
			if( clsCheckString.isNumeric( waux ) == false )
			{
				getMessageCheck( "Telefone deve conter apenas numeros" );
				return false;
			}
		}

		waux = compl.getFax();

		if( clsCheckString.isNull( waux ) == true )
		{
			if( clsCheckString.isNumeric( waux ) == false )
			{
				getMessageCheck( "Fax deve conter apenas numeros" );
				return false;
			}
		}

		return true;
	}

	public void setMensag( String pMensag )
	{
		clsStatus.setMensag( pMensag );
	}

	private void getMessageCheck( String pStr )
	{
		JOptionPane.showMessageDialog( this,pStr,"Ateno",JOptionPane.WARNING_MESSAGE );
	}

	/*********************************
	 - Set padrao Windows
	*********************************/
	private void changeLookAndFeel( )
	{
		try
		{
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
			SwingUtilities.updateComponentTreeUI(this);

		}
		catch( Exception e ){}
	}
}
