import java.awt.*;
import java.net.*;
import java.awt.event.*;
import java.applet.Applet;
import java.applet.AppletContext;
import javax.swing.*;
import java.io.PrintStream;
import java.io.DataInputStream;
import java.io.IOException;

/**
* Tratamento do numero especial que recebera chamadas com desconto
* @author Ivan Nagy
* @since 2002-11-05
**/
public class CartaoEspecial extends Applet
{
	final static Parametro param = new Parametro();
	private static final CalculaCDCelular clsCalculaCDCelular = new CalculaCDCelular();
	private static final CheckString clsCheckString = new CheckString();

	private JButton bttEnvia, bttCancela;
	private TextField txtCelular,txtCD,txtCartaoEspecial;

	private ButtonGroup grpTipoCelular;
	private JRadioButton rdbPos,rdbPre;

	private Status clsStatus;
	private String mTipoCelular="Pre";

	public void init()
	{
		Titulo clsTitulo = new Titulo("Celular Especial",20,20);
		clsStatus = new Status( " ",20,20 );

		JPanel pnlCampo = new JPanel(new BorderLayout( 1,1 ) );
		pnlCampo.setBackground(param.get_BackColor());
		pnlCampo.setForeground(param.get_ForeColor());
		pnlCampo.setBorder( BorderFactory.createEtchedBorder() );

		JPanel pnlJButton = new JPanel(new BorderLayout( 1,1 ) );
		pnlJButton.setBackground(param.get_BackColor());
		pnlJButton.setForeground(param.get_ForeColor());
		pnlJButton.setBorder( BorderFactory.createEtchedBorder() );

		bttEnvia = new JButton( "  Envia  " );
		bttEnvia.setForeground(Color.black);
		bttEnvia.setFont(param.get_Fonte());
		bttEnvia.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					if( checkEnvio() == true )
					{
						clsStatus.setMensag( "Enviando informao. Aguarde..." );
						getURL();
						clsStatus.setMensag( "" );
					}
				}
			});

		bttCancela = new JButton( "Cancela" );
		bttCancela.setForeground(Color.black);
		bttCancela.setFont(param.get_Fonte());
		bttCancela.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					txtCelular.setText( "" );
					txtCD.setText( "" );
					txtCartaoEspecial.setText( "" );
					rdbPre.setSelected( true );
				}
			});

		txtCelular = new TextField();
		txtCelular.setName("txtCelular");
		txtCelular.setBackground(Color.white);
		txtCelular.setForeground(Color.black);
		txtCelular.setFont(param.get_Fonte());

		txtCD = new TextField();
		txtCD.setName("txtCD");
		txtCD.setBackground(Color.white);
		txtCD.setForeground(Color.black);
		txtCD.setFont(param.get_Fonte());

		txtCartaoEspecial = new TextField();
		txtCartaoEspecial.setName("txtCartaoEspecial");
		txtCartaoEspecial.setBackground(Color.white);
		txtCartaoEspecial.setForeground(Color.black);
		txtCartaoEspecial.setFont(param.get_Fonte());

		//Tratamento do Radio Button
		ClickRadioButton clickradiobutton = new ClickRadioButton();

		rdbPre = new JRadioButton("Pre-Pago", true);
		rdbPre.addItemListener( clickradiobutton );
		rdbPre.setActionCommand( "Pre" );
		rdbPre.setBackground( param.get_BackColor() );
		rdbPre.setForeground( param.get_ForeColor() );
		rdbPre.setFont( param.get_Fonte() );

		rdbPos = new JRadioButton("Pos-Pago", true);
		rdbPos.addItemListener( clickradiobutton );
		rdbPos.setActionCommand( "Pos" );
		rdbPos.setBackground( param.get_BackColor() );
		rdbPos.setForeground( param.get_ForeColor() );
		rdbPos.setFont( param.get_Fonte() );

		grpTipoCelular = new ButtonGroup();
		grpTipoCelular.add( rdbPre );
		grpTipoCelular.add( rdbPos );

		GridBagConstraints gbcConstraints = new GridBagConstraints();
		GridBagLayout gblCampo = new GridBagLayout();
		GridBagLayout gblJButton = new GridBagLayout();

		AddGridComponente grdAddCampo = new AddGridComponente(gblCampo,gbcConstraints,4,10);
		pnlCampo.add( clsTitulo,"North" );
		pnlCampo.add( grdAddCampo,"Center" );

		AddGridComponente grdAddJButton = new AddGridComponente(gblJButton,gbcConstraints,2,2);
		pnlJButton.add( clsStatus,"South" );
		pnlJButton.add( grdAddJButton,"Center" );

		grdAddCampo.addComponente(new Label( "Celular:" ),gblCampo,gbcConstraints,1,1,1,1);
		grdAddCampo.addComponente(txtCelular,gblCampo,gbcConstraints,1,2,1,5);
		grdAddCampo.addComponente(new Label( "CD:" ),gblCampo,gbcConstraints,1,8,1,1);
		grdAddCampo.addComponente(txtCD,gblCampo,gbcConstraints,1,9,1,1);
		grdAddCampo.addComponente(new Label( "Celular Especial:" ),gblCampo,gbcConstraints,3,1,1,1);
		grdAddCampo.addComponente(txtCartaoEspecial,gblCampo,gbcConstraints,3,2,1,5);

		grdAddCampo.addComponente(rdbPre,gblCampo,gbcConstraints,2,8,1,4);
		grdAddCampo.addComponente(rdbPos,gblCampo,gbcConstraints,3,8,1,4);

		grdAddJButton.addComponente(bttEnvia,gblJButton,gbcConstraints,1,1,1,1);
		grdAddJButton.addComponente(bttCancela,gblJButton,gbcConstraints,1,2,1,1);

		setLayout( new BorderLayout( 1,1 ) );
		add( pnlCampo,"Center" );
		add( pnlJButton,"South" );

		changeLookAndFeel( );

		rdbPre.setSelected( true );
		txtCelular.requestFocus();
	}

	private boolean checkEnvio()
	{
		String waux;

		if( txtCelular.getText().equals( txtCartaoEspecial.getText() ) )
		{
			JOptionPane.showMessageDialog( null,"Numero do celular igual ao numero do " +
				"celular especial.","Ateno",JOptionPane.WARNING_MESSAGE );
			return false;
		}

		waux = txtCelular.getText();
		if( clsCheckString.isNull( waux ) == false )
		{
			JOptionPane.showMessageDialog( null,"Celular obrigatrio",
					"Ateno",JOptionPane.WARNING_MESSAGE );
			return false;
		}
		if( clsCheckString.isNumeric( waux ) == false )
		{
			JOptionPane.showMessageDialog( null,"Celular deve conter apenas numeros",
					"Ateno",JOptionPane.WARNING_MESSAGE );
			return false;
		}

		if( txtCelular.getText().length() != 10 )
		{
			JOptionPane.showMessageDialog( null,"Celular invlido.","Ateno",
					JOptionPane.WARNING_MESSAGE );
			txtCelular.requestFocus();
			return false;
		}
		if( rdbPre.isSelected() == true )
		{
			waux = txtCD.getText();
			if( clsCheckString.isNull( waux ) == false )
			{
				JOptionPane.showMessageDialog( null,"CD obrigatrio",
						"Ateno",JOptionPane.WARNING_MESSAGE );
				return false;
			}
			if( clsCheckString.isNumeric( waux ) == false )
			{
				JOptionPane.showMessageDialog( null,"CD deve conter apenas numeros",
						"Ateno",JOptionPane.WARNING_MESSAGE );
				return false;
			}
			try
			{
				if( clsCalculaCDCelular.isCD( txtCelular.getText(),txtCD.getText() ) == false )
				{
					JOptionPane.showMessageDialog( null,"Cdigo de Segurana ( CD ) invlido.","Ateno",
							JOptionPane.WARNING_MESSAGE );
					return false;
				}
			}
			catch( Exception exp ){}
		}

		waux = txtCartaoEspecial.getText();
		if( clsCheckString.isNull( waux ) == false )
		{
			JOptionPane.showMessageDialog( null,"Celular especial obrigatrio",
					"Ateno",JOptionPane.WARNING_MESSAGE );
			return false;
		}
		if( clsCheckString.isNumeric( waux ) == false )
		{
			JOptionPane.showMessageDialog( null,"Celular especial deve conter apenas numeros",
					"Ateno",JOptionPane.WARNING_MESSAGE );
			return false;
		}
		if( txtCartaoEspecial.getText().length() != 10 )
		{
			JOptionPane.showMessageDialog( null,"Celular especial invlido.","Ateno",
					JOptionPane.WARNING_MESSAGE );
			txtCartaoEspecial.requestFocus();
			return false;
		}

		return true;
	}

	/************************************************
	Envia informao para incluso
	*************************************************/
	private void getURL()
	{
		String result;
		String contexto = "?param=" + param.xml_transac( 104 ) +
						  param.xml_str( "ORIGEM", mTipoCelular.toUpperCase() ) +
						  param.xml_str( "ACAO", "ADD" ) +
						  param.xml_str( "CELULAR", txtCelular.getText() ) +
						  param.xml_str( "CARTAO_ESPECIAL", txtCartaoEspecial.getText() ) +
						  param.getCtrl();

		contexto = contexto.replace( ' ','+' );
		contexto = contexto.replace( '\n','+' );

		final int etx=0x03;

		try
		{
			URL urlDados = new URL(param.get_Middleware()+contexto);

			URLConnection connection = urlDados.openConnection();
			DataInputStream in = new DataInputStream(connection.getInputStream());
			StringBuffer arq = new StringBuffer();
			try
			{
				while(true)
				{
					result = in.readLine();
					if(result.length() == 0) break;

					arq.append(result);
					if(result.indexOf(etx) > 0) break;
				}
			}
			catch (Exception ex) {};
			in.close();

			String status = param.xml_get(arq.toString(),"ERR_MENS");
			int erro = Integer.parseInt(param.xml_get(arq.toString(),"ERR"));
			if(status != null)
			{
				if ( erro == 0 )
				{
					JOptionPane.showMessageDialog(null, "Celular Especial cadastrado com sucesso", "Aviso",
							JOptionPane.INFORMATION_MESSAGE);
					txtCelular.setText( "" );
					txtCD.setText( "" );
					txtCartaoEspecial.setText( "" );
				}
				else
				{
					JOptionPane.showMessageDialog(null, status.toString().trim(), "Aviso", JOptionPane.ERROR_MESSAGE);
				}
			}
			else
			{
				JOptionPane.showMessageDialog(null, "Sem resposta", "Erro", JOptionPane.ERROR_MESSAGE);
			}
		}
		catch(MalformedURLException mue)
		{
			System.out.println("Illegal URL: " + mue);
		}
		catch(IOException ioe)
		{
			System.out.println("IOException: " + ioe);
		}
		catch(Exception e)
		{
			System.out.println("Error: " + e);
		}
	}

	//Trata as aes do Radio Button
	public class ClickRadioButton implements ItemListener
	{
		public void itemStateChanged( ItemEvent e )
		{
			mTipoCelular = grpTipoCelular.getSelection().getActionCommand();

			if( mTipoCelular.equals( "Pre" ) )
			{
				txtCD.setEnabled( true );
			}
			else
			{
				txtCD.setText( "" );
				txtCD.setEnabled( false );
			}

		}
	}

	/*********************************
	 - Set padrao Windows
	*********************************/
	private void changeLookAndFeel( )
	{
		try
		{
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
			SwingUtilities.updateComponentTreeUI(this);

		}
		catch( Exception e ){}
	}
}
