import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ClienteComplemento extends Panel implements KeyListener, ItemListener
{
	private TextField txtDepend;
	private TextField txtDataNasc,txtTelefone,txtFax;
	private TextField txtObs;
	private Choice choProfissao, choEstadoCiv, choEscola, choBanco;
	//private Checkbox rdbCCSim,rdbCCNao;
	private String focus;
	private JCheckBox chkConfidencial;
	private List lstProfissao, lstEstadoCiv, lstEscola, lstBanco;
	private String[] codProfissao, codEstadoCiv, codEscola, codBanco;
	private Parametro param = new Parametro();

	public ClienteComplemento(	List lstProfissao, List lstEstadoCiv,
						List lstEscola, List lstBanco,
						String[] codProfissao, String[] codEstadoCiv,
						String[] codEscola, String[] codBanco)
	{
		this.lstProfissao = lstProfissao;
		this.lstEstadoCiv = lstEstadoCiv;
		this.lstEscola = lstEscola;
		this.lstBanco = lstBanco;
		this.codProfissao = codProfissao;
		this.codEstadoCiv = codEstadoCiv;
		this.codEscola = codEscola;
		this.codBanco = codBanco;
		focus=".";

		Label lblProfissao = new Label("Profisso:");
		Label lblEstadoCiv = new Label("Estado Civil:");
		Label lblEscola = new Label("Escolaridade:");
		Label lblDepend = new Label("Dependentes:");
		Label lblDataNasc = new Label("Data Nascimento:");
		Label lblBanco = new Label("Banco:");
		Label lblAux = new Label("(DD-MM-YYYY):");
		lblAux.setBackground(param.get_BackColor());
		lblAux.setForeground(param.get_ForeColor());
		lblAux.setFont(param.get_Fonte());


		choProfissao = new Choice();
		choEstadoCiv = new Choice();
		choEscola = new Choice();
		choBanco = new Choice();
		chkConfidencial = new JCheckBox( "Confidencial" );

		chkConfidencial.setBackground( param.get_BackColor() );
		chkConfidencial.setForeground( param.get_ForeColor() );
		chkConfidencial.setFont(param.get_Fonte());

		//********************************
		txtDepend = new TextField();
		txtDepend.setName("txtDepend");
		txtDepend.addKeyListener(this);
		txtDepend.setBackground(Color.white);
		txtDepend.setForeground(Color.black);
		txtDepend.setFont(param.get_Fonte());
		//********************************
		txtDataNasc = new TextField();
		txtDataNasc.setName("txtDataNasc");
		txtDataNasc.addKeyListener(this);
		txtDataNasc.setBackground(Color.white);
		txtDataNasc.setForeground(Color.black);
		txtDataNasc.setFont(param.get_Fonte());
		//********************************
		txtTelefone = new TextField();
		txtTelefone.setName("txtDataNasc");
		txtTelefone.addKeyListener(this);
		txtTelefone.setBackground(Color.white);
		txtTelefone.setForeground(Color.black);
		txtTelefone.setFont(param.get_Fonte());
		//********************************
		txtFax = new TextField();
		txtFax.setName("txtDataNasc");
		txtFax.addKeyListener(this);
		txtFax.setBackground(Color.white);
		txtFax.setForeground(Color.black);
		txtFax.setFont(param.get_Fonte());
		//********************************

		choProfissao.setBackground(param.get_ForeColor());
		choProfissao.setForeground(param.get_WriteColor());
		choProfissao.setFont(param.get_Fonte());
		choEstadoCiv.setBackground(param.get_ForeColor());
		choEstadoCiv.setForeground(param.get_WriteColor());
		choEstadoCiv.setFont(param.get_Fonte());
		choEscola.setBackground(param.get_ForeColor());
		choEscola.setForeground(param.get_WriteColor());
		choEscola.setFont(param.get_Fonte());
		choBanco.setBackground(param.get_ForeColor());
		choBanco.setForeground(param.get_WriteColor());
		choBanco.setFont(param.get_Fonte());

		// *** Adiciona valores aos Choices Profisso, Estado Civil, ***
		// ******************* Escolaridade e Banco ********************
		try
		{
			for ( int i = 0; i < lstProfissao.getItemCount(); i++ )
				choProfissao.add(lstProfissao.getItem(i));

			for ( int i = 0; i < lstEstadoCiv.getItemCount(); i++ )
				choEstadoCiv.add(lstEstadoCiv.getItem(i));

			for ( int i = 0; i < lstEscola.getItemCount(); i++ )
				choEscola.add(lstEscola.getItem(i));

			for ( int i = 0; i < lstBanco.getItemCount(); i++ )
				choBanco.add(lstBanco.getItem(i));
		}
		catch( Exception exp ){}
		// ********************************************************

		GridBagConstraints gbcConstraints = new GridBagConstraints();
		GridBagLayout gblDados = new GridBagLayout();
		AddGridComponente grdAddDados = new AddGridComponente(gblDados,gbcConstraints,6,20);

		grdAddDados.addComponente(lblProfissao,gblDados,gbcConstraints,1,1,1,1);
		grdAddDados.addComponente(lblEscola,gblDados,gbcConstraints,2,1,1,1);
		grdAddDados.addComponente(lblDepend,gblDados,gbcConstraints,3,1,1,1);
		grdAddDados.addComponente(lblDataNasc,gblDados,gbcConstraints,4,1,1,1);

		//********** Profisso e Estado Civil ***********
		grdAddDados.addComponente(choProfissao,gblDados,gbcConstraints,1,2,1,8);
		grdAddDados.addComponente(lblEstadoCiv,gblDados,gbcConstraints,1,11,1,1);
		grdAddDados.addComponente(choEstadoCiv,gblDados,gbcConstraints,1,12,1,8);

		//************ Escolaridade *************
		grdAddDados.addComponente(choEscola,gblDados,gbcConstraints,2,2,1,8);

		//************ Dependentes ************
		grdAddDados.addComponente(txtDepend,gblDados,gbcConstraints,3,2,1,5);
		grdAddDados.addComponente(new Label("pessoa(s)"),gblDados,gbcConstraints,3,7,1,4);

		//******** Data de Nascimento *********
		grdAddDados.addComponente(txtDataNasc,gblDados,gbcConstraints,4,2,1,5);
		grdAddDados.addComponente(lblAux,gblDados,gbcConstraints,4,7,1,5);

		//************** Conta Corrente *******
		grdAddDados.addComponente(lblBanco,gblDados,gbcConstraints,5,11,1,1);
		grdAddDados.addComponente(choBanco,gblDados,gbcConstraints,5,12,1,8);

		//******** Telefones *********
		grdAddDados.addComponente(new Label("Telefone:"),gblDados,gbcConstraints,2,11,1,1);
		grdAddDados.addComponente(txtTelefone,gblDados,gbcConstraints,2,12,1,5);

		//******** Fax *********
		grdAddDados.addComponente(new Label("Fax:"),gblDados,gbcConstraints,3,11,1,1);
		grdAddDados.addComponente(txtFax,gblDados,gbcConstraints,3,12,1,5);

		//******** Confidencial *********
		grdAddDados.addComponente(chkConfidencial,gblDados,gbcConstraints,4,12,1,8);


		setLayout(new GridLayout(1,1));
		add(grdAddDados);
		setBackground(param.get_BackColor());
		setForeground(param.get_ForeColor());
	}

	/*
	public void paint (Graphics g)
	{
		update(g);
	}

	public void update(Graphics g)
	{
		Dimension d = getSize();

		g.setColor(param.get_BackColor());
		g.fill3DRect(0, 0, d.width - 1, d.height - 1, true);

		g.setColor(Color.yellow);
		g.drawRoundRect(5, 5, d.width - 10, d.height - 10, 10, 10);
	}

	public Insets getInsets()
	{
		return new Insets(10,10,10,10);
	}*/

	public void keyTyped(KeyEvent e) {}
	public void keyPressed(KeyEvent e) {}
	public void keyReleased(KeyEvent e)	{}

	/*****************************************************************************
	Verifica quem originou o evento e define se o boto deve ou no ser habilitado
	******************************************************************************/
	public void itemStateChanged(ItemEvent e){}

	public void reset()
	{
		setProfissao("");
		setEstadoCiv("");
		setEscola("");
		setDepend("");
		setDataNasc("");
		//setCC("");
		setBanco("");
		setTelefone("");
		setFax("");
		setConfidencial("N");

	}

	public String getProfissao()
	{
		return codProfissao[ choProfissao.getSelectedIndex() ];
	}

	public String getEstadoCiv()
	{
		return codEstadoCiv[ choEstadoCiv.getSelectedIndex() ];
	}

	public String getEscola()
	{
		return codEscola[ choEscola.getSelectedIndex() ];
	}

	public String getDepend()
	{
		return txtDepend.getText();
	}

	public String getFormatDataNasc()
	{
		String datanasc="30-02-2002";

		if( txtDataNasc.getText().trim().length() == 10 )
		{
			datanasc = txtDataNasc.getText();
		}
		if( txtDataNasc.getText().trim().length() <= 0 )
			datanasc="";

		return datanasc;
	}

	public String getDataNasc()
	{
		String datanasc="";
		if( txtDataNasc.getText().trim().length() == 10 )
		{
			datanasc = txtDataNasc.getText().substring(6, txtDataNasc.getText().length()) +
					   txtDataNasc.getText().substring(3,5) +
					   txtDataNasc.getText().substring(0,2);
		}
		return datanasc;
	}

	public String getBanco()
	{
		return codBanco[ choBanco.getSelectedIndex() ];
	}

	public String getConfidencial()
	{
		if( chkConfidencial.isSelected() == true )
			return "S";

		return "N";
	}

	public String getTelefone()
	{
		return txtTelefone.getText();
	}

	public String getFax()
	{
		return txtFax.getText();
	}

	public void setProfissao(String prof)
	{
		int i=0;

		if( prof.length() > 0 && !prof.equals( "0" ) )
		{
			for ( i = 0;; i++)
			{
				if ( codProfissao[i].equals(prof) ) break;
			}
		}
		choProfissao.select(i);
	}

	public void setEstadoCiv(String estciv)
	{
		int i=0;
		if( estciv.length() > 0 && !estciv.equals( "0" ) )
		{
			for ( i = 0;; i++)
			{
				if ( codEstadoCiv[i].equals(estciv) ) break;
			}
		}
		choEstadoCiv.select(i);
	}

	public void setEscola(String escola)
	{
		int i=0;
		if( escola.length() > 0 && !escola.equals( "0" ) )
		{
			for ( i = 0;; i++)
			{
				if ( codEscola[i].equals(escola) ) break;
			}
		}
		choEscola.select(i);
	}

	public void setDepend(String ndep)
	{
		txtDepend.setText(ndep);
	}

	public void setDataNasc(String data)
	{
		if ( data.length() > 0 )
			data = 	data.substring(6,data.length()) + "-" +
					data.substring(4,6) + "-" +
					data.substring(0,4);
		txtDataNasc.setText(data);
	}

	public void setBanco(String banco)
	{
		int i = 0;
		if( banco.length() > 0 )
		{
			for ( i = 0;; i++)
			{
				if ( codBanco[i].equals(banco) ) break;
			}
		}
		choBanco.select(i);
	}

	public void setConfidencial( String pStr )
	{
		chkConfidencial.setSelected( true );

		if( pStr.equals( "S" ) )
			chkConfidencial.setSelected( true );
		else
			chkConfidencial.setSelected( false );
	}

	public void setTelefone( String pStr )
	{
		txtTelefone.setText( pStr );
	}

	public void setFax( String pStr )
	{
		txtFax.setText( pStr );
	}

}
