import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import java.awt.geom.*;
import java.awt.print.*;
import java.awt.print.PrinterJob;
import java.text.*;

public class HTTPGetPagina extends HttpServlet
{
	public static ParamBasic param;

	public void init(ServletConfig config) throws ServletException
	{
		try
		{
			super.init(config);
			param = new ParamBasic();
		}
		catch (ServletException e)
		{
			throw e;
		}
	}

	public void doGet (HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
	{
		doPost( request, response );
	}

	public void doPost( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException
	{
		PrintWriter output;
		String relat, resp;

		response.setContentType( "text/html" );		// content type
		response.setHeader ("Pragma", "no-cache");
		response.setHeader ("Cache-Control", "no-cache");
		output = response.getWriter();				// get writer

		// create and send HTML page to client
		StringBuffer buf = new StringBuffer();

		// Nao cria uma sessao (false) se uma nao existir
		HttpSession session = request.getSession(false);

		if(session == null)
		{
			buf.append( param.get_HTML_Interromper("Aviso", "No existe sesso habilitada"));
			output.println( "Aviso: No existe sesso habilitada" );
		}
		else
		{
			try
			{
				String waux = request.getParameter( "param" );

				int transac = Integer.parseInt( param.xml_get( waux, "TRANSACAO"  ) );
				String wCodBase = param.xml_get( waux, "CODBASE"  );
				String wClass = param.xml_get( waux, "CLASS"  );
				int wWidth = Integer.parseInt( param.xml_get( waux, "WIDTH"  ) );
				int wHeigth = Integer.parseInt( param.xml_get( waux, "HEIGTH"  ) );

				String userid = (String) session.getValue("userid");
				String username = (String) session.getValue("username");

				try
				{
					montaPagina( output, wCodBase, wClass, wWidth, wHeigth, transac,userid );
				}
				catch (Exception e)
				{
					log(e.toString());
					buf.append( param.get_HTML_Interromper("Aviso - menu()", e.getMessage()) );
					output.print(buf.toString());
				}
			}
			catch (Exception e)
			{
				log(e.toString());
				buf.append( param.get_HTML_Interromper("Aviso - getRelatorio()", e.getMessage()) );
				output.print(buf.toString());
			}
		}

		output.close();							// close PrintWriter stream
	}

	public void montaPagina( PrintWriter output, String pcodbase, String pclass, int pwidth, int pheigth,
							 int ptransac,String userid )
	{
		output.println( "<html>" );
		output.println( "<head>" );
		output.println( "<title></title></head>\n" );
		output.println( "<body marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 background=" + param.HOME_LOCAL + "images/c_fundo_azul.jpg oncontextmenu='return false'>\n" );
		output.println( "<center>" );
		output.println( "<br>");
		output.println( "<table border='2' bordercolor='rgb(0,100,155)'><tr><td>" );
		output.println( "<OBJECT classid=" + param.pluginCLASSID + " width=" + pwidth + " height=" + pheigth + " align=baseline" );
		output.println( "codebase=" + param.pluginCODEBASE + ">" );
		output.println( "<param name='code' value=" + pclass + ">" );
		output.println( "<param name='codebase' value=" + pcodbase + ">" );
		output.println( "<param name='type' value=" + param.pluginTYPE + ">" );
		output.println( "<param name='model' value=" + param.pluginMODEL + ">");
		output.println( "<param name='scriptable' value=true>" );
		output.println( "<param name=login value=\"" + userid + "\">" );

		//Executa os parametros
		if( ptransac > 0 )
		{
			try
			{
				String resp = listaParam( ptransac );
				output.println("<param name=param1 value=\"" + resp + "\">" );
			}
			catch( Exception exp ){}
		}

		output.println( "No Java 2 SDK, Standard Edition v 1.3 support for APPLET!!");
		output.println( "</OBJECT>" );
		output.println( "</td></tr></table>" );
		output.println( "<table width='500' cellpadding='0' cellspacing='0' border='0'>" );
		output.println( "<tr><br><br><table width='570'><tr><td width='0'></td>" );
		output.println( "<td width='570'><font face='verdana' color='#000000' size=1>" );
		output.println( "<DD>Copyright  2001 - TELESP CELULAR Todos os Direitos Reservados<br>" );
		output.println( "</font></td>" );
		output.println( "<td><a href='http://www.portugaltelecom.pt' target='_blank'><img src='" + param.HOME_LOCAL + "images/lg_tc_pt_empresas.gif' width='125' height='80' alt='' border='0'></a></td>" );
		output.println( "</tr></table><br></tr></table>" );
		output.println( "</center>" );
		output.println( "</body>" );
		output.println( "</html>" );
	}

	private String listaParam( int transac ) throws Exception
	{
		StringBuffer buf = new StringBuffer();

		buf.append( param.xml_ini() );
		buf.append( param.xml_transac( transac ) );

		ClientPPS pps = new ClientPPS();

		try
		{
			String resp = pps.runClient(buf.toString());
			pps = null;
			String status = param.xml_get(resp, "ERR_MENS");

			if ( !status.equals("OK") )
			{
				throw new Exception( status );
			}
			return resp;
		}
		catch (Exception e)
		{
			throw e;
		}
	}
}
