// Fig. 19.5: HTTPGetHomeValidaLogin.java
// Creating and sending a page to the client
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class HTTPLogin extends HttpServlet
{
	public static ParamBasic param;
	public void init(ServletConfig config) throws ServletException
	{
		try
		{
			super.init(config);
			param = new ParamBasic();
		}
		catch (ServletException e)
		{
			throw e;
		}
	}

	public void doGet( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException
	{
		try
		{
			doPost(request, response);
		}
		catch (ServletException se)
		{
			log(se.toString());
			throw se;
		}
		catch (IOException ioe)
		{
			log(ioe.toString());
			throw ioe;
		}
	}

	public void doPost( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException
	{
		PrintWriter output;
		String userid, senha, username, resp;
		int transac;
		HttpSession session;
		session=null;

		String waux = request.getParameter( "param" );
		userid = param.xml_get( waux, "USERID");
		senha = param.xml_get( waux, "PASSWD");

		try
		{
			transac = Integer.parseInt( param.xml_get( waux, "TRANSACAO"  ) );
		}
		catch( Exception exp )
		{
			transac = -1;
		}

		response.setContentType( "text/html" );		// content type
		response.setHeader ("Pragma", "no-cache");
		response.setHeader ("Cache-Control", "no-cache");
		output = response.getWriter();				// get writer

		// create and send HTML page to client
		StringBuffer buf = new StringBuffer();

		if(userid == null || senha == null || userid.length() == 0 || senha.length() == 0 )
		{
			if( transac > 0 )
				retornoLogin(output, "Usurio/Senha invlido");
		}
		else
		{
			if( transac < 0 )
			{
				retornoLogin(output, "Transao Incorreta");
			}
			else
			{
				// Valida login com o PPS
				try
				{
					// Decriptografia

					userid=param.decriptografia( param.CRYPTO,userid.trim() );
					senha =param.decriptografia( param.CRYPTO,senha.trim());

					resp = validaSenha(userid, senha, transac);
					username = param.xml_get(resp, "NOM");

					// Cria uma sessao (verdadeira) se nao existir uma
					try
					{
						session = request.getSession(true);
						session.removeValue("userid");
						session.removeValue("username");

						session.putValue("userid", userid);
						session.putValue("username", username);

						retornoLogin(output, resp);
					}
					catch (Exception e)
					{
						log(e.toString());
						retornoLogin(output, e.getMessage());
					}
				}
				catch (Exception e)
				{
					log(e.toString());
					retornoLogin(output, e.getMessage());
				}
			}
		}

		output.close();
	}

	// Valida usurio no UNIX
	private String validaSenha( String userid, String senha, int transac ) throws Exception
	{
		try
		{
			StringBuffer buf = new StringBuffer();

			buf.append( param.xml_ini() );
			buf.append( param.xml_transac( transac ) );
			buf.append( param.xml_str("USERID", userid) );
			buf.append( param.xml_str("PASSWD", senha) );
			ClientPPS pps = new ClientPPS();

			try
			{
				String resp = pps.runClient(buf.toString());

				pps = null;

				String status = param.xml_get(resp, "ERR_MENS");
				if ( !status.equals("OK") )
				{
					throw new Exception( resp );
				}
				return resp;
			}
			catch (Exception e)
			{
				throw e;
			}
		}
		catch (Exception e)
		{
			throw e;
		}
	}

	// Resposta do login
	private void retornoLogin(PrintWriter output, String msg)
	{
		output.println( msg );
	}

}
