// Fig. 19.5: HTTPGetHomeValidaLogin.java
// Creating and sending a page to the client
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class HTTPMenu extends HttpServlet
{
	public static ParamBasic param;

	private int mHeight=0;

	private StringBuffer mbuf_str;

	public void init(ServletConfig config) throws ServletException
	{
		try
		{
			super.init(config);
			param = new ParamBasic();
		}
		catch (ServletException e)
		{
			throw e;
		}
	}

	public void doGet( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException
	{
		try
		{
			doPost(request, response);
		}
		catch (ServletException se)
		{
			log(se.toString());
			throw se;
		}
		catch (IOException ioe)
		{
			log(ioe.toString());
			throw ioe;
		}
	}

	public void doPost( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException
	{
		PrintWriter output;
		String relat, resp;

		response.setContentType( "text/html" );		// content type
		response.setHeader ("Pragma", "no-cache");
		response.setHeader ("Cache-Control", "no-cache");
		output = response.getWriter();				// get writer

		// create and send HTML page to client
		StringBuffer buf = new StringBuffer();

		// Nao cria uma sessao (false) se uma nao existir
		HttpSession session = request.getSession(false);

		if(session == null)
		{
			buf.append( param.get_HTML_Interromper("Aviso", "No existe sesso habilitada"));
			output.println( "Aviso: No existe sesso habilitada" );
		}
		else
		{
			try
			{
				String waux = request.getParameter( "param" );
				waux = param.xml_get( waux, "TRANSACAO"  );

				int transac = Integer.parseInt( waux );
				String userid = (String) session.getValue("userid");
				String username = (String) session.getValue("username");

				try
				{
					menu( output, userid, transac );
				}
				catch (Exception e)
				{
					log(e.toString());
					buf.append( param.get_HTML_Interromper("Aviso - menu()", e.getMessage()) );
					output.print(buf.toString());
				}
			}
			catch (Exception e)
			{
				log(e.toString());
				buf.append( param.get_HTML_Interromper("Aviso - getRelatorio()", e.getMessage()) );
				output.print(buf.toString());
			}
		}

		output.close();							// close PrintWriter stream
	}


	private String getRotulo(HttpSession session)
	{
		return ("sessions.id: " + session.getId() + "<br>\n" +
				"created: " + new Date(session.getCreationTime()) + "<br>\n" +
				"lastaccessed: " + new Date(session.getLastAccessedTime()) + "<br>\n");
	}

	private void menuOpen( PrintWriter output )
	{
		output.println( "<html>" );
		output.println( "<head><title></title></head>" );
		output.println( "<body marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 background=" + param.HOME_LOCAL + "images/h_fundo_consumidor.gif oncontextmenu='return false'\n>" );
		output.println( "<center>" );
		output.println( "<table border='2' bordercolor='rgb(0,100,155)'>" );
		output.println( "<tr>" );
		output.println( "<td>" );
		output.println( "<OBJECT classid=" + param.pluginCLASSID + " Width=165 Height=" + mHeight + " align=baseline" );
		output.println( "codebase=" + param.pluginCODEBASE + ">" );
		output.println( "<param name='code' value=MenuButton.class>" );
		output.println( "<param name='codebase' value=" + param.HOME_LOCAL + "applets/" + ">" );
		output.println( "<param name='type' value=" + param.pluginTYPE + ">" );
		output.println( "<param name='model' value=" + param.pluginMODEL + ">");
		output.println( "<param name='scriptable' value=true>" );
		output.println( "<param name='isHorizontal' value='false'>" );
		output.println( "<param name='3DBorder' value='false'>" );
		output.println( "<param name='buttonType' value='0'>" );
		output.println( "<param name='status' value='link'>" );
		output.println( "<param name='alignText' value='left'>" );
		output.println( "<param name='backColor' value='0071B7'>" );
		output.println( "<param name='backHighColor' value='0071B7'>" );
		output.println( "<param name='fontColor' value='ffffff'>" ) ;
		output.println( "<param name='fontHighColor' value='FFD700'>" );
		output.println( "<param name='font' value='verdana,11,1'>" );
		output.println( "<param name=pressedItem value=1>" );
		output.println( "<param name=statusString value=''>" );
		output.println( mbuf_str.toString() );

	}

	private void menuItem( PrintWriter output,String username, int transac )
	{

		int wQuantMenu=0;

		mbuf_str = new StringBuffer();

		mbuf_str.append( "<param name='menuItems'  value='" );
		mbuf_str.append( "{_}" );

		wQuantMenu++;
		mbuf_str.append( "{Login: " + username + ",#,#," + param.HOME_LOCAL + "images/login.gif }" );
		mbuf_str.append( "{_}" );
		mbuf_str.append( "{-}" );

		wQuantMenu++;
		mbuf_str.append( "{Telesp Celular,http://www.telespcelular.com.br,aplicativo," + param.HOME_LOCAL + "images/homepage.gif}" );
		mbuf_str.append( "{-}" );

		wQuantMenu++;
		mbuf_str.append( "{Cadastro Cliente," + param.HOME_HTTP + "HTTPGetPagina?param=<TRANSACAO>99</TRANSACAO>+<CODBASE>" + param.HOME_LOCAL + "applets/</CODBASE>+" +
					    "<CLASS>Cadastro.class</CLASS>+<WIDTH>570</WIDTH>+<HEIGTH>830</HEIGTH>,aplicativo," + param.HOME_LOCAL + "images/item_menu.gif}" );

		if( transac == 1 )
		{
			wQuantMenu++;
			mbuf_str.append( "{Cadastro Usuario," + param.HOME_HTTP + "HTTPGetPagina?param=<TRANSACAO>0</TRANSACAO>+<CODBASE>" + param.HOME_LOCAL + "applets/</CODBASE>+" +
						    "<CLASS>Usuario.class</CLASS>+<WIDTH>570</WIDTH>+<HEIGTH>410</HEIGTH>,aplicativo," + param.HOME_LOCAL + "images/item_menu.gif}" );
		}

		mbuf_str.append( "{-}" );
		wQuantMenu++;
		mbuf_str.append( "{Celular Especial," + param.HOME_HTTP + "HTTPGetPagina?param=<TRANSACAO>0</TRANSACAO>+<CODBASE>" + param.HOME_LOCAL + "applets/</CODBASE>+" +
						"<CLASS>CartaoEspecial.class</CLASS>+<WIDTH>300</WIDTH>+<HEIGTH>250</HEIGTH>,aplicativo," + param.HOME_LOCAL + "images/item_promocao.gif}" );

		mbuf_str.append( "{-}" );

		wQuantMenu++;
		mbuf_str.append( "{Sair," + param.HOME + "index.html,_top," + param.HOME_LOCAL + "images/exit.gif}" );
		mbuf_str.append( "'>" );

		mHeight = ( 30 * wQuantMenu );
	}

	private void menuClose( PrintWriter output )
	{
		output.println( "No Java 2 SDK, Standard Edition v 1.3 support for APPLET!!");
		output.println( "</OBJECT>" );
		output.println( "</td>" );
		output.println( "</tr>" );
		output.println( "</table>" );
		output.println( "</center>" );
		output.println( "</body>" );
		output.println( "</html>" );
	}

	private void menu( PrintWriter output, String username, int transac )
	{
		menuItem( output, username, transac );
		menuOpen( output );
		menuClose( output );
	}
}
