import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import java.awt.geom.*;
import java.awt.print.*;
import java.awt.print.PrinterJob;
import java.text.*;

public class HTTPMiddleWare extends HttpServlet
{
	public static ParamBasic param;

	public void init(ServletConfig config) throws ServletException
	{
		try
		{
			super.init(config);
			param = new ParamBasic();
		}
		catch (ServletException e)
		{
			throw e;
		}
		//param.debug("Iniciou o HTTPMiddleWare");
	}

	public void doGet (HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
	{
		doPost( request, response );
	}

	public void doPost (HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
		PrintWriter	output;
		String buffer = new String();

		response.setContentType("text/html");
		response.setHeader ("Pragma", "no-cache");
		response.setHeader ("Cache-Control", "no-cache");
		output = response.getWriter ();

		// Nao cria uma sessao (false) se uma nao existir
		HttpSession session = request.getSession(false);

		if(session == null)
		{
			buffer = ( param.get_HTML_Interromper("Aviso", "No existe sesso habilitada"));
			output.println( "Aviso: No existe sesso habilitada" );
		}
		else
		{
			buffer = request.getParameter("param");
			//param.debug(buffer);
			try
			{
				getTransacao(output, buffer);
			}
			catch (Exception e)
			{
				param.debug( e.toString() );
			}
		}
    }

    /*******************
     Efetua a transao
    *******************/
	private void getTransacao( PrintWriter output, String buffer ) throws Exception
	{
		ClientPPS2 pps = new ClientPPS2();

		try
		{
			pps.runClient(buffer, output);
			pps = null;
		}
		catch (Exception e)
		{
			throw e;
		}
	}
}
