import java.awt.*;

import java.awt.event.*;
import java.awt.Label;
import java.awt.TextField;
import java.applet.Applet;
import java.applet.AppletContext;

import java.net.*;
import java.io.PrintStream;
import java.io.DataInputStream;
import java.io.IOException;
import javax.swing.*;

/**
* Login no Sistema PPS
* @author Ivan Nagy
* @since 2002-10-21
**/
public class LoginMobitel extends Applet implements KeyListener
{

	private static final Parametro param = new Parametro();

	private JTextField txtLogin;
	private TextField txtSenha;
	private JButton bttEnvia;
	private String contexto;

	private boolean mAlteraSenha=false;
	private String mbuffer="";

	public void init()
	{

		JPanel pnlCampos = new JPanel( new FlowLayout() ) ;
		pnlCampos.setBackground( param.get_BackColor() );
		pnlCampos.setForeground( param.get_ForeColor() );
		pnlCampos.setBorder( BorderFactory.createEtchedBorder() );

		JPanel pnlBotoes = new JPanel( new FlowLayout() ) ;
		pnlBotoes.setBackground( param.get_BackColor() );
		pnlBotoes.setForeground( param.get_ForeColor() );
		pnlBotoes.setBorder( BorderFactory.createEtchedBorder() );

		txtLogin = new JTextField();
		txtLogin.setFont(param.get_Fonte());
		txtLogin.setForeground( Color.black );
		txtSenha = new TextField();
		txtSenha.setEchoChar( '*' );
		txtSenha.setForeground( Color.black );
		txtSenha.setFont(param.get_Fonte());

		bttEnvia = new JButton( "Enviar" );
		bttEnvia.setFont(param.get_Fonte());
		bttEnvia.addKeyListener(this);
		bttEnvia.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					enviarAcesso();
				}
			});

		Label lblLabelAux[];
		lblLabelAux = new Label[ 2 ];
		lblLabelAux[ 0 ] = new Label ( "Login:" );
		lblLabelAux[ 1 ] = new Label ( "Senha:" );
		for( int waux_idx = 0; waux_idx <= 1; waux_idx++ )
		{
			lblLabelAux[ waux_idx ].setForeground( param.getBackColorText() );
			lblLabelAux[ waux_idx ].setFont( param.getFonteMedia() );
		}

		GridBagConstraints gbcConstraints = new GridBagConstraints();

		GridBagLayout gblCampos = new GridBagLayout();
		AddGridComponente grdAddCampos = new AddGridComponente( gblCampos,gbcConstraints,2,6 );
		pnlCampos.add( grdAddCampos );

		GridBagLayout gblBotoes = new GridBagLayout();
		AddGridComponente grdAddBotoes = new AddGridComponente( gblBotoes,gbcConstraints,2,2 );
		pnlBotoes.add( grdAddBotoes );

		grdAddCampos.addComponente( lblLabelAux[ 0 ],gblCampos,gbcConstraints,1,1,1,1);
		grdAddCampos.addComponente( txtLogin,gblCampos,gbcConstraints,1,2,1,4);

		grdAddCampos.addComponente( lblLabelAux[ 1 ],gblCampos,gbcConstraints,2,1,1,1);
		grdAddCampos.addComponente( txtSenha,gblCampos,gbcConstraints,2,2,1,4);

		grdAddBotoes.addComponente( bttEnvia,gblBotoes,gbcConstraints,1,1,1,1);

		setLayout( new BorderLayout( 1,1 ) );
		setBackground(param.get_BackColor());
		setForeground(param.get_ForeColor());
		setFont(param.get_Fonte());

		add( pnlCampos, BorderLayout.CENTER );
		add( pnlBotoes, BorderLayout.SOUTH );

		changeLookAndFeel();

		txtLogin.requestFocus();
	}

	public void enviarAcesso()
	{
		if( txtLogin.getText().length() <= 0 )
		{
			JOptionPane.showMessageDialog( null,"Login invalido","Ateno",
				JOptionPane.ERROR_MESSAGE );
			txtLogin.selectAll();
			txtLogin.requestFocus();
			return;
		}
		if( txtSenha.getText().length() <= 5 )
		{
			JOptionPane.showMessageDialog( null,"Senha invalida","Ateno",
				JOptionPane.ERROR_MESSAGE );
			txtSenha.selectAll();
			txtSenha.requestFocus();
			return;
		}

		if( mAlteraSenha == false )
			getURL();
		else
		{
			enviaInformacao( mbuffer );
			getURL();
		}
	}

	// Substitui o comando AppletContext.showDocument()
	public void getURL()
  	{
		String result;

		final int etx=0x03;

    	try
    	{

			String contexto;

			contexto = montaLogin();
			if( contexto == null )
			{
				return;
			}

			URL urlLogin = new URL(param.get_Login() + contexto );
			URLConnection connection = urlLogin.openConnection();
      		DataInputStream in = new DataInputStream(connection.getInputStream());
      		StringBuffer arq = new StringBuffer();
			try
			{
				while(true)
				{
					result = in.readLine();
					if(result.length() == 0) break;
					arq.append(result);
					if(result.indexOf(etx) > 0) break;
				}
			}
			catch (Exception ex) {};
      		in.close();

      		result = arq.toString();
      		String wmens = param.xml_get(result.toString(), "ERR_MENS");
			String erro = param.xml_get( result.toString(),"ERR");

			try
			{
				if( erro.equals( "0" ) || wmens.equals( "OK" ) )
				{
					if( verificaAcesso( result.toString() ) == true && mAlteraSenha == false )
					{
						URL urlMenu = new URL( param.getHomeIndex() + montaMenu( param.xml_get(result.toString(), "GERENTE") ) );
						getAppletContext().showDocument( urlMenu,"menu" );
					}
				}
				else
				{
					if( wmens.length() <=0 )
					{
						wmens = "Sem resposta.";
					}

					JOptionPane.showMessageDialog( null,wmens,"Ateno",
						JOptionPane.ERROR_MESSAGE );
				}
			}
			catch( Exception exp )
			{
				JOptionPane.showMessageDialog(null, "Sem resposta", "Erro", JOptionPane.ERROR_MESSAGE);
			}
     	}
      	catch(MalformedURLException mue)
      	{
      		System.out.println("Illegal URL: " + mue);
    	}
    	catch(IOException ioe)
    	{
    		System.out.println("IOException: " + ioe);
    	}
    	catch(Exception e)
    	{
			System.out.println("Error: " + e);
		}
	}

	public String montaLogin()
	{
		StringBuffer wbuf = new StringBuffer();

		try
		{
			wbuf.append( "?param=" );
			wbuf.append( param.xml_transac( 100 ) );
			wbuf.append( param.xml_str( "USERID",param.criptografia( param.CRYPTO,txtLogin.getText().trim() ) ) );
			wbuf.append( param.xml_str( "PASSWD",param.criptografia( param.CRYPTO,txtSenha.getText().trim() ) ) );
			wbuf.append( param.xml_str( "GERENTE","N" ) );
		}
		catch( Exception exp )
		{
			JOptionPane.showMessageDialog( null,"Login/Senha: " + exp.getMessage(),"Ateno",
					JOptionPane.ERROR_MESSAGE );
			return null;
		}

		return wbuf.toString().replace( '\n','+' );
	}

	public String montaMenu( String pTipo )
	{
		StringBuffer wbuf = new StringBuffer();

		wbuf.append( "?param=" );

		if( pTipo.equals( "S" ) )
			wbuf.append( param.xml_transac( 1 ) );
		else
			wbuf.append( param.xml_transac( 2 ) );

		return wbuf.toString().replace( '\n','+' );
	}


	/**
	*Set padrao Windows
	**/
	private void changeLookAndFeel( )
	{
		try
		{
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
			SwingUtilities.updateComponentTreeUI(this);
		}
		catch( Exception e ){}
	}

	public boolean verificaAcesso( String buffer )
	{

		if( param.xml_get(buffer, "ATIVO").equals( "N" ) )
		{
			JOptionPane.showMessageDialog( null,"Login desativado. Acesso no permitido.","Ateno",
					JOptionPane.WARNING_MESSAGE );
			return false;
		}

		try
		{
			String wcpfaux = param.xml_get(buffer, "CPF");
			if( param.xml_get(buffer, "PASS").equals( wcpfaux.substring( 0, wcpfaux.length() -2 ) ) )
			{
				JOptionPane.showMessageDialog( null, "Seja bem vindo ao sistema PPS.\n" +
						" Este  o seu primeiro acesso ao sistema, por favor digite a nova senha",
								"Alterao da senha", JOptionPane.INFORMATION_MESSAGE );
				mAlteraSenha = true;
				txtSenha.selectAll();
				txtSenha.requestFocus();
				mbuffer = buffer;
			}
		}
		catch(Exception ex)
		{
			return false;
		}

		return true;
	}

	private String montaContexto( String buffer )
	{
		String contexto;
		StringBuffer wbuf = new StringBuffer();

		wbuf.append( "?param=" );
		wbuf.append( param.xml_transac( 101 ) );
		wbuf.append( param.xml_str( "USERID",txtLogin.getText() ) );
		wbuf.append( param.xml_str( "NOM",param.xml_get(buffer, "NOM") ) );
		wbuf.append( param.xml_str( "PASS",txtSenha.getText() ) );
		wbuf.append( param.xml_str( "MAIL",param.xml_get(buffer, "MAIL") ) );
		wbuf.append( param.xml_str( "RG",param.xml_get(buffer, "RG") ) );
		wbuf.append( param.xml_str( "CPF",param.xml_get(buffer, "CPF") ) );
		wbuf.append( param.xml_str( "EMPRESA",param.xml_get(buffer, "EMPRESA") ) );
		wbuf.append( param.xml_str( "ATIVO",param.xml_get(buffer, "ATIVO") ) );
		wbuf.append( param.xml_str( "GERENTE",param.xml_get(buffer, "GERENTE") ) );
		wbuf.append( param.xml_str( "USER",param.xml_get(buffer, "USER") ) );

		contexto = wbuf.toString();

		contexto = contexto.replace( ' ','+' );
		contexto = contexto.replace( '\n','+' );

		return contexto;
	}

	/*******************************
	- Envia as informaes dos campos
	********************************/
	private boolean enviaInformacao(String buffer)
	{
		String result;
		final int etx=0x03;

		try
		{
			URL urlDados = new URL( param.get_Middleware() + montaContexto( buffer ) );
			URLConnection connection = urlDados.openConnection();
			DataInputStream in = new DataInputStream( connection.getInputStream() );
			StringBuffer arq = new StringBuffer();
			try
			{
				while(true)
				{
					result = in.readLine();
					if(result.length() == 0) break;

					arq.append(result);
					if(result.indexOf(etx) > 0) break;
				}
			}
			catch (Exception ex) {};
			in.close();
			String status = param.xml_get( arq.toString(),"ERR_MENS" );
			int erro = Integer.parseInt( param.xml_get( arq.toString(),"ERR" ) );
			if( status != null )
			{
				if ( status.equals("OK") )
				{
					JOptionPane.showMessageDialog(null, "Senha alterada com sucesso !", "Sucesso!",
										JOptionPane.INFORMATION_MESSAGE);
					mAlteraSenha = false;
					return true;
				}
				else
				{
					JOptionPane.showMessageDialog(null, "Erro na alterao da senha !", "Aviso", JOptionPane.ERROR_MESSAGE);
					return false;
				}
			}
			else
			{
				JOptionPane.showMessageDialog(null, "Sem resposta", "Erro", JOptionPane.ERROR_MESSAGE);
				return false;
			}
		}
		catch(MalformedURLException mue)
		{
			System.out.println("Illegal URL: " + mue);
		}
		catch(IOException ioe)
		{
			System.out.println("IOException: " + ioe);
		}
		catch(Exception e)
		{
			System.out.println("Error: " + e);
		}

		return true;
	}

	public void keyTyped(KeyEvent e) {}
	public void keyPressed(KeyEvent e){}
	public void keyReleased(KeyEvent e)
	{
		int keyCode = e.getKeyCode();

	     // Consiste o caracterENTER
		if( keyCode == 10 )
        {
			enviarAcesso();
		}
	}
}
