import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableColumn;

import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.ListSelectionEvent;

import java.net.*;
import java.io.PrintStream;
import java.io.DataInputStream;
import java.io.IOException;

/**
* Frame para visualizacao de informacoes extras
* @author Ivan Nagy
* @since 2002-11-04
**/
public class PoupUp extends Frame implements KeyListener
{
	private static final Color BACK = Color.white;
	private static final Color COR = Color.black;
	private static Font FONTE = new Font("verdana",Font.PLAIN + Font.BOLD,11);
	private PoupUp frame;

	private Parametro param = new Parametro();

	private TextField txtBusca;
	private Label lblAux;
	private String codLista[];

	private Vector v;
	private Vector mVectorColumn;
	private JTable table;
	private JScrollPane scrollPane;
	private Model myModel;
	private int currentRow;

	private int mTransac=0;
	private String mTagSet="";
	private String mTagGet="";

	private Status clsStatus;

	private Button bttOk,bttLocalizar;

	private int mColuna=0;

	public PoupUp()
	{
		frame = this;

		v = new Vector();

		try
		{
			myModel = new Model( this );
		}
		catch( Exception exp ){}
	}

	public void montaPoupUp()
	{
		//Adiciona os componentes da panel
		table = new JTable(myModel);
		table.setFont(FONTE);
		//table.setPreferredScrollableViewportSize(new Dimension(500, 200));

		//Se up renderer
		setUpColorRenderer(table);

		//Set up column sizes.
		initColumnSizes(table, myModel);

		clsStatus = new Status( "",20,20 );

		table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ListSelectionModel rowSM = table.getSelectionModel();
		rowSM.addListSelectionListener(new ListSelectionListener()
			{
				public void valueChanged(ListSelectionEvent e)
				{
					// Consiste multipla selecao
					if(e.getValueIsAdjusting() ) return;

					ListSelectionModel lsm = (ListSelectionModel) e.getSource();

					if(!lsm.isSelectionEmpty())
					{
						currentRow = lsm.getMinSelectionIndex();
						clsStatus.setMensag( myModel.getValueAt(getCurrentRow(), 1).toString() );
					}
				}
			});

		//Create the scroll pane and add the table to it.
		scrollPane = new JScrollPane(table);

		Panel pnlCampos = new Panel( new BorderLayout() );
		Panel pnlBotoes = new Panel( new BorderLayout() );

		pnlCampos.setBackground(BACK);
		pnlBotoes.setBackground(BACK);

		lblAux = new Label( "Busca:",Label.CENTER );
		lblAux.setForeground(COR);
		lblAux.setFont(FONTE);

		txtBusca = new TextField();
		txtBusca.setBackground( Color.yellow );
		txtBusca.setFont(FONTE);
		txtBusca.addKeyListener(this);

		bttLocalizar = new Button("Pesquisar");
		bttLocalizar.setEnabled(true);
		bttLocalizar.setFont(FONTE);
		bttLocalizar.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					if( txtBusca.getText().length() > 0 )
					{
						clsStatus.setMensag( "Pesquisando..." );
						getURL( getTransacao(),getTagSet(),getTagGet(),txtBusca.getText() );
						bttOk.setEnabled( true );
						clsStatus.setMensag( myModel.getValueAt(getCurrentRow(), 1).toString() );
						bttLocalizar.setEnabled( false );
					}
					else
						JOptionPane.showMessageDialog(frame,
							"Campo no pode ser nulo","Ateno",
							JOptionPane.WARNING_MESSAGE );
				}
			});

		bttOk = new Button("Selecionar");
		bttOk.setEnabled(true);
		bttOk.setFont(FONTE);
		bttOk.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					getLinha();
					encerrar();
				}
			});

		Button bttCancelar = new Button(" Cancelar ");
		bttCancelar.setEnabled(true);
		bttCancelar.setFont(FONTE);
		bttCancelar.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					encerrar();
				}
			});

		GridBagConstraints gbcConstraints = new GridBagConstraints();

		GridBagLayout gblCampos = new GridBagLayout();
		AddGridComponente grdAddCampos = new AddGridComponente( gblCampos,gbcConstraints,15,30 );
		pnlCampos.add( grdAddCampos );

		GridBagLayout gblBotoes = new GridBagLayout();
		AddGridComponente grdAddBotoes = new AddGridComponente( gblBotoes,gbcConstraints,2,3 );
		pnlBotoes.add( grdAddBotoes,"Center" );
		pnlBotoes.add( clsStatus ,"South" );

		grdAddCampos.addComponente( lblAux,gblCampos,gbcConstraints,1,1,1,29);
		grdAddCampos.addComponente( txtBusca,gblCampos,gbcConstraints,2,1,1,29);
		grdAddCampos.addComponente( scrollPane,gblCampos,gbcConstraints,4,1,11,29);

		grdAddBotoes.addComponente( bttLocalizar,gblBotoes,gbcConstraints,1,1,1,1);
		grdAddBotoes.addComponente( bttOk,gblBotoes,gbcConstraints,1,2,1,1);
		grdAddBotoes.addComponente( bttCancelar,gblBotoes,gbcConstraints,1,3,1,1);

		frame.addWindowListener(
			new WindowAdapter()
			{
   	    		public void windowClosing(WindowEvent e)
   	    		{
					encerrar();
				}

				public void windowDeactivated(WindowEvent e)
				{
					//encerrar();
				}
		    });

		setLayout( new BorderLayout() );
		setSize(580,480);
		add( pnlCampos,"Center" );
		add( pnlBotoes,"South" );

		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension frameSize = frame.getSize();

		int posX, posY;
		posX = (screenSize.width - frameSize.width) / 2;
		posY = (screenSize.height - frameSize.height) / 2;
		setLocation (posX,posY);

		changeLookAndFeel();

		txtBusca.requestFocus();

	}

	public void setTitulo( String pTitulo )
	{
		setTitle( pTitulo );
	}

	public void setTexto( String pText )
	{
		lblAux.setText( pText );
	}

	public void setTransacao( int pTransac )
	{
		mTransac = pTransac;
	}

	public void setTagSet( String pTagSet )
	{
		mTagSet = pTagSet;
	}

	public void setTagGet( String pTagGet )
	{
		mTagGet = pTagGet;
	}

	public int getTransacao()
	{
		return mTransac;
	}

	public String getTagSet()
	{
		return mTagSet;
	}

	public String getTagGet()
	{
		return mTagGet;
	}

	public void setShow()
	{
		clsStatus.setMensag( "" );
		bttOk.setEnabled( false );
		txtBusca.setText( "" );
		v.clear();
		setVetor( v );
		txtBusca.requestFocus();
		setVisible( true );
	}

	public void setColumnAddElement( String pColuna )
	{
		myModel.columnAddElement( pColuna );
		v.addElement( "" );
		myModel.setVector( v );
		mColuna ++;
	}

	private void setUpColorRenderer(JTable table)
	{
		//table.setDefaultRenderer(Color.class, new ColorRenderer(true));
	}

	/**
	* This method picks good column sizes.
	* If all column heads are wider than the column's cells'
	* contents, then you can just use column.sizeWidthToFit().
	*/
	private void initColumnSizes(JTable table, MyTableModel model)
	{
		TableColumn column = null;
		Component comp = null;
		int headerWidth = 0;
		int cellWidth = 0;

		String wcoluna_str;

		for (int i = 0; i < model.getColumnCount(); i++)
		{
			column = table.getColumnModel().getColumn(i);
			try
			{
				comp = column.getHeaderRenderer().getTableCellRendererComponent(null, column.getHeaderValue(),false, false, 0, 0);
				headerWidth = comp.getPreferredSize().width;
			}
			catch (NullPointerException e){}

			wcoluna_str = model.getColumnName( i );

			comp = table.getDefaultRenderer(
				model.getColumnClass(i)).getTableCellRendererComponent(table,
							wcoluna_str, false, false, 0, i);

			cellWidth = comp.getPreferredSize().width;

			//XXX: Before Swing 1.1 Beta 2, use setMinWidth instead.
			column.setPreferredWidth(Math.max(headerWidth, cellWidth));
		}
	}

	public int getCurrentRow()
	{
		return currentRow;
	}

	public void rowDelete()
	{
		myModel.rowDelete( getCurrentRow() );
	}

	public String getLinha()
	{
		return (myModel.getValueAt(getCurrentRow(), 0).toString());
	}

	public void setVetor(Vector xv)
	{
		v.clear();
		for(int idx=0; idx < xv.size(); idx++)
		{
			v.addElement(xv.elementAt(idx));
		}

		myModel.fireTableDataChanged();			// Show mudanca em table
	}

	/****************
	 Classe auxiliar
	****************/
	public class Model extends MyTableModel
	{
		private PoupUp tab;

		// Construtor
		public Model(PoupUp xTab)
		{
			super();

			tab=xTab;

			setEditable(1);
		}

		// Deleta uma linha
		public void rowDelete(int row)
		{
			int column, max;
			int idx = getIdx(row, 0);		// Calcula
			for(column=0; column < getColumnCount(); column++) rowsDeleteElement(idx);
			fireTableDataChanged();			// Show mudanca em table
		}
	}

	private void encerrar()
	{
		dispose();
		frame.dispose();
	}

	/************************************************
	Efetua consulta
	*************************************************/
	private void getURL( int pTransac, String pTagSet,String pTagGet, String pTxt )
	{
		String result;
		String contexto = "?param=" + param.xml_transac( pTransac ) +
						  param.xml_str( pTagSet, pTxt.toUpperCase() ) + param.getCtrl();

		contexto = contexto.replace( ' ','+' );
		contexto = contexto.replace( '\n','+' );

		final int etx=0x03;

		try
		{
			URL urlDados = new URL(param.get_Middleware()+contexto);

			URLConnection connection = urlDados.openConnection();
			DataInputStream in = new DataInputStream(connection.getInputStream());
			StringBuffer arq = new StringBuffer();

			try
			{
				while(true)
				{
					result = in.readLine();
					if(result.length() == 0) break;

					arq.append(result);
					if(result.indexOf(etx) > 0) break;
				}
			}
			catch (Exception ex) {};
			in.close();

			String status = param.xml_get(arq.toString(),"ERR_MENS");
			int erro = Integer.parseInt(param.xml_get(arq.toString(),"ERR"));
			if(status != null)
			{
				if( erro == 0 )
					mostraInfo( arq.toString(),pTagGet );

				//Buffer over flow
				if( erro == -25010 )
				{
					mostraInfo( arq.toString(),pTagGet );
					JOptionPane.showMessageDialog(this, "Excedeu o limite de informaes localizadas,\n" +
						" por este motivo no foi possvel a total visualizao das informaes.\n" +
						" Efetue uma nova consulta restringindo o parametro.","Alerta",
					JOptionPane.WARNING_MESSAGE);
				}

				if( erro != 0 && erro != -25010 )
				{
					JOptionPane.showMessageDialog(this, "Informao no localizada!", "Aviso", JOptionPane.WARNING_MESSAGE);
				}
			}
			else
			{
				JOptionPane.showMessageDialog(this, "Sem resposta", "Erro", JOptionPane.ERROR_MESSAGE);
			}
		}
		catch(MalformedURLException mue)
		{
			System.out.println("Illegal URL: " + mue);
		}
		catch(IOException ioe)
		{
			System.out.println("IOException: " + ioe);
		}
		catch(Exception e)
		{
			System.out.println("Error: " + e);
		}
	}

	/*******************************
	Mostra as informaes nos campos
	********************************/
	private void mostraInfo( String buffer,String pTabGet )
	{
		String wParam;
		int pos, tam, qtd;
		int wSequencia=0;
		String cod, descr,descr2;

		String wTipoSeparador;

		Vector vaux = new Vector(1,1);

		try
		{
			wParam = param.xml_get( buffer,pTabGet );
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
			return;
		}

		if( wParam.trim().length() <= 0 )
		{
			JOptionPane.showMessageDialog( this,"Informao no localizada.","Ateno",
				JOptionPane.WARNING_MESSAGE );

			return;
		}

		try
		{
			tam=wParam.length();

			/************************
			Obtem qtd. de Registros
			*************************/
			for(pos=0, qtd=0;; qtd++)
			{

				wSequencia++;

				if( wSequencia == mColuna )
				{
					wTipoSeparador = "|";
					wSequencia = 0;
				}
				else
					wTipoSeparador = "=";

				cod = param.getSubstring(wTipoSeparador,wParam, pos);
				pos=pos+cod.length()+1;

				vaux.addElement( cod );

				if (pos >= tam) break;
			}
			setVetor( vaux );

		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
		}
		repaint();
	}

	private void changeLookAndFeel( )
	{
		try
		{
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
			SwingUtilities.updateComponentTreeUI(this);

		}
		catch( Exception e ){}
	}

    public void paint(Graphics g)
    {
		update(g);
    }
	public void update(Graphics g)
	{
		Dimension d = getSize();
	}

	public void keyTyped(KeyEvent e) {}
	public void keyPressed(KeyEvent e){}
	public void keyReleased(KeyEvent e)
	{
		int keyCode = e.getKeyCode();

		clsStatus.setMensag( "" );
		bttOk.setEnabled( false );
		bttLocalizar.setEnabled( true );
		v.clear();
		setVetor( v );
	}
}