import java.awt.*;
import java.applet.Applet;

class Status extends Panel
{
	String mensag;
	Dimension size;
	Font lbl_font = new Font("verdana", Font.BOLD, 12);
	Font msg_font = new Font("verdana", Font.BOLD + Font.PLAIN, 12);
	int width, height;

	private Label lblAux;

	public Status(String msg, int initialWidth, int initialHeight)
	{
		width=initialWidth;
		height=initialHeight;
		size = new Dimension(width,height);

		lblAux = new Label( "" );
		lblAux.setFont ( lbl_font );
		lblAux.setForeground( Color.black );

		setLayout( new BorderLayout( 1,1 ) );

		setBackground( Color.lightGray );
		add( lblAux,"Center" );
	}

	public Dimension getPreferredSize()
	{
		return getMinimumSize();
	}

	public Dimension getMinimumSize()
	{
		return size;
	}

	public void paint (Graphics g)
	{
		update(g);
	}

	public void update(Graphics g)
	{
		Dimension d = getSize();
		width = (int) d.width;
		height = (int) d.height;

		g.setColor(Color.lightGray);
		g.fill3DRect(0, 0, d.width - 1, d.height - 1, true);

		g.setColor(Color.lightGray);
		g.drawRoundRect(5, 5, d.width - 10, d.height - 10, 10, 10);
	}

	public void setMensag(String msg)
	{
		if( msg.equals( null ) )
			msg =  "";

		lblAux.setText( msg );
		repaint();
	}
}
