/*****************************************************************************************
Classe   : Usuario.java
Autor    : Ivan Nagy
Data	 : 2002-10-15
Objetivo : Efetuar manutencao dos usuario do cadastro de clientes
*****************************************************************************************/

import java.awt.*;
import java.net.*;
import java.awt.event.*;
import java.applet.Applet;
import java.applet.AppletContext;
import javax.swing.*;
import java.io.PrintStream;
import java.io.DataInputStream;
import java.io.IOException;

public class Usuario extends Applet
{
	private static final Parametro param = new Parametro();
	private JButton bttNovo,bttConfirma,bttReset,bttConsulta;
	private TextField txtDados[];
	private JRadioButton rdbAtivo,rdbDesativo;
	private ButtonGroup btgStatus;
	private JCheckBox chkGerente;
	private Status clsStatus;
	private static final CheckString clsCheckString = new CheckString();
	private static final CPF clsCPF = new CPF();
	private static final CNPJ clsCNPJ = new CNPJ();

	private MyPoupUp myPoupUp;

	//Determina a cor a ser utilizada: RED | GREEN | BLUE
	private Color mBackground = new Color( 0,113,200 );

	public void init()
	{
		/*********************************
		 - Classes
		*********************************/
		Titulo pnlTitulo = new Titulo( "Telesp Celular - PPS ( Manuteno Usurio )",20,20 );
		//********************************
		clsStatus = new Status( " ",20,20 );
		//********************************

		myPoupUp = new MyPoupUp( this );

		//Criando Grid Bag
		GridBagConstraints wgrid_const = new GridBagConstraints();
		GridBagLayout grdBotoes = new GridBagLayout();
		GridBagLayout grdDados = new GridBagLayout();

		/*********************************
		 - Criando as Panels
		*********************************/
		JPanel pnlPrincipal = new JPanel( new BorderLayout( ) );
		pnlPrincipal.setBorder( BorderFactory.createEtchedBorder() );
		//*******************************
		JPanel pnlBotoes = new JPanel( new BorderLayout( ) );
		pnlBotoes.setBorder( BorderFactory.createEtchedBorder() );
		//*******************************
		JPanel pnlDados = new JPanel( new BorderLayout( ) );
		pnlDados.setBorder( BorderFactory.createEtchedBorder() );

		/*********************************
		 - Criando Grid's
		*********************************/
		AddGridComponente grdAddDados = new AddGridComponente( grdDados,wgrid_const,11,22 );
		pnlDados.add( grdAddDados, BorderLayout.CENTER );
		//*******************************
		AddGridComponente grdAddBotoes = new AddGridComponente( grdBotoes,wgrid_const,2,4 );
		pnlBotoes.add( grdAddBotoes, BorderLayout.CENTER );
		pnlBotoes.add( clsStatus, BorderLayout.SOUTH );

		/*********************************
		 - Criando ARRAY de Label
		*********************************/
		Label lblLabelAux[];
		lblLabelAux = new Label[ 10 ];
		lblLabelAux[ 0 ] = new Label ( "Acesso" );
		lblLabelAux[ 1 ] = new Label ( "Nome" );
		lblLabelAux[ 2 ] = new Label ( "Senha" );
		lblLabelAux[ 3 ] = new Label ( "E-mail" );
		lblLabelAux[ 4 ] = new Label ( "RG" );
		lblLabelAux[ 5 ] = new Label ( "CPF" );
		lblLabelAux[ 6 ] = new Label ( "Cadastro" );
		lblLabelAux[ 7 ] = new Label ( "Alterao" );
		lblLabelAux[ 8 ] = new Label ( "Empresa" );
		lblLabelAux[ 9 ] = new Label ( "Usurio" );
		//*******************************

		for( int widx_label = 0; widx_label < 10; widx_label++ )
		{
			lblLabelAux[ widx_label ].setForeground( Color.white );
		}

		/*********************************
		 - Criando JTextField
		*********************************/
		txtDados = new TextField[ 10 ];
		for( int waux_idx = 0; waux_idx < 10; waux_idx++ )
		{
			txtDados[ waux_idx ] = new TextField();
		}
		txtDados[ 0 ].setEnabled( false );
		txtDados[ 2 ].setEnabled( false );
		txtDados[ 2 ].setEchoChar( '*' );
		txtDados[ 6 ].setEnabled( false );
		txtDados[ 7 ].setEnabled( false );
		txtDados[ 9 ].setEnabled( false );

		/*********************************
		 - Criando RadioButton
		*********************************/
		//Tratamento do Radio Button
		ClickRadioButton clickradiobutton = new ClickRadioButton();
		//*******************************
		rdbAtivo = new JRadioButton( "Ativo",true );
		rdbAtivo.addItemListener( clickradiobutton );
		rdbAtivo.setActionCommand( "0" );
		rdbAtivo.setBackground( param.get_BackColor() );
		rdbAtivo.setForeground( param.get_ForeColor() );
		//*******************************
		rdbDesativo = new JRadioButton( "Desativo",false );
		rdbDesativo.addItemListener( clickradiobutton );
		rdbDesativo.setActionCommand( "1" );
		rdbDesativo.setBackground( param.get_BackColor() );
		rdbDesativo.setForeground( param.get_ForeColor() );
		//*******************************
		btgStatus = new ButtonGroup();
		btgStatus.add( rdbAtivo );
		btgStatus.add( rdbDesativo );

		/*********************************
		 - Criando CheckBox
		*********************************/
		chkGerente = new JCheckBox( "Gerente" );
		chkGerente.setBackground( param.get_BackColor() );
		chkGerente.setForeground( param.get_ForeColor() );

		/*********************************
		 - Criando Botoes
		*********************************/
		bttNovo = new JButton( "  Novo  " );
		bttNovo.setForeground(Color.black);
		bttNovo.setFont(param.get_Fonte());
		bttNovo.addActionListener(
			new ActionListener()
			{
				public void actionPerformed( ActionEvent e )
				{
					clearDados();
				}
			} );

		bttConsulta = new JButton( "Consultar" );
		bttConsulta.setForeground(Color.black);
		bttConsulta.setFont(param.get_Fonte());
		bttConsulta.addActionListener(
			new ActionListener()
			{
				public void actionPerformed( ActionEvent e )
				{
					try
					{
						clearDados();
						myPoupUp.setShow();
					}
					catch(Exception ex){}
				}
			} );


		bttConfirma = new JButton( " Enviar " );
		bttConfirma.setForeground(Color.black);
		bttConfirma.setFont(param.get_Fonte());
		bttConfirma.addActionListener(
			new ActionListener()
			{
				public void actionPerformed( ActionEvent e )
				{
					if( trataCampos() == true )
					{
						clsStatus.setMensag( "Enviando informao. Aguarde..." );
						enviaInformacao();
						clearDados();
					}
				}
			} );


		bttReset = new JButton( " Reset  " );
		bttReset.setForeground(Color.black);
		bttReset.setFont(param.get_Fonte());
		bttReset.addActionListener(
			new ActionListener()
			{
				public void actionPerformed( ActionEvent e )
				{
					txtDados[ 2 ].setText( "" );
				}
			} );



		/*********************************
		 - Adicionando os componentes a grid
		   grdDados
		*********************************/
		grdAddDados.addComponente( lblLabelAux[ 0 ],grdDados,wgrid_const,1,1,1,1); //Acesso
		grdAddDados.addComponente( txtDados[ 0 ],grdDados,wgrid_const,1,2,1,5);
		//*********************************
		grdAddDados.addComponente( lblLabelAux[ 1 ],grdDados,wgrid_const,2,1,1,1); //Nome
		grdAddDados.addComponente( txtDados[ 1 ],grdDados,wgrid_const,2,2,1,20);
		//*********************************
		grdAddDados.addComponente( lblLabelAux[ 2 ],grdDados,wgrid_const,3,1,1,1); //Senha
		grdAddDados.addComponente( txtDados[ 2 ],grdDados,wgrid_const,3,2,1,5);
		//*********************************
		grdAddDados.addComponente( lblLabelAux[ 3 ],grdDados,wgrid_const,4,1,1,1); //E-mail
		grdAddDados.addComponente( txtDados[ 3 ],grdDados,wgrid_const,4,2,1,20);
		//*********************************
		grdAddDados.addComponente( lblLabelAux[ 4 ],grdDados,wgrid_const,5,1,1,1); //RG
		grdAddDados.addComponente( txtDados[ 4 ],grdDados,wgrid_const,5,2,1,5);
		//*********************************
		grdAddDados.addComponente( lblLabelAux[ 5 ],grdDados,wgrid_const,6,1,1,1); //CPF
		grdAddDados.addComponente( txtDados[ 5 ],grdDados,wgrid_const,6,2,1,5);
		//*********************************
		grdAddDados.addComponente( lblLabelAux[ 6 ],grdDados,wgrid_const,7,1,1,1); //Cadastro
		grdAddDados.addComponente( txtDados[ 6 ],grdDados,wgrid_const,7,2,1,7);
		//*********************************
		grdAddDados.addComponente( lblLabelAux[ 7 ],grdDados,wgrid_const,8,1,1,1); //Alteracao
		grdAddDados.addComponente( txtDados[ 7 ],grdDados,wgrid_const,8,2,1,7);
		//*********************************
		grdAddDados.addComponente( lblLabelAux[ 8 ],grdDados,wgrid_const,9,1,1,1); //Empresa
		grdAddDados.addComponente( txtDados[ 8 ],grdDados,wgrid_const,9,2,1,20);
		//*********************************
		grdAddDados.addComponente( lblLabelAux[ 9 ],grdDados,wgrid_const,10,1,1,1); //Usuario
		grdAddDados.addComponente( txtDados[ 9 ],grdDados,wgrid_const,10,2,1,4);
		//*********************************
		grdAddDados.addComponente( rdbAtivo,grdDados,wgrid_const,11,1,1,1);
		grdAddDados.addComponente( rdbDesativo,grdDados,wgrid_const,11,3,1,3);
		//*********************************
		grdAddDados.addComponente( chkGerente,grdDados,wgrid_const,11,8,1,3);

		/*********************************
		 - Adicionando os componentes a grid
		   grdDados
		*********************************/
		grdAddBotoes.addComponente( bttNovo,grdBotoes,wgrid_const,1,1,1,1);
		//*********************************
		grdAddBotoes.addComponente( bttConsulta,grdBotoes,wgrid_const,1,2,1,1);
		//*********************************
		grdAddBotoes.addComponente( bttConfirma,grdBotoes,wgrid_const,1,3,1,1);
		//*********************************
		grdAddBotoes.addComponente( bttReset,grdBotoes,wgrid_const,1,4,1,1);


		setLayout( new BorderLayout( 1,1 ) );
		setBackground( param.get_BackColor() );
		setForeground( param.get_ForeColor() );

		pnlDados.setBackground(param.get_BackColor());
		pnlBotoes.setBackground(param.get_BackColor());

		add( pnlTitulo, BorderLayout.NORTH );
		add( pnlDados, BorderLayout.CENTER );
		add( pnlBotoes, BorderLayout.SOUTH );

		clearDados();

		txtDados[ 9 ].setText( getLoginCad() );

		changeLookAndFeel();
	}

	public void paint (Graphics g)
	{
		update(g);
	}

	public void update(Graphics g)
	{
		Dimension d = getSize();
	}

	public Insets getInsets()
	{
		return new Insets(1,1,1,1);
	}

	/*********************************
	 - Tratamento dos campos
	*********************************/
	private boolean trataCampos()
	{
		String wstr = "";

		for( int widx = 0; widx < 10; widx++ )
		{
			//Verifica nulos
			if( widx == 1 || widx == 4 || widx == 5 || widx == 8 )
			{
				wstr = txtDados[ widx ].getText();

				if( clsCheckString.isNull( wstr ) == false )
				{
					JOptionPane.showMessageDialog( null,"O campo no pode ser nulo","Ateno",
						JOptionPane.WARNING_MESSAGE );
					txtDados[ widx ].requestFocus();
					return false;
				}
			}
			//Verifica numerico
			if( widx == 5 )
			{
				wstr = txtDados[ widx ].getText();


				//Verifica CPF
				try
				{
					if( clsCPF.isCPF( wstr ) == false )
					{
						JOptionPane.showMessageDialog( null,"CPF invalido",
							"Ateno",JOptionPane.WARNING_MESSAGE );
						txtDados[ widx ].selectAll();
						txtDados[ widx ].requestFocus();
						return false;
					}
				}
				catch( Exception exp )
				{
					JOptionPane.showMessageDialog( null,exp.getMessage(),
						"Ateno",JOptionPane.WARNING_MESSAGE );
					txtDados[ widx ].selectAll();
					txtDados[ widx ].requestFocus();
					return false;
				}


			}
			//Verifica caracteres especiais
			if( widx == 4  )
			{
				wstr = txtDados[ widx ].getText();

				if( clsCheckString.isCharacEspec( wstr ) == false )
				{
					JOptionPane.showMessageDialog( null,"O campo deve conter somente caracteres alfanumricos",
						"Ateno",JOptionPane.WARNING_MESSAGE );
					txtDados[ widx ].selectAll();
					txtDados[ widx ].requestFocus();
					return false;
				}
			}

			//Verifica email valido
			if( widx == 3 )
			{
				wstr = txtDados[ widx ].getText();

				if( clsCheckString.isNull( wstr ) == true )
				{
					if( clsCheckString.checkDigit( wstr, "@" ) == false )
					{
						JOptionPane.showMessageDialog( null,"E-mail invalido",
							"Ateno",JOptionPane.WARNING_MESSAGE );
						txtDados[ widx ].selectAll();
						txtDados[ widx ].requestFocus();
						return false;
					}
					if( clsCheckString.checkDigit( wstr, "." ) == false )
					{
						JOptionPane.showMessageDialog( null,"E-mail invalido",
							"Ateno",JOptionPane.WARNING_MESSAGE );
						txtDados[ widx ].selectAll();
						txtDados[ widx ].requestFocus();
						return false;
					}
				}
			}
		}

		return true;
	}

	/*******************************
	- Envia as informaes dos campos
	********************************/
	private void enviaInformacao()
	{
		String result;
		final int etx=0x03;

		try
		{
			URL urlDados = new URL( param.get_Middleware() + montaContexto());
			URLConnection connection = urlDados.openConnection();
			DataInputStream in = new DataInputStream( connection.getInputStream() );
			StringBuffer arq = new StringBuffer();
			try
			{
				while(true)
				{
					result = in.readLine();
					if(result.length() == 0) break;

					arq.append(result);
					if(result.indexOf(etx) > 0) break;
				}
			}
			catch (Exception ex) {};
			in.close();
			String status = param.xml_get( arq.toString(),"ERR_MENS" );
			int erro = Integer.parseInt( param.xml_get( arq.toString(),"ERR" ) );
			if( status != null )
			{
				if ( status.equals("OK") )
				{
					JOptionPane.showMessageDialog(null, "Cliente cadastrado com sucesso !", "Sucesso!",
										JOptionPane.INFORMATION_MESSAGE);
				}
				else
				{
					JOptionPane.showMessageDialog(null, "Erro no cadastramento !", "Aviso", JOptionPane.ERROR_MESSAGE);
				}
			}
			else
			{
				JOptionPane.showMessageDialog(null, "Sem resposta", "Erro", JOptionPane.ERROR_MESSAGE);
			}
		}
		catch(MalformedURLException mue)
		{
			System.out.println("Illegal URL: " + mue);
		}
		catch(IOException ioe)
		{
			System.out.println("IOException: " + ioe);
		}
		catch(Exception e)
		{
			System.out.println("Error: " + e);
		}
	}

	/************************************************
	- Consulta celular e carrega as informaes na tela
	*************************************************/
	private void consultaCadastro( String pNome )
	{
		String result;
		String contexto = "?param=<TRANSACAO>100</TRANSACAO><USERID>"
					+ pNome.toString() + "</USERID>+<PASSWD></PASSWD>+<GERENTE>S</GERENTE>"	+ param.getCtrl();

		contexto = contexto.replace( ' ','+' );

		final int etx=0x03;

		try
		{
			URL urlDados = new URL(param.get_Middleware() + contexto);
			URLConnection connection = urlDados.openConnection();
			DataInputStream in = new DataInputStream(connection.getInputStream());
			StringBuffer arq = new StringBuffer();
			try
			{
				while(true)
				{
					result = in.readLine();
					if(result.length() == 0) break;

					arq.append(result);
					if(result.indexOf(etx) > 0) break;
				}
			}
			catch (Exception ex) {};
			in.close();

			String status = param.xml_get(arq.toString(),"ERR_MENS");
			int erro = Integer.parseInt(param.xml_get(arq.toString(),"ERR"));
			if(status != null)
			{
				if ( status.equals("OK") )
					mostraInformacao(arq.toString());
				else
				{
					JOptionPane.showMessageDialog(null, "Usuario no cadastrado !", "Aviso",
						JOptionPane.WARNING_MESSAGE);
				}
			}
			else
			{
				JOptionPane.showMessageDialog(null, "Sem resposta", "Erro", JOptionPane.ERROR_MESSAGE);
			}
		}
		catch(MalformedURLException mue)
		{
			System.out.println("Illegal URL: " + mue);
		}
		catch(IOException ioe)
		{
			System.out.println("IOException: " + ioe);
		}
		catch(Exception e)
		{
			System.out.println("Error: " + e);
		}
	}

	private String montaContexto()
	{
		String contexto;
		StringBuffer wbuf = new StringBuffer();

		wbuf.append( "?param=" );
		wbuf.append( param.xml_transac( 101 ) );
		wbuf.append( param.xml_str( "USERID",txtDados[ 0 ].getText() ) );
		wbuf.append( param.xml_str( "NOM",txtDados[ 1 ].getText().toUpperCase() ) );

		if( txtDados[ 2 ].getText().length() <= 0 )
			wbuf.append( param.xml_str( "PASS",resetSenha( txtDados[ 5 ].getText() ) ) );
		else
			wbuf.append( param.xml_str( "PASS",txtDados[ 2 ].getText() ) );

		wbuf.append( param.xml_str( "MAIL",txtDados[ 3 ].getText().toLowerCase() ) );
		wbuf.append( param.xml_str( "RG",txtDados[ 4 ].getText() ) );
		wbuf.append( param.xml_str( "CPF",txtDados[ 5 ].getText() ) );
		wbuf.append( param.xml_str( "EMPRESA",txtDados[ 8 ].getText().toUpperCase() ) );

		if( rdbAtivo.isSelected() == true )
			wbuf.append( param.xml_str( "ATIVO","S" ) );
		else
			wbuf.append( param.xml_str( "ATIVO","N" ) );
		if( chkGerente.isSelected() == true )
			wbuf.append( param.xml_str( "GERENTE","S" ) );
		else
			wbuf.append( param.xml_str( "GERENTE","N" ) );

		wbuf.append( param.xml_str( "USER",getLoginCad() ) );

		contexto = wbuf.toString();

		contexto = contexto.replace( ' ','+' );
		contexto = contexto.replace( '\n','+' );

		return contexto;
	}

	/*******************************
	- Mostra as informaes nos campos
	********************************/
	private void mostraInformacao( String buffer )
	{
		txtDados[ 0 ].setText( param.xml_get( buffer,"ACES" ) );
		txtDados[ 1 ].setText( param.xml_get( buffer,"NOM" ) );
		txtDados[ 2 ].setText( param.xml_get( buffer,"PASS" ) );
		txtDados[ 3 ].setText( param.xml_get( buffer,"MAIL" ) );
		txtDados[ 4 ].setText( param.xml_get( buffer,"RG" ) );
		txtDados[ 5 ].setText( param.xml_get( buffer,"CPF" ) );
		txtDados[ 6 ].setText( param.xml_get( buffer,"DTCAD" ) );
		txtDados[ 7 ].setText( param.xml_get( buffer,"DTALT" ) );
		txtDados[ 8 ].setText( param.xml_get( buffer,"EMPRESA" ) );
		if( param.xml_get( buffer,"ATIVO" ).equals( "S" ) )
			rdbAtivo.setSelected( true );
		else
			rdbDesativo.setSelected( true );

		if( param.xml_get( buffer,"GERENTE" ).equals( "S" ) )
			chkGerente.setSelected( true );
		else
			chkGerente.setSelected( false );

		txtDados[ 9 ].setText( param.xml_get( buffer,"USER" ) );

		bttReset.setEnabled( true );

		repaint();
	}

	/*********************************
	 - Classe para tratamento das acoes
	   do botao
	*********************************/
	public class ClickRadioButton implements ItemListener
	{
		public void itemStateChanged( ItemEvent e )
		{
			String wtipo = btgStatus.getSelection().getActionCommand();
			int wEscolha = Integer.parseInt( wtipo );

			int widx;
			int windex;
		}
	}

	/*********************************
	 - Set padrao Windows
	*********************************/
	private void changeLookAndFeel( )
	{
		try
		{
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
			SwingUtilities.updateComponentTreeUI(this);

		}
		catch( Exception e ){}
	}

	public void clearDados()
	{
		for( int widx = 0; widx < 10; widx++ )
		{
			txtDados[ widx ].setText( "" );
		}

		txtDados[ 9 ].setText( getLoginCad() );

		chkGerente.setSelected( false );
		rdbAtivo.setSelected( true );

		txtDados[ 1 ].requestFocus();

		bttReset.setEnabled( false );
	}

	public String resetSenha( String pCPF )
	{
		return pCPF.substring( 0,pCPF.length() - 2 );
	}

	public String getLoginCad()
	{
		return getParameter("login");
	}

	public void setLinha( String puserid )
	{
		consultaCadastro( puserid );
		txtDados[0].setText( puserid );
	}

	public class MyPoupUp extends PoupUp
	{
		private Usuario clsUsuario;

		public MyPoupUp( Usuario xUsuario )
		{
			super();

			clsUsuario = xUsuario;

			setColumnAddElement( "Login" );
			setColumnAddElement( "             Usurio             " );
			setColumnAddElement( "      CPF      " );
			montaPoupUp();

			setTitulo( "Busca de Usurio" );
			setTexto( "Digite o usurio:" );
			setTransacao( 103 );
			setTagSet( "NOM" );
			setTagGet( "NOM" );

		}

		public void setShow()
		{
			super.setShow();
		}

		public String getLinha()
		{
			String wuserid = super.getLinha();

			clsUsuario.setLinha( wuserid );

			return wuserid;
		}
	}
}
