import java.awt.*;
import java.net.*;
import java.awt.event.*;
import java.awt.Label;
import java.awt.TextField;
import java.applet.Applet;
import java.applet.AppletContext;

public class Aviso extends Applet
{
	private Button btOk;
	private Dimension size;
	private URL newDocument;
	private String url;
	private Mensagem msg;
	private static final Parametro param = new Parametro();

	private Font lbl_font = new Font("Arial", Font.ITALIC, 12);
	private Font msg_font = new Font("Arial", Font.PLAIN, 12);

	public final static Color BG = Color.lightGray;
	public final static Color FG = Color.black;

	public void init()
	{
		String tit, mensagem, url;

		size = getSize();

		// Obtem parametros
		tit = getParameter("titulo");
		mensagem = getParameter("mensagem");
		url = getParameter("url");

		btOk = new Button();
		btOk.setLabel("Ok");
		btOk.setEnabled(true);
		btOk.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					pagina();
				}
			});

		Titulo titulo = new Titulo(tit, 20, 20);
		msg = new Mensagem(mensagem);

		Panel panelSup = new Panel(new BorderLayout(5,5));
		panelSup.add(titulo, BorderLayout.NORTH);
		panelSup.add(msg, BorderLayout.CENTER);

		Panel panelInf = new Panel(new FlowLayout(FlowLayout.CENTER));
		panelInf.add(btOk);

		setLayout(new BorderLayout(5,5));
		add (panelSup, BorderLayout.NORTH);
		add (panelInf, BorderLayout.SOUTH);

		setBackground(BG);
		setForeground(FG);
		setSize(size);

		// Cria a URL
		try
		{
			if (url == null) url = param.get_homeLogin()+param.getCtrl();
			newDocument = new URL(url);
		}
		catch (Exception e)
		{
			newDocument = null;
			msg.setMensagem("falhou url...");
		}
	}

	// Retorna para pagina designada
	private void pagina()
	{
		// Cria a URL
		try
		{
			if (newDocument != null)
			{
				AppletContext browser = getAppletContext();
				browser.showDocument ( newDocument, param.TARGET_WINDOW );
			}
		}
		catch (Exception e)
		{
			msg.setMensagem("Falhou url...");
		}
		newDocument = null;
	}

	//
	private class Mensagem extends Panel
	{
		private Dimension sizeP;
		private Label lblMsg;

		public Mensagem(String mens)
		{
			int mHeight, mWidth;

			mHeight = (int)(size.height * 0.5);
			mWidth = (int)(size.width);

			sizeP = new Dimension(mWidth, mHeight);
			lblMsg = new Label(mens);

			setLayout(new FlowLayout());
			add(lblMsg);
			setSize(sizeP);
		}

		public Dimension getPreferredSize()
		{
			return getMinimumSize();
		}

		public Dimension getMinimumSize()
		{
			return sizeP;
		}

		public void paint (Graphics g)
		{
			update(g);
		}

		public void update(Graphics g)
		{
			g.setColor(Color.blue);
			g.drawRoundRect(1, 1, sizeP.width - 3, sizeP.height - 3, 10, 10);
		}

		public Insets getInsets()
		{
			return new Insets(5,5,5,5);
		}

		public void setMensagem(String mens)
		{
			lblMsg.setText(mens);
		}
	}
}
