/*******************************
 Solicitao ao PPS

 Autor:	Edivaldo (S-Tecno)

 Data:	28 jan 2002
*******************************/
import java.io.*;
import java.net.*;
import java.awt.*;

public class ClientSock
{
	private DataOutputStream output;
	private DataInputStream input;
	private String dadosSock;
	private static final Parametro param = new Parametro();
	private static final Character STX = new Character('');
	private static final Character ETX = new Character('');


	public String runClient() throws Exception
	{
		Socket client;

		dadosSock = "";
		try
		{
			// Step 1: Create a Socket to make connection.
			client = new Socket( InetAddress.getByName( param.get_remoteHost() ), param.get_remotePort() );
			output = new DataOutputStream( client.getOutputStream() );
			input = new DataInputStream( client.getInputStream() );

			// Step 2: Process connection.
			try
			{
				recvData();
			}
			catch ( ClassNotFoundException cnfex )
			{
				logOcorrencia( cnfex.toString() );
				throw new Exception(cnfex.toString());
			}

			// Step 3: Close connection.
			output.close();
			input.close();
			client.close();
			return dadosSock;
		}
		catch ( EOFException eof )
		{
			logOcorrencia( eof.toString() );
			throw new Exception( "Server terminated connection" );
		}
		catch ( IOException e )
		{
			logOcorrencia( e.toString() );
			throw new Exception( e.toString() );
		}
	}

	//Aguarda resposta do PPS
	private void recvData() throws IOException, Exception
	{
		String message = "";
		byte caract;

		byte etx = 0x03;

		int x = 0;

		try
		{
			do
			{
				caract = input.readByte();
				if (caract == etx )	break;
				message += (char) caract;
				x++;
			} while ( caract != etx);
		}
		catch ( IOException ioe)
		{
			throw ioe;
		}
		catch ( Exception e)
		{
			throw e;
		}

		dadosSock = message;
	}

	//Procura o fim da mensagem
	private boolean achouFimMensagem(String aux)
	{
		int etx = 0x03;
		if(aux.indexOf(etx) == -1)
			return false;
		else
			return true;
	}

	// Log de ocorrencias
	private void logOcorrencia(String msg)
	{
		if (msg.length() > 0)
		{
			try
			{
				MLog l = new MLog( param.get_logFile() );
				l.gravaMsg("ClientPPS> " + msg + "\n");
				l=null;
			}
			catch (Exception e) {};
		}
	}
}