import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.applet.*;

public class Espia extends Applet
{
	private static final Parametro param = new Parametro();

	private Dimension dimension;

	private boolean acionarAlarme;

	public void init()
	{
		Status status;
		Titulo titulo;

		dimension = new Dimension(900,500);

		// Set/Reset tipo de panel;
		param.set_panelMaster(false);
		String panel = getParameter("panel");

		if(panel != null) if(panel.equals("1"))	param.set_panelMaster(true);

		String dadosEspia = getParameter("dados");

		if(param.get_panelMaster())
			status = new Status("Respostas acima de 8 segundos so criticas",20,20);
		else
			status = new Status(".",20,20);

		String data = param.xml_get(dadosEspia, "DATA");
		String aux = "ltima monitorao ocorreu "+
						data.substring(6,8)+"/"+
						data.substring(4,6)+"/"+
						data.substring(0,4)+" "+
						data.substring(8,10)+":"+
						data.substring(10,12)+":"+
						data.substring(12);
		titulo = new Titulo(aux,20,20);

		Panel pMaqDados = new Panel(new GridLayout(1,5,2,2));
		Panel pMaqTitulo = new Panel(new GridLayout(1,5,2,2));

		setAlarme(false);
		for(int m=0; m<5; m++)
		{
			String maqLabel = "MAQ"+m;
			String maqValor = param.xml_get(dadosEspia, maqLabel);

			if (maqValor.length() > 0)
			{
				Maquina maq = new Maquina(maqValor, this);
				pMaqDados.add(maq);
				pMaqTitulo.add(maq.getPLabel());
			}
		}

		// Obtem chaves
		String chaves = param.xml_get(dadosEspia, "CHV");
		Hora hora = new Hora(chaves);

		// Cria a panel de dados
		Panel pDados = new Panel(new BorderLayout(2,2));
		pDados.add(hora, BorderLayout.WEST);
		pDados.add(pMaqDados, BorderLayout.CENTER);

		// Cria a panel de header
		Panel pHeader = new Panel(new BorderLayout(2,2));
		pHeader.add(hora.getPLabel(), BorderLayout.WEST);
		pHeader.add(pMaqTitulo, BorderLayout.CENTER);
		Label lbAster = new Label("");
		lbAster.setBackground(Color.blue);
		lbAster.setForeground(Color.yellow);
		pHeader.add(lbAster, BorderLayout.EAST);

		// Cria o cursor somente para a rea de dados
		Panel pScroll = new Panel(new BorderLayout(0,0));
		ScrollDados scroll = new ScrollDados(true, false, new Dimension(886,600), new Dimension(886,400));
		scroll.add(pDados);
		pScroll.add(scroll, BorderLayout.CENTER);

		// Cria a panel geral
		Panel pGeral = new Panel(new BorderLayout(2,2));
		pGeral.add(pHeader, BorderLayout.NORTH);
		pGeral.add(pScroll, BorderLayout.CENTER);

		// Incluir tudo no applet
		setLayout(new BorderLayout(5,5));
		add (titulo, BorderLayout.NORTH);
		add (pGeral, BorderLayout.CENTER);
		add (status, BorderLayout.SOUTH);

		setBackground(Color.gray);
		setForeground(param.FG1);

		setSize(dimension);

		// Dispara o alarme se houver problema
		alarme();
	}

	public Dimension getPreferredSize()
	{
		return dimension;
	}

	public Dimension getMinimumSize()
	{
		return dimension;
	}

	public Dimension getMaximumSize()
	{
		return dimension;
	}

	// Alarme
	public void alarme()
	{
		if (getAlarme())
		{
			AudioClip sound = getAudioClip(getCodeBase(), param.audioAlarme);
			if(sound != null) sound.play();
		}
	}

	public boolean getAlarme()
	{
		return acionarAlarme;
	}

	public void setAlarme(boolean alarme)
	{
		acionarAlarme=alarme;
	}
}
