/****************************************
Classe responsvel para o registro do Log
****************************************/

import java.io.*;

public class MLog
{
	private String projeto;
	private DataOutputStream output;

	// Construtor
	public MLog(String proj) throws Exception
	{
		projeto = proj.trim().toUpperCase();

		if ( projeto.length() == 0)
		{
			throw new Exception("Lenght of project is null");
		}
	}

	// Inserir mensagem
	public void gravaMsg(String msg) throws IOException
	{
		// Consiste o tamanho da mensagem
		if ( msg.length() == 0)
		{
			throw new IOException("Lenght of message is null");
		}

		try
		{
			openOutputFile();
			addText(msg);
		}
		catch( IOException e)
		{
			throw e;
		}
	}

	// Abre o arquivo
	private void openOutputFile() throws IOException
	{
		String fileName = projeto + ".log";

		try
		{
			output = new DataOutputStream( new FileOutputStream( fileName, true ) );
		}
		catch ( IOException e )
		{
			throw e;
		}
	}

	// Adiciona dados no arquivo
	private void addText(String xMsg) throws IOException
	{
		try
		{
			output.writeBytes(xMsg);
			output.flush();
		}
		catch ( IOException e )
		{
			throw e;
		}
	}

	// Fecha o arquivo
	private void closeOutputFile() throws IOException
	{
		try
		{
			output.close();
		}
		catch ( IOException e )
		{
			throw e;
		}
	}
}
