import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.*;

class Maquina extends Panel
{
	private static final Parametro param = new Parametro();
	private static final Color BG_BLUE = Color.blue;
	private static final Color FG_GREEN = Color.green;
	private static final Color FG_BLACK = Color.black;
	private static final Color FG_WHITE = Color.white;
	private static final Color BG_LIGHT_GRAY = Color.black;
	private static final Color FG_ORANGE = Color.white;
	private static final Color FG_RED = Color.red;
	private static final Font FONTE0 = new Font("Arial", Font.BOLD + Font.PLAIN, 10);
	private static final Font FONTE1 = new Font("Arial", Font.BOLD + Font.PLAIN, 12);
	private static final Font FONTE2 = new Font("Ariel", Font.BOLD, 14);

	private Panel pLabel;

	public Maquina(String maqValor, Espia espia)
	{
		int pos, tam;
		boolean panelMaster = param.get_panelMaster();

		setLayout(new BorderLayout(1,1));
		setFont(param.FONTE1);
		setBackground(Color.gray);

		pos=0;
		String maqNome = param.getSubstring(maqValor, pos).trim();
		pos=pos+maqNome.length()+1;

		String maqPorta = param.getSubstring(maqValor, pos).trim();
		pos=pos+maqPorta.length()+1;

		pLabel = new Panel( new GridLayout(4,1,2,2) );
		pLabel.setBackground(Color.gray);

		// Nome do servico
		Panel pServico = new Panel (new BorderLayout(2,2));
		Label lblServ = new Label(getServico(maqNome, maqPorta), Label.CENTER);
		lblServ.setFont(FONTE2);
		lblServ.setBackground(BG_BLUE);
		lblServ.setForeground(FG_GREEN);
		pServico.add(lblServ);
		pLabel.add(pServico);

		// Header Principal
		Panel pHeader = new Panel (new BorderLayout(2,2));
		Label lblMaq = new Label(maqNome+" ("+maqPorta+")", Label.CENTER);
		lblMaq.setFont(FONTE1);
		lblMaq.setBackground(BG_BLUE);
		lblMaq.setForeground(FG_GREEN);
		pHeader.add(lblMaq);
		pLabel.add(pHeader);

		// Ttulo
		Panel pTitulo = new Panel (new GridLayout(1,2,1,1));
		Label titQtd = new Label("Teste(%)", Label.CENTER);
		titQtd.setFont(FONTE1);
		titQtd.setBackground(Color.blue);
		titQtd.setForeground(Color.yellow);
		pTitulo.add(titQtd);

		// Consiste tipo de Panel
		if(panelMaster)
		{
			Label titTempo = new Label("Tempo(Seg)", Label.CENTER);
			titTempo.setFont(FONTE1);
			titTempo.setBackground(Color.blue);
			titTempo.setForeground(Color.yellow);
			pTitulo.add(titTempo);
		}
		pLabel.add(pTitulo);

		// Sub-Ttulo
		Panel pSubTitulo= new Panel (new GridLayout(1,2,1,1));
		Panel pSubTitulo1= new Panel (new GridLayout(1,2,1,1));
		Label stitErro = new Label("Erro", Label.CENTER);
		stitErro.setFont(FONTE0);
		stitErro.setBackground(Color.blue);
		stitErro.setForeground(Color.yellow);

		Label stitOk = new Label("Ok", Label.CENTER);
		stitOk.setFont(FONTE0);
		stitOk.setBackground(Color.blue);
		stitOk.setForeground(Color.yellow);
		pSubTitulo1.add(stitErro);
		pSubTitulo1.add(stitOk);
		pSubTitulo.add(pSubTitulo1);

		// Consiste tipo de Panel
		if(panelMaster)
		{
			Panel pSubTitulo2= new Panel (new GridLayout(1,2,1,1));
			Label stitTmin = new Label("Min.", Label.CENTER);
			stitTmin.setFont(FONTE0);
			stitTmin.setBackground(Color.blue);
			stitTmin.setForeground(Color.yellow);

			Label stitTmax = new Label("Max.", Label.CENTER);
			stitTmax.setFont(FONTE0);
			stitTmax.setBackground(Color.blue);
			stitTmax.setForeground(Color.yellow);
			pSubTitulo2.add(stitTmin);
			pSubTitulo2.add(stitTmax);
			pSubTitulo.add(pSubTitulo2);
		}
		pLabel.add(pSubTitulo);

		Panel pmatriz = new Panel( new GridLayout(30,1,1,1) );
		pmatriz.setBackground(Color.gray);

		tam=maqValor.length();
		for(int h=0;; h++)
		{
			try
			{
				int q_erro, q_ok, vstatus;
				long tmin, tmax;

				// ltimo
				String ultimo = param.getSubstring(maqValor, pos);
				pos = pos + ultimo.length()+1;

				// Obtem qtd. de transaes com erros
				String qtd_erro = param.getSubstring(maqValor, pos);
				pos = pos + qtd_erro.length()+1;

				try
				{
					Integer oqtd_erro = new Integer(qtd_erro);
					q_erro = oqtd_erro.intValue();
				}
				catch (NumberFormatException nfe)
				{
					q_erro = 0;
				}

				// Obtem qtd. de transaes sem erros
				String qtd_ok = param.getSubstring(maqValor, pos);
				pos = pos + qtd_ok.length()+1;

				try
				{
					Integer oqtd_ok = new Integer(qtd_ok);
					q_ok = oqtd_ok.intValue();
				}
				catch (NumberFormatException nfe)
				{
					q_ok = 0;
				}

				// Obtem o Status da Transao
				String status = param.getSubstring(maqValor, pos);
				pos = pos + status.length()+1;

				try
				{
					Integer ostatus = new Integer(status);
					vstatus = ostatus.intValue();
				}
				catch (NumberFormatException nfe)
				{
					vstatus = 0;
				}

				// Obtem o tempo mnimo da transao
				String temp_min = param.getSubstring(maqValor, pos);
				pos = pos + temp_min.length()+1;

				try
				{
					Long lmin = new Long(temp_min);
					tmin = lmin.longValue();
				}
				catch (NumberFormatException nfe)
				{
					tmin = 0;
				}

				// Obtem o tempo mximo da transao
				String temp_max = param.getSubstring(maqValor, pos);
				pos = pos + temp_max.length()+1;

				try
				{
					Long lmax = new Long(temp_max);
					tmax = lmax.longValue();
				}
				catch (NumberFormatException nfe)
				{
					tmax = 0;
				}

				PanelResult pResult =
				new PanelResult(ultimo, q_erro, q_ok, vstatus, tmin, tmax, espia, panelMaster);
				pmatriz.add(pResult);

				if (pos >= tam) break;
			}
			catch (IndexOutOfBoundsException e)
			{
				break;
			};
		}

		add(pmatriz, BorderLayout.CENTER);
		setSize(100,400);
	}

	// Devolve o panel Label
	public Panel getPLabel()
	{
		return pLabel;
	}

	// Obtem o nome do servico
	public String getServico(String maq, String port)
	{
		if(maq.equals("gaivota"))
		{
			if(port.equals("5110")) return "PPS (SmallPayment)";
			if(port.equals("5112")) return "PPS (C/C.Cliente)";
		}

		if(maq.equals("tcel_spo_n3"))
			if(port.equals("9691")) return "P2K";

		if(maq.equals("uplinkdb1"))
			if(port.equals("5030")) return "WapGateway";

		if(maq.equals("autos"))
			if(port.equals("800")) return "Autos";

		return "???";
	}
}
