import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.*;

class PanelResult extends Panel
{
	private static final Font FONTE0 = new Font("Arial", Font.BOLD + Font.PLAIN, 10);

	private boolean lastError, lastOk;
	private int q_erro, q_ok, status;
	private long tmin, tmax;
	private static final long TEMPO_MAXIMO = 8000000;
	private Color verde = new Color(13,101,13);
	private Color vermelho = new Color(214,21,21);

	public PanelResult(String ultimo, int erro, int ok, int stt, long min, long max, Espia espia, boolean panelMaster)
	{
		lastError=lastOk=false;
		if(ultimo.equals("E"))
			lastError=true;
		else
			if(ultimo.equals("O"))
				lastOk=true;

		q_erro = erro;
		q_ok = ok;
		status = stt;
		tmin = min;
		tmax = max;

		setLayout(new GridLayout(1,4,1,1));
		setBackground(Color.gray);

		Label lblErro = new Label("");
		Button btErro = new Button("");
		if(q_erro == 0)
		{
			lblErro.setBackground(Color.lightGray);
			lblErro.setForeground(Color.red);
			lblErro.setFont(FONTE0);
		}
		else
		{
			String aux = percentual((double) (q_erro * 100) / (q_erro + q_ok));
			btErro.setBackground(Color.lightGray);
			btErro.setForeground(Color.red);
			if (lastError)
			{
				aux = aux+" *";
				btErro.setForeground(vermelho);
			}
			btErro.setLabel(aux);
			btErro.setFont(FONTE0);
			btErro.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					StringBuffer buf = new StringBuffer();
					buf.append("Cdigo do ltimo erro=");
					buf.append(status);
					buf.append("\n");
					buf.append("Descricao=");
					buf.append( getDescrErro(status));
					buf.append("\n");
					buf.append("Qtd. testes com sucesso=");
					buf.append(q_ok);
					buf.append("\n");
					buf.append("Qtd. testes com erro=");
					buf.append(q_erro);
					FrameMensag msg = new FrameMensag("Erro", buf.toString());
				}
			});
		}

		Label lblOk = new Label("", Label.CENTER);
		lblOk.setBackground(Color.lightGray);
		lblOk.setForeground(Color.black);
		lblOk.setFont(FONTE0);
		if (q_ok != 0)
		{
			String aux = percentual((double) (q_ok * 100) / (q_erro + q_ok));
			if (lastOk)
			{
				aux = aux+ " *";
				lblOk.setForeground(verde);
			}
			lblOk.setText(aux);
		}

		if (q_erro == 0)
			add(lblErro);
		else
			add(btErro);

		add(lblOk);

		// Consiste tipo de pgina
		if(panelMaster)
		{
			Label lblTmin = new Label("", Label.CENTER);
			lblTmin.setBackground(Color.lightGray);
			lblTmin.setForeground(Color.black);
			lblTmin.setFont(FONTE0);
			if(tmin != 0)
			{
				lblTmin.setText(customFormat(tmin));
			}
			if(tmin > TEMPO_MAXIMO)
			{
				lblTmin.setForeground(Color.red);
				espia.setAlarme(true);
			}

			Label lblTmax = new Label("", Label.CENTER);
			lblTmax.setBackground(Color.lightGray);
			lblTmax.setForeground(Color.black);
			lblTmax.setFont(FONTE0);
			if(tmax != 0)
			{
				lblTmax.setText(customFormat(tmax));
			}
			if(tmax > TEMPO_MAXIMO)
			{
				lblTmax.setForeground(Color.red);
				espia.setAlarme(true);
			}
			add(lblTmin);
			add(lblTmax);
		}
	}

	private String customFormat(long val)
	{
		String pattern = "##0.000";
		double value = (double) val / 1000000;
		DecimalFormat myFormatter = new DecimalFormat(pattern);
		return (myFormatter.format(value));
	}

	private String percentual(double val)
	{
		String pattern = "##0.0";
		DecimalFormat myFormatter = new DecimalFormat(pattern);
		return (myFormatter.format(val));
	}

	private String getDescrErro(int erro)
	{
		switch(erro)
		{
			case 0:
				return "APROVADO_E_SEM_ERROS";
			case -1:
				return "SEM_RESPOSTA_AUTOS";
			case -2:
				return "SEM_RESPOSTA_PPS";
			case -3:
				return "SEM_RESPOSTA_P2K";
			case -4:
				return "SEM_RESPOSTA_WAP";
			case -5:
				return "CELULAR_NAO_ENCONTRADO";
			case -6:
				return "CELULAR_NAO_ACTIVO";
			case -7:
				return "CELULAR_EM_ESTADO_INCOMPATIVEL";
			case -8:
				return "NAO_CADASTRADO_WAP";
			case -9:
				return "NAO_CADASTRADO_P2K";
			case -10:
				return "TIPO_DOCUM_DESCONHECIDO";
			case -11:
				return "DOCUMENTO_NAO_CORRESPONDE";
			case -12:
				return "CLIENTE_SEM_CADASTRO";

			// Falhas de comunicacao
			case -70:
				return "Socket invalido";
			case -71:
				return "Erro no socket";
			case -72:
				return "Erro na criao do socket";
			case -73:
				return "Nome de host invlido";
			case -74:
				return "Falha na conexo do socket";
			case -75:
				return "Erro ao enviar dados via socket";
			case -76:
				return "Erro na recepo de dados via socket";
			case -77:
				return "ACKNOLEGE ERROR";
			case -78:
				return "ANSWER ERROR";
			case -79:
				return "Falha no comando Listen";
			case -80:
				return "Falha no comando Bind";
			case -81:
				return "Falha ao configurar o socket";
			default:
				return " ";
		}
	}
}
