import java.awt.*;
import java.applet.Applet;

class Status extends Panel
{
	String mensag;
	Dimension size;
	Font lbl_font = new Font("Arial", Font.BOLD + Font.ITALIC, 12);
	Font msg_font = new Font("Arial", Font.BOLD + Font.PLAIN, 12);
	int width, height;

	public Status(String msg, int initialWidth, int initialHeight)
	{
		width=initialWidth;
		height=initialHeight;
		size = new Dimension(width,height);
		mensag = msg;
	}

	public Dimension getPreferredSize()
	{
		return getMinimumSize();
	}

	public Dimension getMinimumSize()
	{
		return size;
	}

	public void paint (Graphics g)
	{
		update(g);
	}

	public void update(Graphics g)
	{
		Dimension d = getSize();
		width = (int) d.width;
		height = (int) d.height;

		g.setColor(Color.lightGray);
		g.fill3DRect(0, 0, d.width - 1, d.height - 1, true);

		g.setColor(Color.black);
		g.setFont(lbl_font);
		g.drawString("Status: ",3,12);
		g.setColor(Color.red);
		g.setFont(msg_font);
		g.drawString(mensag,45,12);
	}

	public void setMensag(String msg)
	{
		mensag = msg;
		repaint();
	}
}
