/*******************************
 Solicitao ao PPS

 Autor:	Edivaldo (S-Tecno)

 Data:	28 jan 2002
*******************************/
import java.io.*;
import java.net.*;
import java.awt.*;

public class ClientPPS
{
	private DataOutputStream output;
	private DataInputStream input;
	private String dadosPPS;
	private static final Parametro param = new Parametro();
	private static final Character STX = new Character('');
	private static final Character ETX = new Character('');

	public String teste(String mensagem) throws Exception
	{
		logOcorrencia(mensagem);
		if (mensagem.length() == 0) throw new Exception("teste");
		return ("<STATUS>OK</STATUS>");
	}

	public String runClient(String mensagem) throws Exception
	{
		Socket client;

		logOcorrencia(mensagem);
		dadosPPS = "";
		try
		{
			// Step 1: Create a Socket to make connection.
			client = new Socket( InetAddress.getByName( param.get_remoteHost() ), param.get_remotePort() );
			output = new DataOutputStream( client.getOutputStream() );
			input = new DataInputStream( client.getInputStream() );

			System.out.println("senData="+mensagem);

			//Envia solicitacao ao PPS
			try
			{
				sendData(mensagem);
			}
			catch (IOException ioe)
			{
				logOcorrencia( ioe.toString() );
				throw new Exception(ioe.toString());
			}

			System.out.println("vai ler...");

			// Step 3: Process connection.
			try
			{
				recvData();
			}
			catch ( ClassNotFoundException cnfex )
			{
				logOcorrencia( cnfex.toString() );
				throw new Exception(cnfex.toString());
			}

			System.out.println("leu="+dadosPPS);

			// Step 4: Close connection.
			output.close();
			input.close();
			client.close();
			return dadosPPS;
		}
		catch ( EOFException eof )
		{
			logOcorrencia( eof.toString() );
			throw new Exception( "Server terminated connection" );
		}
		catch ( IOException e )
		{
			logOcorrencia( e.toString() );
			throw new Exception( e.toString() );
		}
	}

	//Formata e envia solicitao ao PPS
	private void sendData( String mensagem ) throws IOException
	{
		System.out.println("sendData=" + mensagem);

		try
		{
			output.writeBytes ( STX.charValue() + mensagem + ETX.charValue() + "\n" );
			output.flush();
		}
		catch ( IOException cnfex )
		{
			throw cnfex;
		}
	}

	//Aguarda resposta do PPS
	private void recvData() throws IOException, Exception
	{
		String message = "";
		byte caract;

		byte etx = 0x03;

		int x = 0;

		try
		{
			do
			{
				caract = input.readByte();
System.out.println(caract);
				if (caract == etx )
				{
					System.out.println("achou ETX\n");
					break;
				}
				message += (char) caract;
				x++;
			} while ( caract != etx);
		}
		catch ( IOException ioe)
		{
			throw ioe;
		}
		catch ( Exception e)
		{
			throw e;
		}

System.out.println("message = "+ message);
		dadosPPS = message;
	}

	//Procura o fim da mensagem
	private boolean achouFimMensagem(String aux)
	{
		int etx = 0x03;
		if(aux.indexOf(etx) == -1)
			return false;
		else
			return true;
	}

	// Log de ocorrencias
	private void logOcorrencia(String msg)
	{
		System.out.println(param.get_logFile());
		if (msg.length() > 0)
		{
			try
			{
				MLog l = new MLog( param.get_logFile() );
				l.gravaMsg("ClientPPS> " + msg + "\n");
				l=null;
			}
			catch (Exception e) {};
		}
	}
}