import java.awt.*;
import java.util.Calendar;
import java.util.Date;
import java.text.SimpleDateFormat;

class Dias extends Panel
{
	Dimension size;
	Font lbl_font = new Font("Arial", Font.BOLD + Font.PLAIN, 14);
	Font msg_font = new Font("Arial", Font.BOLD + Font.PLAIN, 12);
	int width, height;

	public final static int LBL_ALTURA = 14;
	public final static int LBL_LARGURA = 60;
	public final static int GAP = 2;

	SimpleDateFormat semana = new SimpleDateFormat ("E");

	public Dias(int initialWidth, int initialHeight)
	{
		width=initialWidth;
		height=initialHeight;
		size = new Dimension(width,height);
	}

	public Dimension getPreferredSize()
	{
		return getMinimumSize();
	}

	public Dimension getMinimumSize()
	{
		return size;
	}

	public void paint (Graphics g)
	{
		update(g);
	}

	public void update(Graphics g)
	{
		int linhaS, linhaG, coluna, colunaVal;

		Dimension d = getSize();
		width = (int) d.width;
		height = (int) d.height;

		g.setColor(Color.lightGray);
		g.fill3DRect(0, 0, d.width - 1, d.height - 1, true);

		g.setColor(Color.yellow);
		g.drawRoundRect(5, 5, d.width - 10, d.height - 10, 10, 10);

		g.setColor(Color.black);
		g.setFont(lbl_font);

		coluna=10;
		linhaS=linhaG=12;
		g.drawString("ltimos 7 dias",coluna,linhaS);
		linhaS+=22;
		linhaG+=10;

		g.setFont(msg_font);

		Calendar cal = Calendar.getInstance();
		for(int pos = 0; pos<7; pos++)
		{
			g.setColor(Color.blue);
			g.fill3DRect(coluna, linhaG, LBL_LARGURA, LBL_ALTURA, true);
			g.setColor(Color.white);
			g.drawString(semana.format( cal.getTime() ),coluna+2,linhaS);

			colunaVal = coluna+LBL_LARGURA+GAP;
			g.setColor(Color.magenta);
			g.fill3DRect(colunaVal, linhaG, LBL_LARGURA, LBL_ALTURA, true);
			g.setColor(Color.black);
			g.drawString("0",colunaVal+2,linhaS);

			linhaS=linhaS+LBL_ALTURA+GAP;
			linhaG=linhaG+LBL_ALTURA+GAP;

			cal.add(Calendar.DATE, -1);
		}

		g.setColor(Color.blue);
		g.fill3DRect(coluna, linhaG, LBL_LARGURA, LBL_ALTURA, true);
		g.setColor(Color.white);
		g.drawString("Total",coluna+2,linhaS);

		colunaVal = coluna+LBL_LARGURA+GAP;
		g.setColor(Color.magenta);
		g.fill3DRect(colunaVal, linhaG, LBL_LARGURA, LBL_ALTURA, true);
		g.setColor(Color.black);
		g.drawString("999",colunaVal+2,linhaS);
	}
}
