import java.awt.*;
import java.awt.event.*;

public class Filtro extends Frame implements ActionListener, ItemListener
{
	private static final Parametro param = new Parametro();

	private List lstBanco, lstPerfil;
	private Button btConf, btCanc;
	public static final String DISABLE = "disable";
	public static final String ENABLE = "enable";
	private String banco[], perfil[];
	private Status status;
	private Titulo titulo;
	private Resultado resultado;

	private String cBanco, cPerfil;

	public Filtro(String bc[], String pf[], Resultado res)
	{
		super("Perfil");

		int index, max;

		banco = bc;
		perfil = pf;
		resultado = res;
		cBanco=cPerfil=null;

		// Fabrica o panel para status
		status = new Status("...",20,20);

		Label lblBanco = new Label("Banco", Label.CENTER);
		lblBanco.setBackground(param.BG1);
		lblBanco.setForeground(param.FG1);
		lblBanco.setFont(param.FONTE1);

		Label lblPerfil = new Label("Perfil", Label.CENTER);
		lblPerfil.setBackground(param.BG1);
		lblPerfil.setForeground(param.FG1);
		lblPerfil.setFont(param.FONTE1);

		Panel panelLbl = new Panel(new GridLayout(1,3,10,10));
		panelLbl.add(lblBanco);
		panelLbl.add(lblPerfil);

		// Bancos
		max = banco.length;
		lstBanco = new List(max, false);
		lstBanco.setBackground(param.BG1);
		lstBanco.setForeground(param.FG1);
		lstBanco.setFont(param.FONTE2);
		lstBanco.addActionListener(this);
		lstBanco.addItemListener(this);
		for(int i=0; i<max; i++)
		{
			try
			{
				lstBanco.add(param.getSubDescr(banco[i]));
			}
			catch (Exception e)
			{
				System.out.println(e.toString());
			}
		}

		// Perfis
		max = perfil.length;
		lstPerfil = new List(max, false);
		lstPerfil.setBackground(param.BG1);
		lstPerfil.setForeground(param.FG1);
		lstPerfil.setFont(param.FONTE2);
		lstPerfil.addActionListener(this);
		lstPerfil.addItemListener(this);
		for(int i=0; i<max; i++)
		{
			try
			{
				lstPerfil.add(param.getSubDescr(perfil[i]));
			}
			catch (Exception e)
			{
				System.out.println(e.toString());
			}
		}

		// Fabrica panel para os indicadores
		Panel panelInd = new Panel(new GridLayout(1,3,10,10));
		panelInd.add(lstBanco);
		panelInd.add(lstPerfil);

		// Boto para confirmao
		btConf = new Button();
		btConf.setLabel("Confirma");
		btConf.setActionCommand(DISABLE);
		btConf.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					if (cBanco != null) resultado.setBanco(cBanco);
					if (cPerfil != null) resultado.setPerfil(cPerfil);
					resultado.getFiltro();
					dispose();
				}
			});

		// Boto para cancelamento
		btCanc = new Button();
		btCanc.setLabel("Cancel.");
		btCanc.setActionCommand(DISABLE);
		btCanc.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					dispose();
				}
			});

		// Fabrica panel para botoes
		Panel panelCmd = new Panel(new FlowLayout(FlowLayout.CENTER, 10, 10));
		panelCmd.add(btConf);
		panelCmd.add(btCanc);

		// Fabrica o panel superior
		Panel panelSuperior = new Panel(new BorderLayout(5,5));
		panelSuperior.add(panelLbl, BorderLayout.NORTH);
		panelSuperior.add(panelInd, BorderLayout.CENTER);
		panelSuperior.add(panelCmd, BorderLayout.SOUTH);

		// Monta o panel principal
		setLayout(new BorderLayout(5,5));
		add(panelSuperior, BorderLayout.CENTER);
		add(status, BorderLayout.SOUTH);

		setBackground(param.BG1);
		setForeground(param.FG1);

		// Centraliza o frame
		setSize(500,300);
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension frameSize = getSize();
		setLocation ( (screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);

		setResizable(false);
		addWindowListener(new WindowAdapter()
			{
				public void windowClosing(WindowEvent e)
				{
					dispose();
				}
            });

		show();
	}

	public void actionPerformed(ActionEvent e)
	{
		List list = (List)(e.getSource());
		selecao(list, list.getSelectedItem());
	}

	public void itemStateChanged(ItemEvent e)
	{
		List list = (List)(e.getItemSelectable());

		int index = ((Integer)(e.getItem())).intValue();
		selecao(list, list.getItem(index));
	}

	public void selecao(List list, String descr)
	{
		int idx;

		btConf.setEnabled(true);
		btConf.setActionCommand(ENABLE);

		idx = list.getSelectedIndex();

		try
		{
			if(list == lstPerfil)		cPerfil=param.getSubChave(perfil[idx]);
			else if(list == lstBanco)	cBanco=param.getSubChave(banco[idx]);
			setStatus();
		}
		catch (Exception e)
		{
			System.out.println(e.toString());
		}
	}

	private void setStatus()
	{
		if (cBanco == null) cBanco="";
		if (cPerfil == null) cPerfil="";

		status.setMensag( cBanco+"/"+cPerfil );
	}
}
