// HTTPGetResultado.java
// Creating and sending a page to the client
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class HTTPGetResultado extends HttpServlet
{
	private Parametro param = new Parametro();

	public void doGet( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException
	{
		PrintWriter output;
		String indicador, titulo, banco, perfil;

		indicador = request.getParameter("indicador");
		titulo = request.getParameter("titulo");
		banco = request.getParameter("banco");
		perfil = request.getParameter("perfil");

		if (indicador == null) indicador="";
		if (titulo == null) titulo="";
		if (banco == null) banco="";
		if (perfil == null) perfil="";

		response.setContentType( "text/html" );		// content type
		response.setHeader ("Pragma", "no-cache");
		response.setHeader ("Cache-Control", "no-cache");
		output = response.getWriter();				// get writer

		// create and send HTML page to client
		StringBuffer buf = new StringBuffer();

		// Nao cria uma sessao (false) se uma nao existir
		HttpSession session = request.getSession(false);
		if(session == null)
		{
			buf.append( param.get_HTML_Interromper("Aviso", "No exite sesso habilitada"));
		}
		else
		{
			try
			{
				String aux = getResultado(indicador, titulo, banco, perfil, session);
				buf.append( aux );
			}
			catch (Exception e)
			{
				log(e.toString());

				String username = (String) session.getValue("username");
				String codErro = param.getCodigoErro(e.getMessage());
				String descrErro = param.getDescricaoErro(e.getMessage());
				buf.append( param.get_HTML_Resultado(codErro, descrErro, username) );

			}
		}

		buf.append( param.get_HTML_Fim() );
		System.out.println( buf.toString() );

      	output.println( buf.toString() );
		output.close();							// close PrintWriter stream
	}

	// Obtem lista de resultados
	private String getResultado(String indicador, String titulo, String xbanco, String xperfil, HttpSession session) throws Exception
	{
		String aux;
		StringBuffer buf;

		buf = new StringBuffer();
		buf.append( param.xml_ini() );
		buf.append( param.xml_str("INDICADOR", indicador) );
		buf.append( param.xml_str("BANCO", xbanco) );
		buf.append( param.xml_str("PERFIL", xperfil) );
		buf.append( param.xml_transac(2) );

		ClientPPS pps = new ClientPPS();

		try
		{
			String resp = pps.runClient(buf.toString());
			pps = null;
			String status = param.xml_get(resp, "STATUS");

			System.out.println("status="+status);
			if ( !(status.equals("OK") || status.equals("-5")) )
			{
				String mens_erro = param.xml_get(resp, "ERR_MENS");
				throw new Exception( mens_erro );
			}

			buf = new StringBuffer();
			buf.append( param.get_HTML_Inicio( param.get_Titulo(), getRotulo(session)) );
			buf.append( param.get_codeResultado() );

			aux = param.xml_get(resp, "LISTA");
			buf.append( param.criaParam("indicador", 0, indicador));
			buf.append( param.criaParam("lista", 0, aux));
			buf.append( param.criaParam("titulo", 0, titulo));

			if ((xbanco.length() > 0) || (xperfil.length() > 0))
			{
				String xFiltro;
				xFiltro = "(" + xbanco + "/" + xperfil +")";
				buf.append( param.criaParam("filtro", 0, xFiltro));
			}

			String banco = (String) session.getValue("banco");
			String perfil = (String) session.getValue("perfil");

			buf.append( param.criaParam("banco", 0, banco));
			buf.append( param.criaParam("perfil", 0, perfil));

			System.out.println( buf.toString() );
			return buf.toString();
		}
		catch (Exception e)
		{
			throw e;
		}
	}

	private String getRotulo(HttpSession session)
	{
		return ("sessions.id: " + session.getId() + "<br>\n" +
				"created: " + new Date(session.getCreationTime()) + "<br>\n" +
				"lastaccessed: " + new Date(session.getLastAccessedTime()) + "<br>\n");
	}
}
