// Obtem lista de Indicadores
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class HTTPGetSaldoTipo extends HttpServlet
{
	private Parametro param = new Parametro();
	public void doGet( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException
	{

	System.out.println("Chamou o HTTPGetIndicadores...");

		try
		{
			doPost(request, response);
		}
		catch (ServletException se)
		{
			log(se.toString());
			throw se;
		}
		catch (IOException ioe)
		{
			log(ioe.toString());
			throw ioe;
		}
	}

	public void doPost( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException
	{
		PrintWriter output;
		String resp, saldotipo, banco, perfil;

		response.setContentType( "text/html" );		// content type
		response.setHeader ("Pragma", "no-cache");
		response.setHeader ("Cache-Control", "no-cache");
		output = response.getWriter();				// get writer

		// create and send HTML page to client
		StringBuffer buf = new StringBuffer();

		// Nao cria uma sessao (false) se uma nao existir
		HttpSession session = request.getSession(false);
		if(session == null)
		{
			buf.append( param.get_HTML_Interromper("Aviso", "No exite sesso habilitada"));
		}
		else
		{
			// Obtem lista de SaldoTipo
			try
			{
				resp = obtemSaldoTipo();

				session.removeValue("banco");
				session.removeValue("perfil");

				saldotipo = param.xml_get(resp, "SALDOTIPO");
				banco = param.xml_get(resp, "BANCO");
				perfil = param.xml_get(resp, "PERFIL");

				session.putValue("banco", banco);
				session.putValue("perfil", perfil);

				buf.append( param.get_HTML_Inicio( param.get_Titulo(), getRotulo(session)) );
				buf.append( param.get_codeIndicadores() );
				buf.append( param.criaParam("saldotipo", 0, saldotipo));
			}
			catch (Exception e)
			{
				buf.append( param.get_HTML_Interromper("Aviso", e.getMessage()) );
			}
		}

		buf.append( param.get_HTML_Fim() );
      	output.println( buf.toString() );
		output.close();							// close PrintWriter stream
	}

	// Obtem lista de SaldoTipo no PPS
	private String obtemSaldoTipo() throws Exception
	{
		StringBuffer buf = new StringBuffer();

		buf.append( param.xml_ini() );
		buf.append( param.xml_transac(1) );

		ClientPPS pps = new ClientPPS();

		try
		{
			String resp = pps.runClient(buf.toString());
			pps = null;
			String status = param.xml_get(resp, "STATUS");

			System.out.println("status="+status);
			if ( !status.equals("OK") )
			{
				String mens_erro = param.xml_get(resp, "ERR_MENS");
				throw new Exception( mens_erro );
			}

			return resp;
		}
		catch (Exception e)
		{
			throw e;
		}
	}

	private String getRotulo(HttpSession session)
	{
		return ("sessions.id: " + session.getId() + "<br>\n" +
				"created: " + new Date(session.getCreationTime()) + "<br>\n" +
				"lastaccessed: " + new Date(session.getLastAccessedTime()) + "<br>\n");
	}
}
