// Fig. 19.5: HTTPGetHomeValidaLogin.java
// Creating and sending a page to the client
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class HTTPGetValidaLogin extends HttpServlet
{
	private Parametro param = new Parametro();
	public void doGet( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException
	{

	System.out.println("Chamou o HTTPGetHomeValidaLogin...");

		try
		{
			doPost(request, response);
		}
		catch (ServletException se)
		{
			log(se.toString());
			throw se;
		}
		catch (IOException ioe)
		{
			log(ioe.toString());
			throw ioe;
		}
	}

	public void doPost( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException
	{
		PrintWriter output;
		String usuario, senha, username, saldotipo, resp, banco, perfil;
		HttpSession session;




		session=null;
		usuario = request.getParameter("usuario");
		senha = request.getParameter("senha");

		response.setContentType( "text/html" );		// content type
		response.setHeader ("Pragma", "no-cache");
		response.setHeader ("Cache-Control", "no-cache");
		output = response.getWriter();				// get writer

		// create and send HTML page to client
		StringBuffer buf = new StringBuffer();

		if(usuario == null || senha == null)
		{
			buf.append( param.get_HTML_Interromper("Aviso", "Usuario/Senha invalido..."));
		}
		else
		{
			// Valida login com o PPS
			try
			{
				resp = validaSenha(usuario, senha);

				username = param.xml_get(resp, "USERNAME");
				saldotipo = param.xml_get(resp, "SALDOTIPO");
				banco = param.xml_get(resp, "BANCO");
				perfil = param.xml_get(resp, "PERFIL");

System.out.println("saldotipo="+saldotipo);

				// Cria uma sessao (verdadeira) se nao existir uma
				try
				{
					session = request.getSession(true);
					session.removeValue("usuario");
					session.removeValue("senha");
					session.removeValue("username");
					session.removeValue("banco");
					session.removeValue("perfil");

					session.putValue("usuario", usuario);
					session.putValue("senha", senha);
					session.putValue("username", username);
					session.putValue("banco", banco);
					session.putValue("perfil", perfil);

					buf.append( param.get_HTML_Inicio( param.get_Titulo(), getRotulo(session)) );
					buf.append( param.get_codeIndicadores() );
					buf.append( param.criaParam("saldotipo", 0, saldotipo));
				}
				catch (Exception e)
				{
					log(e.toString());
					buf.append( param.get_HTML_Interromper("Erro", "Falhou sessao"));
				}
			}
			catch (Exception e)
			{
				buf.append( param.get_HTML_Interromper("Aviso", e.getMessage()) );
			}
		}

		buf.append( param.get_HTML_Fim() );
      	output.println( buf.toString() );
		output.close();							// close PrintWriter stream
	}

	private String validaSenha(String usuario, String senha) throws Exception
	{
		StringBuffer buf = new StringBuffer();

		buf.append( param.xml_ini() );
		buf.append( param.xml_str("USER", usuario) );
		buf.append( param.xml_str("PASSWD", senha) );
		buf.append( param.xml_transac(3) );

		ClientPPS pps = new ClientPPS();

		try
		{
			String resp = pps.runClient(buf.toString());
			pps = null;
			String status = param.xml_get(resp, "STATUS");

			System.out.println("status="+status);
			if ( !status.equals("OK") )
			{
				String mens_erro = param.xml_get(resp, "ERR_MENS");
				throw new Exception( mens_erro );
			}

			return resp;
		}
		catch (Exception e)
		{
			throw e;
		}
	}

	private String getRotulo(HttpSession session)
	{
		return ("sessions.id: " + session.getId() + "<br>\n" +
				"created: " + new Date(session.getCreationTime()) + "<br>\n" +
				"lastaccessed: " + new Date(session.getLastAccessedTime()) + "<br>\n");
	}
}
