import java.net.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.List;
import java.applet.AppletContext;
import java.applet.Applet;

public class Indicadores extends Applet implements ActionListener, ItemListener
{
	private static final Parametro param = new Parametro();

	private List lst;
	private Button btConf;

	private Vector siteNames;
	private URL newDocument;

	private int colunas;
	private Status status;
	private Titulo titulo;
	private String contexto;

	private int colunaSel;

	public void init()
	{
		newDocument = null;
		siteNames = new Vector();
		lst = new List(4, false);	// preferencia visvel 4 itens
		lst.addActionListener(this);
		lst.addItemListener(this);

		System.out.println( retValue("100"));

		// Fabrica o panel para status
		status = new Status("...",20,20);

		// Fabrica o panel para o titulo
		titulo = new Titulo("Movimentos do PPS",20,20);

		try
		{
			getParametros();
		}
		catch (Exception e)
		{
			System.out.println(e.toString());
		}

		// Fabrica o panel para confirmao
		Image image = getImage(getCodeBase(), param.LOGO2);
		Logo2 logo = new Logo2(image, this, 50, 50);

		btConf = new Button();
		btConf.setLabel("Confirma");
		btConf.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					obtemDadosPPS();
				}
			});

		Panel panelConf = new Panel(new BorderLayout(20,20));
		panelConf.add(logo, BorderLayout.NORTH);
		panelConf.add(btConf, BorderLayout.SOUTH);

		// Fabrica o panel superior
		Panel panelSuperior = new Panel(new BorderLayout(5,5));
		panelSuperior.add(lst, BorderLayout.CENTER);
		panelSuperior.add(panelConf, BorderLayout.EAST);

		// Monta o panel principal
		setLayout(new BorderLayout(5,5));
		add(titulo, BorderLayout.NORTH);
		add(panelSuperior, BorderLayout.CENTER);
		add(status, BorderLayout.SOUTH);

		setBackground(param.BG1);
		setForeground(param.FG1);

		colunaSel = -1;
	}

	public String getAppletInfo()
	{
		return "Demonstrates the different types of layout managers.";
	}

	public void actionPerformed(ActionEvent e)
	{
		List list = (List)(e.getSource());
		int index = list.getSelectedIndex();

		String codigo = (String) siteNames.elementAt(index);

		contexto =	"?indicador=" + codigo +
					"&titulo=" +  list.getSelectedItem();

		setStatus( "Index= " + index + " Codigo=" + codigo);
	}

	public void itemStateChanged(ItemEvent e) {}

	public void setStatus(String aux)
	{
		status.setMensag(aux);
	}

	// Obtem dados do PPS
	private void obtemDadosPPS()
	{
		// Cria a URL
		try
		{
			System.out.println (param.get_Resultado()+contexto+param.getCtrl());
			newDocument = new URL(param.get_Resultado()+contexto+param.getCtrl());
			AppletContext browser = getAppletContext();
			browser.showDocument ( newDocument, param.TARGET_WINDOW );
		}
		catch (Exception e)
		{
			System.out.println("URL Invalido");
		}
	}

	private String retValue(String val)
	{
		Character aspasDuplas = new Character('"');
		return ("value=" + aspasDuplas + val.trim() + aspasDuplas);
	}

	// Copia parametros de HTML
	private void getParametros() throws Exception
	{
		String saldotipo, result, codigo, descr;
		int pos, idx;

		saldotipo = getParameter("saldotipo");
		if (saldotipo == null)
			throw new Exception ("Parametro inexistente");

		// Carrega parametros
		pos=0;
		codigo="";
		descr="";
		do
		{
			try
			{

				result = param.getSubstring(saldotipo, pos);

				if (result.length() == 0) break;

				idx = result.indexOf("=");
				if (idx > 0)
				{
					codigo = result.substring(0, idx);
					descr = result.substring(idx+1);

					lst.add ( descr.trim().toLowerCase() );
					siteNames.addElement( codigo );
				}

				pos +=result.length()+1;
			}
			catch (Exception e)
			{
				throw e;
			}
		}
		while(pos < saldotipo.length());
	}
}
