import java.net.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.applet.AppletContext;
import java.util.Calendar;
import java.util.Date;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.text.DecimalFormat;

public class Resultado extends Applet
{
	private static final Parametro param = new Parametro();
	private URL newDocument;

	private List lst;
	private Button btRefresh, btFiltro, btGrafico, btListagem, btDado;

	static final String DISABLE = "disable";
	static final String ENABLE = "enable";
	static final String HAB_QTD = "Qtd.";
	static final String HAB_VALOR = "Valor";
	private Status status;
	private Titulo titulo;
	private DecimalFormat decimalFormat;

	private String cIndicador, cBanco, cPerfil, cTitulo;

	private String vDia[], vSem[], vMes[], vBanco[], vPerfil[];
	final static Color bg = Color.lightGray;
	final static Color fg = Color.black;
	final static Color lb_bg = Color.orange;
	final Font lb_fonte = new Font("Ariel", Font.BOLD, 14);

	public void init()
	{
		String descr;

		decimalFormat = new DecimalFormat(param.DECIMAL_FORMAT);
		try
		{
			getParametros();
			getBancos();
			getPerfis();
		}
		catch (Exception e)
		{
			System.out.println( e.toString() );
		}

		cBanco=cPerfil="";
		setBanco("");
		setPerfil("");

		TabResult dias = new TabResult("ltima semana", vDia,140,80);
		TabResult semanas = new TabResult("ltimas 4 semanas", vSem,140,80);
		TabResult meses = new TabResult("ltimos 4 meses", vMes,140,80);

		Panel ppp = new Panel(new GridLayout(1,3));
		ppp.add(dias);
		ppp.add(semanas);
		ppp.add(meses);

		btRefresh = new Button();
		btRefresh.setLabel("Refresh");
		btRefresh.setEnabled(false);
		btRefresh.setActionCommand(DISABLE);
		btRefresh.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					refresh();
				}
			});

		btFiltro = new Button();
		btFiltro.setLabel("Filtro");
		btFiltro.setActionCommand(ENABLE);
		btFiltro.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					filtro();
				}
			});

		btGrafico = new Button();
		btGrafico.setLabel("Grfico");
		btGrafico.setActionCommand(ENABLE);
		btGrafico.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					String command = e.getActionCommand();

					if (command == DISABLE)
					{
						btGrafico.setEnabled(true);
						btGrafico.setActionCommand(ENABLE);
					}
					else
					{
						btGrafico.setEnabled(false);
						btGrafico.setActionCommand(DISABLE);
					}
				}
			});

		btListagem = new Button();
		btListagem.setLabel("Listagem");
		btListagem.setActionCommand(ENABLE);
		btListagem.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					String command = e.getActionCommand();

					if (command == DISABLE)
					{
						btListagem.setEnabled(true);
						btListagem.setActionCommand(ENABLE);
					}
					else
					{
						btListagem.setEnabled(false);
						btListagem.setActionCommand(DISABLE);
					}
				}
			});

		btDado = new Button();
		btDado.setLabel(HAB_QTD);
		btDado.setActionCommand(HAB_QTD);
		btDado.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					String command = e.getActionCommand();

					if (command == HAB_VALOR)
					{
						btDado.setActionCommand(HAB_QTD);
						btDado.setLabel(HAB_QTD);
					}
					else
					{
						btDado.setActionCommand(HAB_VALOR);
						btDado.setLabel(HAB_VALOR);
					}
				}
			});

		Panel panelCmd = new Panel(new GridLayout(1,5,10,10));
		panelCmd.add(btRefresh);
		panelCmd.add(btFiltro);
		panelCmd.add(btGrafico);
		panelCmd.add(btListagem);
		panelCmd.add(btDado);

		Panel panelMiolo = new Panel(new BorderLayout(10,10));
		panelMiolo.add(ppp, BorderLayout.CENTER);
		panelMiolo.add(panelCmd, BorderLayout.SOUTH);

		setLayout(new BorderLayout(5,5));
		add (panelMiolo, BorderLayout.CENTER);

		// Fabrica o titulo
		cTitulo = getParameter("titulo");
		descr=cTitulo;
		String xFiltro = getParameter("filtro");
		if (xFiltro != null) descr += " " + xFiltro;

		if (descr == null)
			titulo = new Titulo("???",20,20);
		else
			titulo = new Titulo(descr,20,20);
		add (titulo, BorderLayout.NORTH);

		status = new Status("...",20,20);
		add (status, BorderLayout.SOUTH);

		setBackground(bg);
		setForeground(fg);
	}

	public String getAppletInfo()
	{
		return "Demonstrates the different types of layout managers.";
	}

	/**********************
	 Obtem lista de Bancos
	**********************/
	private void getBancos() throws Exception
	{
		int colunas, pos, idx;
		String buf, result;

		buf = getParameter("banco");
		if (buf == null)
			throw new Exception ("Parametro inexistente");

		// Qtd. de colunas
		pos=colunas=0;
		do
		{
			try
			{
				result = param.getSubstring(buf, pos);

				if (result.length() == 0) break;
				idx = result.indexOf("=");
				if (idx == -1) break;

				pos +=result.length()+1;
				colunas++;
			}
			catch (Exception e)
			{
				throw e;
			}
		}
		while(pos < buf.length());

		// Cria vetor
		vBanco = new String[colunas+1];

		pos=colunas=0;
		do
		{
			try
			{
				result = param.getSubstring(buf, pos);
				if (result.length() == 0) break;
				idx = result.indexOf("=");
				if (idx == -1) break;

				vBanco[colunas++] = result;
				pos +=result.length()+1;
			}
			catch (Exception e)
			{
				throw e;
			}
		}
		while(pos < buf.length());
	}

	/**********************
	 Obtem lista de Perfil
	**********************/
	private void getPerfis() throws Exception
	{
		int colunas, pos, idx;
		String buf, result;

		buf = getParameter("perfil");
		if (buf == null)
			throw new Exception ("Parametro inexistente");

		// Qtd. de colunas
		pos=colunas=0;
		do
		{
			try
			{
				result = param.getSubstring(buf, pos);

				if (result.length() == 0) break;
				idx = result.indexOf("=");
				if (idx == -1) break;

				pos +=result.length()+1;
				colunas++;
			}
			catch (Exception e)
			{
				throw e;
			}
		}
		while(pos < buf.length());

		// Cria vetor
		vPerfil = new String[colunas];

		pos=colunas=0;
		do
		{
			try
			{
				result = param.getSubstring(buf, pos);

				if (result.length() == 0) break;
				idx = result.indexOf("=");
				if (idx == -1) break;

				vPerfil[colunas++] = result;
				pos +=result.length()+1;
			}
			catch (Exception e)
			{
				throw e;
			}
		}
		while(pos < buf.length());
	}

	public void setBanco(String bc)
	{
		cBanco = bc;
	}

	public void setPerfil(String pf)
	{
		cPerfil = pf;
	}

	public String getFiltro()
	{
		String stt;
		if (cBanco == null) cBanco="";
		if (cPerfil == null) cPerfil="";

		stt = cBanco+"/"+cPerfil;
		status.setMensag(stt);

		btRefresh.setEnabled(true);
		btRefresh.setActionCommand(ENABLE);

		btFiltro.setEnabled(false);
		btFiltro.setActionCommand(DISABLE);

		btGrafico.setEnabled(false);
		btGrafico.setActionCommand(DISABLE);

		btListagem.setEnabled(false);
		btListagem.setActionCommand(DISABLE);

		btDado.setEnabled(false);
		btDado.setActionCommand(DISABLE);

		return (stt);
	}

	public void filtro()
	{
		Filtro filtro = new Filtro(vBanco, vPerfil, this);
	}

	// Refaz a tela de resultados
	public void refresh()
	{
		String contexto =	param.get_Resultado()+
							"?indicador=" + cIndicador +
							"&titulo=" + cTitulo +
							"&banco=" + cBanco +
							"&perfil=" + cPerfil+param.getCtrl();

		System.out.println(contexto);
		// Cria a URL
		try
		{
			newDocument = new URL(contexto);
			AppletContext browser = getAppletContext();
			browser.showDocument ( newDocument, param.TARGET_WINDOW );
		}
		catch (Exception e)
		{
			System.out.println("URL Invalido");
		}
	}

	// Obtm Parmetros
	private void getParametros() throws Exception
	{
		cIndicador = getParameter("indicador");


System.out.println("cIndicador="+cIndicador);


		String buf = getParameter("lista");
		if (buf == null)
			throw new Exception ("Parametro inexistente");

		SimpleDateFormat formatInt, formatDia, formatSemana, formatMes;
		DateFormat df;
		Calendar cal;
		int dia;

		try
		{
			formatInt = new SimpleDateFormat("yyyyMMdd");
			formatDia = new SimpleDateFormat("dd/MMM E");
			formatSemana = new SimpleDateFormat("W'a.Sem'/MMM");
			formatMes = new SimpleDateFormat("MMM/yyyy");

			df = formatInt.getDateInstance();
			cal = Calendar.getInstance();
		}
		catch (Exception e)
		{
			System.out.println(e.toString());
			throw e;
		}

		int intDia[] = new int[8];
		int intSem[] = new int[5];
		int intMes[] = new int[5];
		String strDia[] = new String[8];
		String strSem[] = new String[5];
		String strMes[] = new String[5];
		Date hoje = new Date(System.currentTimeMillis());

		try
		{
			// Obtm as datas da ltima semana
			cal.setTime(hoje);
			dia = cal.get(Calendar.DAY_OF_WEEK);
			for(;dia > 1; dia--)
			{
				cal.add(Calendar.DATE, -1);
			}

			for(int idx=0; idx < 8; idx++)
			{
				Integer aux = new Integer(formatInt.format(cal.getTime()));
				intDia[idx] = aux.intValue();
				strDia[idx] = formatDia.format(cal.getTime());
				System.out.println("Dias.="+intDia[idx]+" - "+strDia[idx]);
				cal.add(Calendar.DATE, 1);
			}

			// Obtm os datas das ltimas 4 semanas
			cal.setTime(hoje);
			dia = cal.get(Calendar.DAY_OF_WEEK);
			for(;dia > 1; dia--)
			{
				cal.add(Calendar.DATE, -1);
			}

			for(int idx=0; idx < 5; idx++)
			{
				Integer aux = new Integer(formatInt.format(cal.getTime()));
				intSem[idx] = aux.intValue();
				strSem[idx] = formatSemana.format(cal.getTime());
				System.out.println("Semana="+intSem[idx]+" - "+strSem[idx]);
				cal.add(Calendar.WEEK_OF_MONTH, -1);
			}

			// Obtm as datas dos ltimos 4 meses
			cal.setTime(hoje);
			cal.set(Calendar.DAY_OF_MONTH, 1);
			for(int idx=0; idx < 5; idx++)
			{
				Integer aux = new Integer(formatInt.format(cal.getTime()));
				intMes[idx] = aux.intValue();
				strMes[idx] = formatMes.format(cal.getTime());
				System.out.println("Meses.="+intMes[idx]+" - "+strMes[idx]);
				cal.add(Calendar.MONTH, -1);
			}
		}
		catch (Exception e)
		{
			System.out.println(e.toString());
		}

		// Carrega parametros
		int pos, idx, datax;
		double totDia[] = new double[8];
		double totSem[] = new double[5];
		double totMes[] = new double[5];
		double total;
		String result;

		// Inicializa acumuladores
		for (idx=0; idx<8; idx++)
		{
			totDia[idx]=0.0;
			if(idx < 5)
			{
				totSem[idx]=0.0;
				totMes[idx]=0.0;
			}
		}

		pos=0;
		do
		{
			try
			{
				result = param.getSubstring(buf, pos);

				if (result.length() == 0) break;
				idx = result.indexOf("=");
				if (idx == -1) break;

				Integer data = new Integer( result.substring(0, idx) );
				Double valor = new Double( result.substring(idx+1) );
				datax = data.intValue();

				for(idx=0; idx < 7; idx++)
				{
					// Acumula totais do dia
					if(datax == intDia[idx])
						totDia[idx] += valor.doubleValue();

					if(idx < 4)
					{
						// Acumula totais da semana
						if(datax >= intSem[idx])
						{
							if ((idx == 0) || (datax > intSem[idx+1]))
							{
								totSem[idx] += valor.doubleValue();
							}
						}

						// Acumula totais do mes
						if(datax >= intMes[idx])
						{
							if ((idx == 0) || (datax > intMes[idx+1]))
							{
System.out.println("datax="+datax+" "+intMes[idx]+"-"+intMes[idx+1]+ "-->"+idx);
								totMes[idx] += valor.doubleValue();
							}
						}
					}
				}
				pos +=result.length()+1;
			}
			catch (Exception e)
			{
				throw e;
			}
		}
		while(pos < buf.length());

		// Fabrica resultados do Dia
		vDia = new String[16];
		idx = 0;
		total = 0;
		for (int i=0; i < 7; i++)
		{
			vDia[idx++] = strDia[i];
			vDia[idx++] = getString( totDia[i] );
			total += totDia[i];
		}
		vDia[idx++] = "Total";
		vDia[idx++] = getString( total );

		// Fabrica resultados da Semana
		vSem = new String[10];
		idx = 0;
		total = 0;
		for (int i=0; i < 4; i++)
		{
			vSem[idx++] = strSem[i];
			vSem[idx++] = getString( totSem[i] );
			total += totSem[i];

			System.out.println(i+" - "+strSem[i]+" - "+totSem[i]);
		}
		vSem[idx++] = "Total";
		vSem[idx++] = getString( total );
		System.out.println("vSem="+idx);

		// Fabrica resultados dos Meses
		vMes = new String[10];
		idx = 0;
		total = 0;
		for (int i=0; i < 4; i++)
		{
			vMes[idx++] = strMes[i];
			vMes[idx++] = getString( totMes[i] );
			total += totMes[i];

			System.out.println(i+" - "+strMes[i]+" - "+totMes[i]);
		}
		vMes[idx++] = "Total";
		vMes[idx++] = getString( total );
		System.out.println("vMes="+idx);
	}

	// Transforma int em String
	private String getString( int val)
	{
		Integer aux;

		try
		{
			aux = new Integer(val);
		}
		catch (NumberFormatException nfe)
		{
			System.out.println(nfe.toString());
			aux = new Integer("0");
		}

		return decimalFormat.format(aux.intValue());
	}

	// Transforma float em String
	private String getString( double val)
	{
		Double aux;

		try
		{
			aux = new Double(val);
		}
		catch (NumberFormatException nfe)
		{
			System.out.println(nfe.toString());
			aux = new Double("0");
		}

		return decimalFormat.format(aux.doubleValue());
	}
}
