import java.awt.*;
import java.util.Vector;

class TabResult extends Panel
{
	private Dimension size;
	private Font lbl_font = new Font("Arial", Font.BOLD + Font.PLAIN, 12);
	private Font msg_font = new Font("Arial", Font.BOLD + Font.PLAIN, 12);
	private int width, height;

	private String titulo;
	private String[] dados;

	public final static int LBL_ALTURA = 14;
	public final static int LBL_LARGURA = 87;
	public final static int GAP = 2;

	public TabResult(String tit, String dad[], int initialWidth, int initialHeight)
	{
		titulo = tit;
		dados = dad;
		width=initialWidth;
		height=initialHeight;
		//size = new Dimension(width,height);
		size = getMaximumSize();
	}

	public Dimension getPreferredSize()
	{
		//return getMinimumSize();
		return getMaximumSize();
	}

	//public Dimension getMinimumSize()
	//{
	//	return size;
	//}

	public void paint (Graphics g)
	{
		update(g);
	}

	public void update(Graphics g)
	{
		int linhaS, linhaG, coluna, colunaVal, itens, index;

		Dimension d = getSize();
		width = (int) d.width;
		height = (int) d.height;

		g.setColor(Color.lightGray);
		g.fill3DRect(0, 0, d.width - 1, d.height - 1, true);

		g.setColor(Color.yellow);
		g.drawRoundRect(5, 5, d.width - 10, d.height - 10, 10, 10);

		g.setColor(Color.black);
		g.setFont(lbl_font);

		coluna=10;
		linhaS=linhaG=12;
		g.drawString(titulo,coluna,linhaS);
		linhaS+=22;
		linhaG+=10;

		g.setFont(msg_font);
		itens = dados.length / 2;
		index = 0;
		for(int pos = 0; pos<itens; pos++)
		{
			g.setColor(Color.blue);
			g.fill3DRect(coluna, linhaG, LBL_LARGURA, LBL_ALTURA, true);
			g.setColor(Color.white);
			g.drawString(dados[index],coluna+2,linhaS);

			index++;
			colunaVal = coluna+LBL_LARGURA+GAP;
			g.setColor(Color.magenta);
			g.fill3DRect(colunaVal, linhaG, LBL_LARGURA, LBL_ALTURA, true);
			g.setColor(Color.black);
			g.drawString(dados[index],colunaVal+2,linhaS);

			index++;
			linhaS=linhaS+LBL_ALTURA+GAP;
			linhaG=linhaG+LBL_ALTURA+GAP;
		}
	}
}
