//  RChart
//  Copyright (C)
//
//  RReport@Confluencia.net
//  All rights reserved
//
// Adquisition , use and distribution of this code is subject to restriction:
//  - You may modify the source code in order to adapt it to your needs.
//  - Redistribution of this ( or a modified version) source code is prohibited. You may only redistribute compiled versions.
//  - You may redistribute the compiled version as part of your application, not a new java component with the same purpose as this one.
//  - You may not remove this notice from the source code
//  - This notice disclaim all warranties of all material
//
package com.java4less.rchart;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class ChartApplet extends Applet implements ChartListener,MouseMotionListener,MouseListener
{
	public boolean isStandalone = false;
	boolean stopped=false;

	public Chart gChart=null;
	public java.awt.Image  tmpImage=null;

	// title
	String ptitle;
	String ptitleFont;
	String ptitleColor;

	// Scale
	Double pScaleYMin;
	Double pScaleXMin;
	Double pScaleXMax;
	Double pScaleYMax;
	Double pScaleY2Max;
	Double pScaleY2Min;

	// Axis
	boolean pAxisX;
	boolean pAxisY;
	boolean pAxisY2;

	boolean pbigTicksGridX;
	boolean pbigTicksGridY;
	boolean pbigTicksGridY2;

	Double scaleTickIntervalX;
	Double scaleTickIntervalY;
	Double scaleTickIntervalY2;

	Integer bigTickIntervalX;
	Integer bigTickIntervalY;
	Integer bigTickIntervalY2;
	int[] bigTickIntervalListX;
	int[] bigTickIntervalListY;
	int[] bigTickIntervalListY2;

	String pAxisXLabels;
	String pAxisYLabels;
	String pAxisY2Labels;

	String scaleLabelsFormatX="";
	String scaleLabelsFormatY="";
	String scaleLabelsFormatY2="";

	// label
	String Xlabel;
	String Ylabel;
	String Y2label;
	String XlabelFont;
	String YlabelFont;
	String Y2labelFont;
	String XlabelColor;
	String YlabelColor;
	String Y2labelColor;

	// Chart
	double pchartLeftMargin;
	double pchartTopMargin;
	double pchartLegendMargin;
	double pchartBottomMargin;
	double pchartSecondYAxisMargin;

	// tips configuration
	java.awt.Color tipColor=java.awt.Color.yellow;
	java.awt.Color tipFontColor=java.awt.Color.black;
	java.awt.Font tipFont=new java.awt.Font("Serif",Font.PLAIN,10);

	String plegendPosition;

	boolean interactive=false;
	public boolean paintDirect=true;

	// applet interactive features
	public boolean showTips=false;
	public boolean showPosition=false;
	public boolean activateHtmlLinks=false;
	public boolean triggerJavaScript=false;
	public String[][] tips= new String[MAX_SERIES][0]; //up to 5 series
	public String[][] htmlLinks= new String[MAX_SERIES][0]; //up to 5 series
	public String htmlLinkTarget="_new";

	String pSerie;
	String[] pSeriesNames= new String[MAX_SERIES];
	String[] pSeriesData= new String[MAX_SERIES];
	String[] pSeriesMaxData= new String[MAX_SERIES];
	String[] pSeriesMinData= new String[MAX_SERIES];
	String[] pSeriesCloseData= new String[MAX_SERIES];
	DataSerie[] pSeries= new DataSerie[MAX_SERIES];
	int pnumSeries=0;

	// legend
	boolean plegend;

	// parameters loaded from file or JScript
	String[] loadedParameters= new String[200]; // up to 200 parameters
	String[] loadedValues= new String[200];
	int loadedParametersCount=0;

	// used to detect if it has been resized
	private int lastWidth=-1;
	private int lastHeight=-1;

	private static final  int MAX_SERIES=50;

	Cursor handCursor=new Cursor(Cursor.HAND_CURSOR);
	Cursor pointerCursor=new Cursor(Cursor.DEFAULT_CURSOR);

	// configuration for realtime applet
	public long msecs=2000; // 2 second
	public boolean triggerJS=false;
	public String reloadFrom="";
	private chartD deamon=null;

	//Get a parameter value by type
	private boolean getBooleanParam(String Param,boolean def)
	{
		try
		{
			String s=this.getParameter(Param ,"");
			if (s.compareTo("")==0) return def;
			return  Boolean.valueOf(s).booleanValue();
		}
		catch(Exception e)
		{
			return def;
		}
	}

	private java.util.Date getDateParam(String Param,String def)
	{

		try
		{
			String s=this.getParameter(Param ,"");

			if (s.compareTo("")==0) s=def;

			if (s.compareTo("")==0) return null;

			java.text.SimpleDateFormat df= new java.text.SimpleDateFormat("dd-MM-yyyy");
			return df.parse(s);

		}
		catch(Exception e)
		{
			return null;
		}
	}

	private Integer getIntParam(String Param,Integer def)
	{

		try
		{
			String s=this.getParameter(Param ,"");
			if (s.compareTo("")==0) return def;
			return new Integer(s);
		}
		catch(Exception e)
		{
			return def;
		}
	}

	private Double getDoubleParam(String Param,Double def)
	{

		try
		{
			String s=this.getParameter(Param ,"");
			if (s.compareTo("")==0) return def;
			return new Double(s);
		}
		catch(Exception e)
		{
			return def;
		}
	}

	private String getStringParam(String Param,String def)
	{

		return this.getParameter(Param, def);

	}


	//Get a parameter value
	public String getParameter(String key, String def)
	{

		// loaded parameters have priority
		for (int i=0;i<loadedParametersCount;i++)
		{
			if (loadedParameters[i].compareTo(key)==0) return loadedValues[i];
		}

		// the applet is used in the servlet in order to read the parameters
		// do not call getParameter(key), it would trigger an exception
		if (isStandalone) return def;

		if (getParameter(key) != null) return getParameter(key);
		else return def;
	}

	private String[] convertList(String items)
	{
		return convertList(items,"|");
	}

	private String[] convertList(String items, String separator)
	{

		String[] itema=new String[5000];
		int itemCount=0;

		// count number of items
		int p=items.indexOf(separator);
		while (p>=0)
		{
			itema[itemCount++]=items.substring(0,p);
			items=items.substring(p+ separator.length(),items.length());
			p=items.indexOf(separator);
		}

		if (items.compareTo("")!=0) itema[itemCount++]=items;

		if (itemCount==0) return null;

		String[] result=new String[itemCount];
		for (int i=0;i<itemCount;i++) result[i]=itema[i];

		return result;

	}

	// item list
	private String[] getItemsParameter(String key)
	{
		String items=getStringParam(key,"");
		return convertList(items);

	}


	private java.awt.Color convertColor(String c)
	{
		if (c.compareTo("RED")==0) return java.awt.Color.red;
		if (c.compareTo("BLACK")==0) return java.awt.Color.black;
		if (c.compareTo("BLUE")==0) return java.awt.Color.blue;
		if (c.compareTo("CYAN")==0) return java.awt.Color.cyan;
		if (c.compareTo("DARKGRAY")==0) return java.awt.Color.darkGray;
		if (c.compareTo("GRAY")==0) return java.awt.Color.gray;
		if (c.compareTo("GREEN")==0) return java.awt.Color.green;
		if (c.compareTo("LIGHTGRAY")==0) return java.awt.Color.lightGray;
		if (c.compareTo("MAGENTA")==0) return java.awt.Color.magenta;
		if (c.compareTo("ORANGE")==0) return java.awt.Color.orange;
		if (c.compareTo("PINK")==0) return java.awt.Color.pink;
		if (c.compareTo("WHITE")==0) return java.awt.Color.white;
		if (c.compareTo("YELLOW")==0) return java.awt.Color.yellow;
		try
		{
			return java.awt.Color.decode(c);
		}
		catch (Exception e)
		{
			return java.awt.Color.black;
		}
	}

	// convert an applet parameter to a Font
	public java.awt.Font convertFont(String f)
	{

		String[] items=convertList(f);

		if (items==null) return null;

		if (items.length<3) return null;

		int s=java.awt.Font.PLAIN;
		if (items[1].compareTo("BOLD")==0) s=java.awt.Font.BOLD;
		if (items[1].compareTo("ITALIC")==0) s=java.awt.Font.ITALIC;

		try
		{
			return new java.awt.Font(items[0],s,new Integer(items[2]).intValue());
		}
		catch (Exception e) {return null;}

	}

	// convert an applet parameter to a FillStyle
	public FillStyle convertFillStyle(String f)
	{

		if (f.compareTo("")==0) return null;

		String[] items=convertList(f);

		if (items==null) return null;

		if (items.length<1) return null;


		// color
		java.awt.Color c=convertColor(items[0]);

		try
		{
			return new FillStyle(c);
		}
		catch (Exception e) {return null;}

	}

	private double[] convertDoubleList(String s)
	{
		String[] items=convertList(s);

		if (items==null) return null;

		double[] d=new double[items.length];

		for (int i=0; i<items.length;i++)
		{
			try
			{
				//if (items[i].toUpperCase().compareTo("NULL")==0)  d[i]=null;
				d[i]=new Double(items[i]).doubleValue();

			} catch (Exception e) {d[i]=0;}
		}

		return d;

	}

	private int[] convertIntList(String s)
	{
		String[] items=convertList(s);
		int[] d=new int[items.length];

		for (int i=0; i<items.length;i++)
		{
			try
			{
				//if (items[i].toUpperCase().compareTo("NULL")==0)  d[i]=null;
				d[i]=new Integer(items[i]).intValue();

			} catch (Exception e) {d[i]=0;}
		}

		return d;

	}

	private Double[] convertDoubleListWithNulls(String s)
	{
		String[] items=convertList(s);
		Double[] d=new Double[items.length];

		for (int i=0; i<items.length;i++)
		{
			try
			{
				if (items[i].toUpperCase().compareTo("NULL")==0)
					d[i]=null;
				else
					d[i]=new Double(items[i]);

			} catch (Exception e) {d[i]=new Double(0);}
		}

		return d;

	}

	private boolean[] convertBooleanList(String s)
	{
		String[] items=convertList(s);
		boolean[] d=new boolean[items.length];

		for (int i=0; i<items.length;i++)
		{
			try
			{
				d[i]=((items[i].compareTo("0")!=0) && (items[i].toUpperCase().compareTo("FALSE")!=0));
      		} catch (Exception e) {d[i]=false;}
		}

		return d;

	}


	// convert an applet parameter to a LineStyle
	public LineStyle convertLineStyle(String f)
	{

		String[] items=convertList(f);

		if (items==null) return null;

		if (items.length<3) return null;
		float floa=0;

		// line's width
		try
		{
			floa=new Float(items[0]).floatValue();
		}
		catch (Exception e) {floa=0.2f;}

		// style
		int typ=LineStyle.LINE_NORMAL;
		if (items[2].compareTo("DASHED")==0) typ=LineStyle.LINE_DASHED;
		if (items[2].compareTo("DOTS")==0) typ=LineStyle.LINE_DOTS;

		// color
		java.awt.Color c=convertColor(items[1]);

		try
		{
			return new LineStyle(floa,c,typ);
	    }
	    catch (Exception e) {return null;}

	}

	//Construct the applet
	public ChartApplet()
	{
	}

	//Initialize the applet
	public void init()
	{

		stopped=false;
		//     System.out.println("Init");
		//System.out.println("Init: "+getStringParam("TITLECHART",""));
		this.loadedParametersCount=0;

		// load runtime configuration
		this.reloadFrom=getParameter("REALTIME_DATAFILE","");
		this.msecs=new Integer(getParameter("REALTIME_MSECS","2000")).longValue();
		this.triggerJS=(getParameter("REALTIME_JS","").toUpperCase().compareTo("TRUE")==0);

		// load parameters from file
		String pFile=getStringParam("DATAFILE","");
		if (pFile.length()>0) loadFromFile(pFile,"N");

		if (getStringParam("PAINT_DIRECT","").compareTo("NO")==0) this.paintDirect=false;

		// build chart
		buildChart();
	}


	private void buildChart()
	{
		java.awt.Color c;
		java.awt.Font font=null;

		interactive=false;

		Title cTitle=null;
		HAxisLabel cXLabel=null;
		VAxisLabel cYLabel=null;
		VAxisLabel cY2Label=null;
		Chart chart;
		LinePlotter linePlot=null;
		LinePlotter3D linePlot3D=null;
		BarPlotter barPlot=null;
		BarPlotter3D barPlot3D=null;
		PiePlotter piePlot=null;
		RadarPlotter radarPlot=null;
		Scale scX= new Scale();
		Scale scY= new Scale();
		Scale scY2= new Scale();
		Axis cXAxis=null;
		Axis cYAxis=null;
		Axis cY2Axis=null;
		LineStyle lstyle;
		FillStyle fstyle;
		Legend clegend=new Legend();

		// reset cursor
		this.setCursor(this.pointerCursor);

		// call javascript on click?
		this.triggerJavaScript=this.getBooleanParam("CHART_JAVASCRIPT_EVENTS",false);
		this.showTips=this.getBooleanParam("CHART_SHOW_TIPS",false);
		this.showPosition=this.getBooleanParam("CHART_SHOW_POSITION",false);

		// tips configuration
		this.tipColor=this.convertColor(getStringParam("CHART_TIPS_COLOR","YELLOW"));
		this.tipFontColor=this.convertColor(getStringParam("CHART_TIPS_FONT_COLOR","BLACK"));
		this.tipFont=this.convertFont(getStringParam("CHART_TIPS_FONT","SERIF|PLAIN|10"));
		this.htmlLinkTarget=getStringParam("CHART_LINKS_TARGET","_new");


		// remove old charts
		this.removeAll();

		if (gChart!=null)
		{
			if (paintDirect)
			{
				this.removeMouseMotionListener(gChart);
				this.removeMouseListener(this);
				this.removeMouseMotionListener(this);
			}
			else
			{
				gChart.removeMouseListener(this);
				gChart.removeMouseMotionListener(this);
			}

		}
		gChart=null;

		// title
		ptitle=getStringParam("TITLECHART","");
		if (ptitle.compareTo("")==0) ptitle=getStringParam("TITLE","");
    	if (ptitle.compareTo("")!=0)
    	{
			cTitle=new Title(ptitle);
			// title's font
			ptitleFont=getStringParam("TITLE_FONT","");
			font=convertFont(ptitleFont);
			if (font!=null) cTitle.font=font;
			// title's color
			ptitleColor=getStringParam("TITLE_COLOR","");
			if (ptitleColor!=null) cTitle.color=convertColor(ptitleColor);
		}

		// XLabel
		Xlabel=getStringParam("XLABEL","");
		if (Xlabel.compareTo("")!=0)
		{
			// font
			XlabelFont=getStringParam("XLABEL_FONT","");
			font=convertFont(XlabelFont);
			if (font==null) font=new java.awt.Font("Arial",java.awt.Font.BOLD,12);
			// color
			XlabelColor=getStringParam("XLABEL_COLOR","");
			if (XlabelColor!=null)
				c=convertColor(XlabelColor);
       		else
       			c=java.awt.Color.black;

			cXLabel=new HAxisLabel(Xlabel,c,font);
			cXLabel.vertical=getBooleanParam("XLABEL_VERTICAL",false);
		}


		// YLabel
		Ylabel=getStringParam("YLABEL","");
		if (Ylabel.compareTo("")!=0)
		{
			// font
			YlabelFont=getStringParam("YLABEL_FONT","");
			font=convertFont(YlabelFont);
			if (font==null) font=new java.awt.Font("Arial",java.awt.Font.BOLD,12);
			// color
			YlabelColor=getStringParam("YLABEL_COLOR","");
			if (YlabelColor!=null)
				c=convertColor(YlabelColor);
			else
				c=java.awt.Color.black;

			cYLabel=new VAxisLabel(Ylabel,c,font);
			cYLabel.vertical=getBooleanParam("YLABEL_VERTICAL",false);
		}

		// Y2Label
		Y2label=getStringParam("Y2LABEL","");
		if (Y2label.compareTo("")!=0)
		{
			// font
			Y2labelFont=getStringParam("Y2LABEL_FONT","");
			font=convertFont(Y2labelFont);
			if (font==null) font=new java.awt.Font("Arial",java.awt.Font.BOLD,12);
			// color
			Y2labelColor=getStringParam("Y2LABEL_COLOR","");
			if (Y2labelColor!=null)
				c=convertColor(Y2labelColor);
			else
				c=java.awt.Color.black;

			cY2Label=new VAxisLabel(Y2label,c,font);
			cY2Label.vertical=getBooleanParam("Y2LABEL_VERTICAL",false);
		}


		if (getBooleanParam("XSCALE_LOG",false)) scX=new logScale();
		if (getBooleanParam("YSCALE_LOG",false)) scY=new logScale();
		if (getBooleanParam("Y2SCALE_LOG",false)) scY2=new logScale();

		int iTmp=getIntParam("XSCALE_LOG_BASE",new Integer(2)).intValue();
		if (iTmp!=2)
		if (scX instanceof logScale) ((logScale) scX).base=iTmp;

		iTmp=getIntParam("YSCALE_LOG_BASE",new Integer(2)).intValue();
		if (iTmp!=2)
			if (scY instanceof logScale) ((logScale) scY).base=iTmp;

		iTmp=getIntParam("Y2SCALE_LOG_BASE",new Integer(2)).intValue();
		if (iTmp!=2)
			if (scY2 instanceof logScale) ((logScale) scY2).base=iTmp;


		// scales
		pScaleXMin=getDoubleParam("XSCALE_MIN",null);
		pScaleXMax=getDoubleParam("XSCALE_MAX",null);
		pScaleYMin=getDoubleParam("YSCALE_MIN",null);
		pScaleYMax=getDoubleParam("YSCALE_MAX",null);
		pScaleY2Min=getDoubleParam("Y2SCALE_MIN",null);
		pScaleY2Max=getDoubleParam("Y2SCALE_MAX",null);


		if (pScaleXMin!=null) scX.min=pScaleXMin.doubleValue();
		if (pScaleYMin!=null) scY.min=pScaleYMin.doubleValue();
		if (pScaleY2Min!=null) scY2.min=pScaleY2Min.doubleValue();
		if (pScaleY2Max!=null) scY2.max=pScaleY2Max.doubleValue();
		if (pScaleXMax!=null) scX.max=pScaleXMax.doubleValue();
		if (pScaleYMax!=null) scY.max=pScaleYMax.doubleValue();

		pAxisX=getBooleanParam("XAXIS",true);
		pAxisY=getBooleanParam("YAXIS",true);
		pAxisY2=getBooleanParam("Y2AXIS",false);

		pbigTicksGridX=getBooleanParam("GRIDX",false);
		pbigTicksGridY=getBooleanParam("GRIDY",false);
		pbigTicksGridY2=getBooleanParam("GRIDY2",false);

		scaleTickIntervalX=getDoubleParam("TICK_INTERVALX",new Double(1));
		scaleTickIntervalY=getDoubleParam("TICK_INTERVALY",new Double(1));
		scaleTickIntervalY2=getDoubleParam("TICK_INTERVALY2",new Double(1));

		bigTickIntervalX=getIntParam("BIG_TICK_INTERVALX",new Integer(5));
		if (getStringParam("BIG_TICK_INTERVAL_LISTX","").length()>0) bigTickIntervalListX=this.convertIntList(getStringParam("BIG_TICK_INTERVAL_LISTX",""));

		bigTickIntervalY=getIntParam("BIG_TICK_INTERVALY",new Integer(5));
		if (getStringParam("BIG_TICK_INTERVAL_LISTY","").length()>0) bigTickIntervalListY=this.convertIntList(getStringParam("BIG_TICK_INTERVAL_LISTY",""));

		bigTickIntervalY2=getIntParam("BIG_TICK_INTERVALY2",new Integer(5));
		if (getStringParam("BIG_TICK_INTERVAL_LISTY2","").length()>0) bigTickIntervalListY2=this.convertIntList(getStringParam("BIG_TICK_INTERVAL_LISTY2",""));

		pAxisXLabels=getStringParam("XAXIS_LABELS","");
		pAxisYLabels=getStringParam("YAXIS_LABELS","");
		pAxisY2Labels=getStringParam("Y2AXIS_LABELS","");


		scX.exactMaxValue=this.getBooleanParam("XSCALE_EXACT_MAX",false);
		scX.exactMinValue=this.getBooleanParam("XSCALE_EXACT_MIN",false);
		if (this.getStringParam("XSCALE_PREF_MAXMIN","").length()>0) scX.preferred_MaxMin_values=this.convertDoubleList(this.getStringParam("XSCALE_PREF_MAXMIN",""));


		scY.exactMaxValue=this.getBooleanParam("YSCALE_EXACT_MAX",true);
		scY.exactMinValue=this.getBooleanParam("YSCALE_EXACT_MIN",true);
		if (this.getStringParam("YSCALE_PREF_MAXMIN","").length()>0) scY.preferred_MaxMin_values=this.convertDoubleList(this.getStringParam("YSCALE_PREF_MAXMIN",""));

		scY2.exactMaxValue=this.getBooleanParam("Y2SCALE_EXACT_MAX",true);
		scY2.exactMinValue=this.getBooleanParam("Y2SCALE_EXACT_MIN",true);
		if (this.getStringParam("Y2SCALE_PREF_MAXMIN","").length()>0) scY2.preferred_MaxMin_values=this.convertDoubleList(this.getStringParam("Y2SCALE_PREF_MAXMIN",""));


		// Axis
		if (pAxisX)
		{
			cXAxis=new Axis(Axis.HORIZONTAL,scX);

			cXAxis.autoNumberOfTicks=this.getIntParam("XAXIS_AUTO_TICKS",new Integer(0)).intValue();
			if (this.getStringParam("XAXIS_PREF_TICK_INTERVAL","").length()>0) cXAxis.ticks_preferred_Interval=this.convertDoubleList(this.getStringParam("XAXIS_PREF_TICK_INTERVAL",""));

			if (getBooleanParam("XAXIS_START_WITH_BIG_TICK",false)) cXAxis.startWithBigTick=true;
			cXAxis.logarithmicIntervals=this.getBooleanParam("TICK_LOG_INTERVALX",false);

			cXAxis.dateLabelFormat=getStringParam("XAXIS_DATE_FORMAT","dd-MMM-yyyy");
			cXAxis.dateStep=getStringParam("XAXIS_DATE_STEP","d");
			cXAxis.initialDate=getDateParam("XAXIS_INITIAL_DATE","");

			cXAxis.bigTickInterval=bigTickIntervalX.intValue();
			cXAxis.bigTickIntervalList=bigTickIntervalListX;
			cXAxis.scaleTickInterval=scaleTickIntervalX.doubleValue();
			cXAxis.tickPixels=(int) this.getDoubleParam("XAXIS_TICKPIXELS",new Double(cXAxis.tickPixels)).doubleValue();
			cXAxis.bigTickPixels=(int) this.getDoubleParam("XAXIS_BIGTICKPIXELS",new Double(cXAxis.bigTickPixels)).doubleValue();
			cXAxis.bigTicksGrid=pbigTicksGridX;
			if ( pAxisXLabels.compareTo("")!=0) cXAxis.tickLabels=convertList(pAxisXLabels);
				String ceroAxis=this.getStringParam("CERO_XAXIS","");
			if (ceroAxis.compareTo("LINE")==0) cXAxis.ceroAxis=Axis.CEROAXIS_LINE;
			if (ceroAxis.compareTo("NO")==0) cXAxis.ceroAxis=Axis.CEROAXIS_NO;
			if (ceroAxis.compareTo("SCALE")==0) cXAxis.ceroAxis=Axis.CEROAXIS_SCALE;

			lstyle=convertLineStyle(getStringParam("XAXIS_STYLE",""));
			if (lstyle!=null) cXAxis.style=lstyle;

			lstyle=convertLineStyle(getStringParam("XAXIS_GRID",""));
			if (lstyle!=null) cXAxis.gridStyle=lstyle;

			c=convertColor(getStringParam("XAXIS_FONT_COLOR",""));
			cXAxis.DescColor=c;

			font=convertFont(getStringParam("XAXIS_FONT",""));
			if (font!=null) cXAxis.DescFont=font;

			cXAxis.IntegerScale=getBooleanParam("XAXIS_INTEGER",true);
			cXAxis.scaleLabelFormat=getStringParam("XAXIS_LABEL_FORMAT","");

			cXAxis.tickAtBase=getBooleanParam("XAXIS_TICKATBASE",false);

			cXAxis.verticalLabels=getBooleanParam("XAXIS_VERTICAL_LABELS",false);

		}

		if (pAxisY)
		{
			cYAxis=new Axis(Axis.VERTICAL,scY);

			cYAxis.autoNumberOfTicks=this.getIntParam("YAXIS_AUTO_TICKS",new Integer(0)).intValue();
			if (this.getStringParam("YAXIS_PREF_TICK_INTERVAL","").length()>0) cYAxis.ticks_preferred_Interval=this.convertDoubleList(this.getStringParam("YAXIS_PREF_TICK_INTERVAL",""));

			cYAxis.dateLabelFormat=getStringParam("YAXIS_DATE_FORMAT","dd-MMM-yyyy");
			cYAxis.dateStep=getStringParam("YAXIS_DATE_STEP","d");
			cYAxis.initialDate=getDateParam("YAXIS_INITIAL_DATE","");

			cYAxis.logarithmicIntervals=this.getBooleanParam("TICK_LOG_INTERVALY",false);

			cYAxis.bigTickInterval=bigTickIntervalY.intValue();
			cYAxis.bigTickIntervalList=bigTickIntervalListY;
			cYAxis.scaleTickInterval=scaleTickIntervalY.doubleValue();
			cYAxis.tickPixels=(int) this.getDoubleParam("YAXIS_TICKPIXELS",new Double(cYAxis.tickPixels)).doubleValue();
			cYAxis.bigTickPixels=(int) this.getDoubleParam("YAXIS_BIGTICKPIXELS",new Double(cYAxis.bigTickPixels)).doubleValue();
			cYAxis.bigTicksGrid=pbigTicksGridY;

			if (getBooleanParam("YAXIS_START_WITH_BIG_TICK",false)) cYAxis.startWithBigTick=true;

			if ( pAxisYLabels.compareTo("")!=0) cYAxis.tickLabels=convertList(pAxisYLabels);
			String ceroAxis=getStringParam("CERO_YAXIS","");
			if (ceroAxis.compareTo("LINE")==0) cYAxis.ceroAxis=Axis.CEROAXIS_LINE;
			if (ceroAxis.compareTo("NO")==0) cYAxis.ceroAxis=Axis.CEROAXIS_NO;
			if (ceroAxis.compareTo("SCALE")==0) cYAxis.ceroAxis=Axis.CEROAXIS_SCALE;


			lstyle=convertLineStyle(getStringParam("YAXIS_STYLE",""));
			if (lstyle!=null) cYAxis.style=lstyle;

			lstyle=convertLineStyle(getStringParam("YAXIS_GRID",""));
			if (lstyle!=null) cYAxis.gridStyle=lstyle;

			c=convertColor(getStringParam("YAXIS_FONT_COLOR",""));
			cYAxis.DescColor=c;

			font=convertFont(getStringParam("YAXIS_FONT",""));
			if (font!=null) cYAxis.DescFont=font;

			cYAxis.IntegerScale=getBooleanParam("YAXIS_INTEGER",true);
			cYAxis.scaleLabelFormat=getStringParam("YAXIS_LABEL_FORMAT","");

			cYAxis.tickAtBase=getBooleanParam("YAXIS_TICKATBASE",false);

			cYAxis.verticalLabels=getBooleanParam("YAXIS_VERTICAL_LABELS",false);
		}


		// second Y Axis
		if (pAxisY2)
		{
			cY2Axis=new Axis(Axis.VERTICAL,scY2);

			cY2Axis.autoNumberOfTicks=this.getIntParam("Y2AXIS_AUTO_TICKS",new Integer(0)).intValue();
			if (this.getStringParam("Y2AXIS_PREF_TICK_INTERVAL","").length()>0) cY2Axis.ticks_preferred_Interval=this.convertDoubleList(this.getStringParam("Y2AXIS_PREF_TICK_INTERVAL",""));

			cY2Axis.dateLabelFormat=getStringParam("Y2AXIS_DATE_FORMAT","dd-MMM-yyyy");
			cY2Axis.dateStep=getStringParam("Y2AXIS_DATE_STEP","d");
			cY2Axis.initialDate=getDateParam("Y2AXIS_INITIAL_DATE","");

			if (getBooleanParam("Y2AXIS_START_WITH_BIG_TICK",false)) cY2Axis.startWithBigTick=true;

			cY2Axis.logarithmicIntervals=this.getBooleanParam("TICK_LOG_INTERVALY2",false);

			cY2Axis.bigTickInterval=bigTickIntervalY2.intValue();
			cY2Axis.bigTickIntervalList=bigTickIntervalListY2;
			cY2Axis.scaleTickInterval=scaleTickIntervalY2.doubleValue();
			cY2Axis.tickPixels=(int) this.getDoubleParam("Y2AXIS_TICKPIXELS",new Double(cY2Axis.tickPixels)).doubleValue();
			cY2Axis.bigTickPixels=(int) this.getDoubleParam("Y2AXIS_BIGTICKPIXELS",new Double(cY2Axis.bigTickPixels)).doubleValue();
			cY2Axis.bigTicksGrid=pbigTicksGridY2;
			if ( pAxisY2Labels.compareTo("")!=0) cY2Axis.tickLabels=convertList(pAxisY2Labels);
			String ceroAxis=getStringParam("CERO_Y2AXIS","");
			if (ceroAxis.compareTo("LINE")==0) cY2Axis.ceroAxis=Axis.CEROAXIS_LINE;
			if (ceroAxis.compareTo("NO")==0) cY2Axis.ceroAxis=Axis.CEROAXIS_NO;
			if (ceroAxis.compareTo("SCALE")==0) cY2Axis.ceroAxis=Axis.CEROAXIS_SCALE;

			lstyle=convertLineStyle(getStringParam("Y2AXIS_STYLE",""));
			if (lstyle!=null) cY2Axis.style=lstyle;

			lstyle=convertLineStyle(getStringParam("Y2AXIS_GRID",""));
			if (lstyle!=null) cY2Axis.gridStyle=lstyle;

			c=convertColor(getStringParam("Y2AXIS_FONT_COLOR",""));
			cY2Axis.DescColor=c;

			font=convertFont(getStringParam("Y2AXIS_FONT",""));
			if (font!=null) cY2Axis.DescFont=font;

			cY2Axis.IntegerScale=getBooleanParam("Y2AXIS_INTEGER",true);
			cY2Axis.scaleLabelFormat=getStringParam("Y2AXIS_LABEL_FORMAT","");

			cY2Axis.tickAtBase=getBooleanParam("Y2AXIS_TICKATBASE",false);

			cY2Axis.verticalLabels=getBooleanParam("Y2AXIS_VERTICAL_LABELS",false);
		}


		// create legend
		fstyle=convertFillStyle(getStringParam("LEGEND_FILL",""));
		if (fstyle!=null) clegend.background=fstyle;
		lstyle=convertLineStyle(getStringParam("LEGEND_BORDER",""));
		if (lstyle!=null) clegend.border=lstyle;
		c=convertColor(getStringParam("LEGEND_COLOR",""));
		clegend.color=c;
		font=convertFont(getStringParam("LEGEND_FONT",""));
		if (font!=null) clegend.font=font;
		clegend.verticalLayout=getBooleanParam("LEGEND_VERTICAL",true);

		pnumSeries=0;
		for (int i=1;i<MAX_SERIES;i++)
		{
			pSerie=getStringParam("SERIE_"+i,"");
			if (pSerie.compareTo("")==0) break;
			pSeriesNames[i]=pSerie;

			pSeriesData[i]=getStringParam("SERIE_DATA_"+i,"");
			if (pSeriesData[i].compareTo("")==0) break;

			String Typ=getStringParam("SERIE_TYPE_"+i,"LINE");

			// tips and links
			this.tips[i]=this.convertList(getStringParam("SERIE_TIPS_"+i,""));
			this.htmlLinks[i]=this.convertList(getStringParam("SERIE_LINKS_"+i,""));
			if (this.htmlLinks[i]!=null)
			if (this.htmlLinks[i].length>0) this.activateHtmlLinks=true;

			// create serie
			pSeries[i]=null;

			if ((Typ.compareTo("LINE")==0) || (Typ.compareTo("B-SPLINES")==0)  ||  (Typ.compareTo("CURVE")==0)  || (Typ.compareTo("LINE_LEAST_SQUARES")==0))
			{

				// create plotter
				if (linePlot==null)
				{

					if (Typ.compareTo("LINE")==0)
						linePlot=new LinePlotter();
		   			else
		   				linePlot= (LinePlotter) new CurvePlotter();

					linePlot.XScale=scX;
					linePlot.YScale=scY;
					linePlot.Y2Scale=scY2;
					linePlot.fixedLimits=getBooleanParam("LINECHART_FIXED_LIMITS",false);

					// backgorund
					FillStyle backstyle=convertFillStyle(getStringParam("LINECHART_BACK",""));
					if (backstyle!=null) linePlot.back=backstyle;

				}


				lstyle=convertLineStyle(getStringParam("SERIE_STYLE_"+i,""));
				if (lstyle==null) lstyle=new LineStyle(0.2f,java.awt.Color.black,LineStyle.LINE_NORMAL);

				// draw line?
				if (getStringParam("SERIE_DRAW_LINE_"+i,"").compareTo("N")==0)	lstyle=null;

				// max, min and close values
				pSeriesMaxData[i]=getStringParam("SERIE_MAX_DATA_"+i,"");
				pSeriesMaxData[i]=getStringParam("SERIE_MAX_DATA_"+i,"");
				pSeriesMinData[i]=getStringParam("SERIE_MIN_DATA_"+i,"");
				pSeriesCloseData[i]=getStringParam("SERIE_CLOSE_DATA_"+i,"");

				pSeries[i]=null;
				if (pSeriesMaxData[i].length()==0) // nomal line
					pSeries[i]= new LineDataSerie(convertDoubleListWithNulls(pSeriesData[i]),lstyle);


				if ((pSeriesMaxData[i].length()>0) && (pSeriesCloseData[i].length()==0))
				{	// max min
					pSeries[i]= new MaxMinDataSerie(convertDoubleListWithNulls(pSeriesData[i]),lstyle);
					if (pSeriesMinData[i].length()>0)
						((MaxMinDataSerie) pSeries[i]).setMaxMinValues(convertDoubleList(pSeriesMaxData[i]),convertDoubleList(pSeriesMinData[i]));
			 		else
			 			((MaxMinDataSerie) pSeries[i]).setMaxMinValues(convertDoubleList(pSeriesMaxData[i]),null);
					((MaxMinDataSerie) pSeries[i]).drawLineEnd=(getStringParam("SERIE_LINE_END_"+i,"").toUpperCase().compareTo("TRUE")==0);
					linePlot.MaxMinType=linePlot.MM_NORMAL;
					LineStyle mmstyle=convertLineStyle(getStringParam("SERIE_MAXMIN_STYLE_"+i,""));
					if (mmstyle!=null) ((MaxMinDataSerie) pSeries[i]).maxminStyle=mmstyle;

					if (getStringParam("SERIE_BUBBLE_"+i,"").toUpperCase().compareTo("TRUE")==0)
					{
						((MaxMinDataSerie) pSeries[i]).bubbleChart=true;
						if (getStringParam("SERIE_FILL_BUBBLE_"+i,"").toUpperCase().compareTo("TRUE")==0)
							((MaxMinDataSerie) pSeries[i]).fillBubble=true;
						else
							((MaxMinDataSerie) pSeries[i]).fillBubble=false;
					}

				}

				if ((pSeriesMaxData[i].length()>0) && (pSeriesCloseData[i].length()>0))
				{	// open close
					pSeries[i]= new MaxMinDataSerie(convertDoubleListWithNulls(pSeriesData[i]),convertDoubleList(pSeriesCloseData[i]),convertDoubleList(pSeriesMaxData[i]),convertDoubleList(pSeriesMinData[i]),lstyle);
					linePlot.MaxMinType=linePlot.MM_OHLC;
					((MaxMinDataSerie) pSeries[i]).drawLineEnd=false;
					if (getStringParam("SERIE_LINE_TYPE_"+i,"").compareTo("CANDLESTICK")==0) linePlot.MaxMinType=linePlot.MM_CANDLESTICK;
					if (getStringParam("SERIE_CANDLE_POSITIVE_COLOR_"+i,"").length()>0) ((MaxMinDataSerie) pSeries[i]).positiveValueColor=convertColor(getStringParam("SERIE_CANDLE_POSITIVE_COLOR_"+i,""));
					if (getStringParam("SERIE_CANDLE_NEGATIVE_COLOR_"+i,"").length()>0) ((MaxMinDataSerie) pSeries[i]).negativeValueColor=convertColor(getStringParam("SERIE_CANDLE_NEGATIVE_COLOR_"+i,""));
					((MaxMinDataSerie) pSeries[i]).openCloseWidth=this.getIntParam("SERIE_OPENCLOSE_WIDTH_"+i,new Integer(7)).intValue();
					LineStyle mmstyle=convertLineStyle(getStringParam("SERIE_MAXMIN_STYLE_"+i,""));
					if (mmstyle!=null) ((MaxMinDataSerie) pSeries[i]).maxminStyle=mmstyle;
				}

				if (Typ.compareTo("LINE")==0)  ((LineDataSerie) pSeries[i]).lineType=linePlot.TYPE_LINE;
				if (Typ.compareTo("B-SPLINES")==0) ((LineDataSerie) pSeries[i]).lineType=linePlot.TYPE_B_SPLINES;
				if (Typ.compareTo("CURVE")==0) ((LineDataSerie) pSeries[i]).lineType=linePlot.TYPE_CUBIC_NATURAL;
				if (Typ.compareTo("LINE_LEAST_SQUARES")==0) ((LineDataSerie) pSeries[i]).lineType=linePlot.TYPE_LEAST_SQUARES_LINE;


				// user defined x coordinates
				String Xs=getStringParam("SERIE_DATAX_"+i,"");
				if (Xs.length()>0) pSeries[i].setDatax(convertDoubleList(Xs));

				// Y axis to use
				pSeries[i].secondYAxis=getBooleanParam("SERIE_SECONDYAXIS_"+i,false);


				// area chart
				fstyle=convertFillStyle(getStringParam("SERIE_FILL_"+i,""));
				if (fstyle!=null) ((LineDataSerie) pSeries[i]).fillStyle=fstyle;


				// values' font
				font=convertFont(getStringParam("SERIE_FONT_"+i,""));
				if (font!=null) ((LineDataSerie) pSeries[i]).valueFont=font;
				c=convertColor(getStringParam("SERIE_COLOR_"+i,""));
				((LineDataSerie) pSeries[i]).valueColor=c;

				// points
				c=convertColor(getStringParam("SERIE_POINT_COLOR_"+i,""));
				((LineDataSerie) pSeries[i]).pointColor=c;
				((LineDataSerie) pSeries[i]).drawPoint=getBooleanParam("SERIE_POINT_"+i,false);

				// lengend
				if (fstyle==null)
				{
					if (lstyle!=null)
					{
						clegend.addItem(pSeriesNames[i],lstyle);
					}
					else
					{
						clegend.addItem(pSeriesNames[i],new FillStyle(((LineDataSerie) pSeries[i]).valueColor));
					}
				}
				else
					clegend.addItem(pSeriesNames[i],fstyle);


				String pointImageStr=getStringParam("SERIE_POINT_IMAGE_"+i,"");
				if (pointImageStr.compareTo("")!=0)
				{
					java.awt.Image im2=null;
					String cb="";
					try
					{
						java.awt.MediaTracker mt2 = new java.awt.MediaTracker(this);
						if (this.isStandalone)
						{
							// load as we are in servlet

							java.io.FileInputStream in=null;
							byte[] b=null;
							int size=0;

							in=new java.io.FileInputStream(pointImageStr);
							if (in!=null)
							{
								size=in.available();
								b=new byte[size];
								in.read(b);
								im2=Toolkit.getDefaultToolkit().createImage(b);
								in.close();
							}

						}
						else // load as we are in applet
						{
							cb=this.getCodeBase().toString();
							if (pointImageStr.toLowerCase().indexOf("http://")>=0) cb="";

							im2=this.getImage(new java.net.URL(cb+pointImageStr));

						}

						if (im2!=null)
						{
							mt2.addImage(im2,0); mt2.waitForID(0);
							int WidthIm = im2.getWidth(null);
							((LineDataSerie) pSeries[i]).icon=im2;
						}

					}
					catch (Exception e2)
					{
						System.out.println("Error reading "+cb+pointImageStr+": "+e2.getMessage());
					}


				}

				pSeries[i].name=pSeriesNames[i];
				linePlot.addSerie(pSeries[i]);
			}

			if (Typ.compareTo("LINE3D")==0)
			{

				// create plotter
				if (linePlot3D==null)
				{
					linePlot3D=new LinePlotter3D();
					linePlot3D.XScale=scX;
					linePlot3D.YScale=scY;
					linePlot3D.Y2Scale=scY2;
					linePlot3D.fixedLimits=getBooleanParam("LINECHART_FIXED_LIMITS",false);

					// border
					if (getStringParam("LINECHART3D_BORDER","").length()>0)	linePlot3D.border=convertLineStyle(getStringParam("LINECHART3D_BORDER",""));

					if (getStringParam("LINECHART3D_DEPTH","").length()>0)	linePlot3D.depth=(int) this.getDoubleParam("LINECHART3D_DEPTH",new Double(20)).doubleValue();


					if (getStringParam("LINECHART3D_SEPARATOR","").length()>0) linePlot3D.interLineSpace=(int) this.getDoubleParam("LINECHART3D_SEPARATOR",new Double(0)).doubleValue();

					// backgorund
					FillStyle backstyle=convertFillStyle(getStringParam("LINECHART3D_BACK",""));
					if (backstyle!=null) linePlot3D.back=backstyle;

				}


				lstyle=convertLineStyle(getStringParam("SERIE_STYLE_"+i,""));
				if (lstyle==null) lstyle=new LineStyle(0.2f,java.awt.Color.black,LineStyle.LINE_NORMAL);

				// draw line?
				if (getStringParam("SERIE_DRAW_LINE_"+i,"").compareTo("N")==0)	lstyle=null;

				// nomal line
				pSeries[i]= new LineDataSerie(convertDoubleListWithNulls(pSeriesData[i]),lstyle);

				// user defined x coordinates
				String Xs=getStringParam("SERIE_DATAX_"+i,"");
				if (Xs.length()>0) pSeries[i].setDatax(convertDoubleList(Xs));

				// Y axis to use
				pSeries[i].secondYAxis=getBooleanParam("SERIE_SECONDYAXIS_"+i,false);


				// area chart
				fstyle=convertFillStyle(getStringParam("SERIE_FILL_"+i,""));
				if (fstyle!=null) ((LineDataSerie) pSeries[i]).fillStyle=fstyle;



				// values' font
				font=convertFont(getStringParam("SERIE_FONT_"+i,""));
				if (font!=null) ((LineDataSerie) pSeries[i]).valueFont=font;
				c=convertColor(getStringParam("SERIE_COLOR_"+i,""));
				((LineDataSerie) pSeries[i]).valueColor=c;


				// lengend
				if (fstyle==null)
				{
					if (lstyle!=null)
					{
						clegend.addItem(pSeriesNames[i],lstyle);
					}
					else
					{
						clegend.addItem(pSeriesNames[i],new FillStyle(((LineDataSerie) pSeries[i]).valueColor));
					}
				}
				else
					clegend.addItem(pSeriesNames[i],fstyle);

				// points
				//c=convertColor(getStringParam("SERIE_POINT_COLOR_"+i,""));
				//((LineDataSerie) pSeries[i]).pointColor=c;
				//((LineDataSerie) pSeries[i]).drawPoint=getBooleanParam("SERIE_POINT_"+i,false);

				pSeries[i].name=pSeriesNames[i];

				linePlot3D.addSerie(pSeries[i]);
			}


			if (Typ.compareTo("RADAR")==0)
			{
				// create plotter
				if (radarPlot==null) radarPlot=new RadarPlotter();

				lstyle=convertLineStyle(getStringParam("SERIE_STYLE_"+i,""));
				if (lstyle==null) lstyle=new LineStyle(0.2f,java.awt.Color.black,LineStyle.LINE_NORMAL);

				pSeries[i]=null;
				pSeries[i]= new LineDataSerie(convertDoubleList(pSeriesData[i]),lstyle);


				// area chart
				fstyle=convertFillStyle(getStringParam("SERIE_FILL_"+i,""));
				if (fstyle!=null) ((LineDataSerie) pSeries[i]).fillStyle=fstyle;

				// lengend
				if (fstyle==null)
					clegend.addItem(pSeriesNames[i],lstyle);
				else
					clegend.addItem(pSeriesNames[i],fstyle);

				// values' font
				font=convertFont(getStringParam("SERIE_FONT_"+i,""));
				if (font!=null) ((LineDataSerie) pSeries[i]).valueFont=font;
				c=convertColor(getStringParam("SERIE_COLOR_"+i,""));
				((LineDataSerie) pSeries[i]).valueColor=c;

				// points
				c=convertColor(getStringParam("SERIE_POINT_COLOR_"+i,""));
				((LineDataSerie) pSeries[i]).pointColor=c;
				((LineDataSerie) pSeries[i]).drawPoint=getBooleanParam("SERIE_POINT_"+i,false);

				pSeries[i].name=pSeriesNames[i];
				radarPlot.addSerie(pSeries[i]);
			}


			if (Typ.compareTo("BAR3D")==0)
			{
				fstyle=convertFillStyle(getStringParam("SERIE_STYLE_"+i,""));
				if (fstyle==null) fstyle=new FillStyle(java.awt.Color.blue);
				pSeries[i]= new BarDataSerie(convertDoubleList(pSeriesData[i]),fstyle);

				if (getStringParam("SERIE_NEGATIVE_STYLE_"+i,"").length()>0)
				{
					((BarDataSerie) pSeries[i]).negativeStyle=convertFillStyle(getStringParam("SERIE_NEGATIVE_STYLE_"+i,""));
				}

				clegend.addItem(pSeriesNames[i],fstyle);


				if (getStringParam("SERIE_BARS_COLORS_"+i,"").length()>0)
				{
					// get list
					String[] listTMP=this.convertList(getStringParam("SERIE_BARS_COLORS_"+i,""));
					// convert to list of styles
					((BarDataSerie) pSeries[i]).barStyles=new FillStyle[listTMP.length];
					for (int j=0; j<listTMP.length;j++)
						((BarDataSerie) pSeries[i]).barStyles[j]=new FillStyle(convertColor(listTMP[j]));
				}

				// values' font
				font=convertFont(getStringParam("SERIE_FONT_"+i,""));
				if (font!=null) ((BarDataSerie) pSeries[i]).valueFont=font;
				c=convertColor(getStringParam("SERIE_COLOR_"+i,""));
				((BarDataSerie) pSeries[i]).valueColor=c;

				// Y axis to use
				pSeries[i].secondYAxis=getBooleanParam("SERIE_SECONDYAXIS_"+i,false);

				// border type of the bars
				String t=getStringParam("SERIE_BORDER_TYPE_"+i,"");
				if (t.compareTo("LOWERED")==0) ((BarDataSerie) pSeries[i]).borderType=BarDataSerie.BORDER_LOWERED;
				if (t.compareTo("RAISED")==0) ((BarDataSerie) pSeries[i]).borderType=BarDataSerie.BORDER_RAISED;
				if (t.compareTo("NO")==0) ((BarDataSerie) pSeries[i]).borderType=BarDataSerie.BORDER_NO;
				if (t.compareTo("NORMAL")==0) ((BarDataSerie) pSeries[i]).borderType=BarDataSerie.BORDER_NORMAL;

				lstyle=convertLineStyle(getStringParam("SERIE_BORDER_"+i,""));
				if (lstyle!=null) ((BarDataSerie) pSeries[i]).border=lstyle;

				// create plotter
				if (barPlot3D==null)
				{
					barPlot3D=new BarPlotter3D();
					barPlot3D.XScale=scX;
					barPlot3D.YScale=scY;
					barPlot3D.Y2Scale=scY2;
					if (getStringParam("BARCHART3D_DEPTH","").length()>0)
						barPlot3D.depth=(int) this.getDoubleParam("BARCHART3D_DEPTH",new Double(20)).doubleValue();

					barPlot3D.fullDepth=(getStringParam("BARCHART3D_FULL_DEPTH","").toUpperCase().compareTo("TRUE")==0);

					// backgorund
					FillStyle backstyle=convertFillStyle(getStringParam("BARCHART3D_BACK",""));
					if (backstyle!=null) barPlot3D.back=backstyle;

					// stack bars?
					barPlot3D.cumulative=getBooleanParam("BARCHART_CUMULATIVE",false);


				}

				// vertical bars?
				barPlot3D.verticalBars=getBooleanParam("BARCHART_VERTICAL",true);

				pSeries[i].name=pSeriesNames[i];
				barPlot3D.addSerie(pSeries[i]);
			}


			if (Typ.compareTo("BAR")==0)
			{
				fstyle=convertFillStyle(getStringParam("SERIE_STYLE_"+i,""));
				if (fstyle==null) fstyle=new FillStyle(java.awt.Color.blue);
				pSeries[i]= new BarDataSerie(convertDoubleList(pSeriesData[i]),fstyle);

				((BarDataSerie) pSeries[i]).addBarsBase(convertDoubleList(getStringParam("SERIE_BARS_START_"+i,"")));;

				// user defined x coordinates
				String Xs=getStringParam("SERIE_DATAX_"+i,"");
				if (Xs.length()>0) pSeries[i].setDatax(convertDoubleList(Xs));


				if (getStringParam("SERIE_NEGATIVE_STYLE_"+i,"").length()>0)
					((BarDataSerie) pSeries[i]).negativeStyle=convertFillStyle(getStringParam("SERIE_NEGATIVE_STYLE_"+i,""));

				clegend.addItem(pSeriesNames[i],fstyle);

				if (getStringParam("SERIE_BARS_COLORS_"+i,"").length()>0)
				{
					// get list
					String[] listTMP=this.convertList(getStringParam("SERIE_BARS_COLORS_"+i,""));
					// convert to list of styles
					((BarDataSerie) pSeries[i]).barStyles=new FillStyle[listTMP.length];
					for (int j=0; j<listTMP.length;j++)
						((BarDataSerie) pSeries[i]).barStyles[j]=new FillStyle(convertColor(listTMP[j]));
				}

				// values' font
				font=convertFont(getStringParam("SERIE_FONT_"+i,""));
				if (font!=null) ((BarDataSerie) pSeries[i]).valueFont=font;
				c=convertColor(getStringParam("SERIE_COLOR_"+i,""));
				((BarDataSerie) pSeries[i]).valueColor=c;

				// Y axis to use
				pSeries[i].secondYAxis=getBooleanParam("SERIE_SECONDYAXIS_"+i,false);

				// border type of the bars
				String t=getStringParam("SERIE_BORDER_TYPE_"+i,"");
				if (t.compareTo("LOWERED")==0) ((BarDataSerie) pSeries[i]).borderType=BarDataSerie.BORDER_LOWERED;
				if (t.compareTo("RAISED")==0) ((BarDataSerie) pSeries[i]).borderType=BarDataSerie.BORDER_RAISED;
				if (t.compareTo("NO")==0) ((BarDataSerie) pSeries[i]).borderType=BarDataSerie.BORDER_NO;
				if (t.compareTo("NORMAL")==0) ((BarDataSerie) pSeries[i]).borderType=BarDataSerie.BORDER_NORMAL;

				lstyle=convertLineStyle(getStringParam("SERIE_BORDER_"+i,""));
				if (lstyle!=null) ((BarDataSerie) pSeries[i]).border=lstyle;

				// create plotter
				if (barPlot==null)
				{
					barPlot=new BarPlotter();
					barPlot.XScale=scX;
					barPlot.YScale=scY;
					barPlot.Y2Scale=scY2;

					// backgorund
					FillStyle backstyle=convertFillStyle(getStringParam("BARCHART_BACK",""));
					if (backstyle!=null) barPlot3D.back=backstyle;

    		        // stack bars?
    		        barPlot.cumulative=getBooleanParam("BARCHART_CUMULATIVE",false);

    		        // old stackbar mode
					if (getBooleanParam("BARCHART_CUMULATIVE_BACK_COMPATIBLE",false)) barPlot.cumulativeBackwardsCompatible=true;

    		        // event chart
					barPlot.eventChart=getBooleanParam("BARCHART_EVENTCHART",false);

				}

				// vertical bars?
				barPlot.verticalBars=getBooleanParam("BARCHART_VERTICAL",true);

				pSeries[i].name=pSeriesNames[i];
				barPlot.addSerie(pSeries[i]);
			}

			if (Typ.compareTo("PIE")==0)
			{

				// fill styles
				FillStyle[] styles=new FillStyle[50];
				for (int j=1;j<50;j++)
				{
					fstyle=convertFillStyle(getStringParam("PIE_STYLE_"+j,""));
					if (fstyle!=null)
						styles[j-1]=fstyle;
    		       	else
    		       		break;

					clegend.addItem(getStringParam("PIE_NAME_"+j,""),fstyle);
				}

				boolean[] pieKeepTogether=null;
				String[] pieLabels=null;

				if (getStringParam("SERIE_LABELS_"+i,"").length()>0) pieLabels=this.getItemsParameter("SERIE_LABELS_"+i);
				if (getStringParam("SERIE_TOGETHER_"+i,"").length()>0) pieKeepTogether=this.convertBooleanList(getStringParam("SERIE_TOGETHER_"+i,""));

				pSeries[i]= new PieDataSerie(convertDoubleList(pSeriesData[i]),styles,pieKeepTogether,pieLabels);

				// values' font
				font=convertFont(getStringParam("SERIE_FONT_"+i,""));
				if (font!=null) ((PieDataSerie) pSeries[i]).valueFont=font;
				if (getStringParam("SERIE_FONT_"+i,"").compareTo("NULL")==0)
					((PieDataSerie) pSeries[i]).valueFont=null;

				c=convertColor(getStringParam("SERIE_COLOR_"+i,""));
				((PieDataSerie) pSeries[i]).valueColor=c;

				((PieDataSerie) pSeries[i]).drawPercentages=getBooleanParam("SERIE_PERCENTAGES_"+i,true);
				Double d=getDoubleParam("SERIE_DISTCENTER_"+i,null);
				if (d!=null) ((PieDataSerie) pSeries[i]).textDistanceToCenter=d.doubleValue();

				// create plotter
				if (piePlot==null)
				{
					piePlot=new PiePlotter();
					piePlot.labelFormat=getStringParam("PIE_LABEL_FORMAT","");
				}
				pSeries[i].name=pSeriesNames[i];
				piePlot.addSerie(pSeries[i]);
			}

    		// format of the value
    		if (pSeries[i]!=null)
    		{
				pSeries[i].valueFormat=getStringParam("SERIE_FORMAT_"+i,"#####.##");

				if (getStringParam("SERIE_DATA_LABELS_"+i,"").length()>0) pSeries[i].dataLabels=this.convertList(getStringParam("SERIE_DATA_LABELS_"+i,""));
			}


    	} // end for


		if (linePlot!=null)
		{

			if (linePlot instanceof CurvePlotter)
			{
				((CurvePlotter) (linePlot)).segments=getIntParam("CURVECHART_SEGMENTS",new Integer(24)).intValue();
			}

		}

    	if (barPlot!=null)
    	{

        	barPlot.barsBase=getDoubleParam("BARCHART_BASE",new Double(0)).doubleValue();


        	// summed labels
        	barPlot.summedLabels=getBooleanParam("BARCHART_SUMMED_LABELS",true);

        	// bar width
        	Integer in=getIntParam("BARCHART_BARWIDTH",null);
        	if (in!=null) barPlot.barWidth=in.intValue();

        	// space between 2 bars
        	in=getIntParam("BARCHART_BARSPACE",null);
        	if (in!=null) barPlot.interBarSpace=in.intValue();

        	// space between 2 groups
        	in=getIntParam("BARCHART_GROUPSPACE",null);
        	if (in!=null) barPlot.interBarSpace=in.intValue();


    	}

		if (barPlot3D!=null)
		{

        	barPlot3D.barsBase=getDoubleParam("BARCHART_BASE",new Double(0)).doubleValue();


        	// summed labels
        	barPlot3D.summedLabels=getBooleanParam("BARCHART_SUMMED_LABELS",true);

        	 // bar width
        	Integer in=getIntParam("BARCHART_BARWIDTH",null);
        	if (in!=null) barPlot3D.barWidth=in.intValue();

        	 // space between 2 bars
        	in=getIntParam("BARCHART_BARSPACE",null);
        	if (in!=null) barPlot3D.interBarSpace=in.intValue();

        	// space between 2 groups
        	in=getIntParam("BARCHART_GROUPSPACE",null);
        	if (in!=null) barPlot3D.interBarSpace=in.intValue();

    	}



    	if (radarPlot!=null)
    	{

        	// size
        	Double d=getDoubleParam("RADARCHART_RADIUS",null);
        	if (d!=null) radarPlot.radiusModifier=d.doubleValue();

        	//circle?
			radarPlot.drawCircle=getBooleanParam("RADARCHART_CIRCLE",false);

			// backgorund
			fstyle=convertFillStyle(getStringParam("RADARCHART_BACK",""));
			if (fstyle!=null) radarPlot.backStyle=fstyle;

			// pie border
			lstyle=convertLineStyle(getStringParam("RADARCHART_BORDER",""));
			if (lstyle!=null) radarPlot.border=lstyle;

			// grid
			lstyle=convertLineStyle(getStringParam("RADARCHART_GRID",""));
			if (lstyle!=null) radarPlot.gridStyle=lstyle;

			// grid font
			font=convertFont(getStringParam("RADARCHART_GRID_FONT",""));
			if (font!=null) radarPlot.gridFont=font;

			// grid font color
        	radarPlot.gridFontColor=convertColor(getStringParam("RADARCHART_GRID_FONT_COLOR",""));

			// faktor's font
        	font=convertFont(getStringParam("RADARCHART_FAKTOR_FONT",""));
        	if (font!=null) radarPlot.faktorFont=font;

			// faktor's color
			radarPlot.faktorColor=convertColor(getStringParam("RADARCHART_FAKTOR_COLOR",""));

			// faktor max, min and names
			String tmpList=getStringParam("RADARCHART_FAKTOR_MAX","");
			if (tmpList.length()>0) radarPlot.faktorMaxs=convertDoubleList(tmpList);

			tmpList=getStringParam("RADARCHART_FAKTOR_MIN","");
			if (tmpList.length()>0) radarPlot.faktorMins=convertDoubleList(tmpList);

			tmpList=getStringParam("RADARCHART_FAKTOR_NAMES","");
			if (tmpList.length()>0) radarPlot.faktorNames=convertList(tmpList);

			// number of ticks
			tmpList=getStringParam("RADARCHART_TICKS","");
			if (tmpList.length()>0) radarPlot.ticks=(new Integer(tmpList)).intValue();

		}

    	if (piePlot!=null)
    	{

        	// size
        	Double d=getDoubleParam("PIECHART_RADIUS",null);
        	if (d!=null) piePlot.radiusModifier=d.doubleValue();

        	// 3d
        	piePlot.effect3D=getBooleanParam("PIECHART_3D",false);

        	// pie border
        	lstyle=convertLineStyle(getStringParam("PIE_BORDER",""));
        	if (lstyle!=null) piePlot.border=lstyle;

        	// pie border
        	lstyle=convertLineStyle(getStringParam("PIE_LABEL_LINE",""));
        	if (lstyle!=null) piePlot.labelLine=lstyle;

    	}

    	// create chart and link everything
    	Plotter plot=barPlot;
    	if (plot==null) plot=barPlot3D;
    	if (plot==null) plot=linePlot3D;
    	if (plot==null) plot=linePlot;
    	if (plot==null) plot=piePlot;
    	if (plot==null) plot=radarPlot;


    	chart=null;
		if ((plot==piePlot) || (plot==radarPlot))
			chart=new Chart(cTitle,plot,null,null);
      	else
      		chart=new Chart(cTitle,plot,cXAxis,cYAxis);


		if ((showPosition) || (showTips) || (this.triggerJavaScript) || (this.activateHtmlLinks))
		{
			// disable paintdirect in order to be able to catch events
			//paintDirect=false;

			// add mouse listener to the applet
			if (paintDirect)
			{
				this.addMouseMotionListener((MouseMotionListener) chart);
				this.addMouseListener(this);
				this.addMouseMotionListener(this);
			}
			else
			{
				chart.addMouseMotionListener(this);
				chart.addMouseListener(this);
			}

			chart.activateSelection=true;

			// register listener
			chart.setChartListener(this);

		}

		chart.repaintAll=true;

		chart.XLabel=cXLabel;
		chart.YLabel=cYLabel;
		chart.Y2Label=cY2Label;
		if (cY2Axis!=null) chart.setY2Scale(cY2Axis);

		if ((piePlot!=null)&&(piePlot!=plot)) chart.addPlotter(piePlot);
		if ((linePlot!=null)&&(linePlot!=plot)) chart.addPlotter(linePlot);
		if ((linePlot3D!=null)&&(linePlot3D!=plot)) chart.addPlotter(linePlot3D);
		if ((barPlot3D!=null)&&(barPlot3D!=plot)) chart.addPlotter(barPlot3D);

		// legend and layout
		if (getBooleanParam("LEGEND",true)) chart.legend=clegend;

		plegendPosition=getStringParam("LEGEND_POSITION","RIGHT");
		if (plegendPosition.compareTo("RIGHT")==0) chart.layout=Chart.LAYOUT_LEGEND_RIGHT;
		if (plegendPosition.compareTo("BOTTOM")==0) chart.layout=Chart.LAYOUT_LEGEND_BOTTOM;
		if (plegendPosition.compareTo("TOP")==0) chart.layout=Chart.LAYOUT_LEGEND_TOP;
		Double d;

		// margins
		d=getDoubleParam("LEFT_MARGIN",null);
		if (d!=null) chart.leftMargin=d.doubleValue();

		d=getDoubleParam("RIGHT_MARGIN",null);
		if (d!=null) chart.rightMargin=d.doubleValue();

		d=getDoubleParam("TOP_MARGIN",null);
		if (d!=null) chart.topMargin=d.doubleValue();
		d=getDoubleParam("LEGEND_MARGIN",null);
		if (d!=null) chart.legendMargin=d.doubleValue();
		d=getDoubleParam("BOTTOM_MARGIN",null);
		if (d!=null) chart.bottomMargin=d.doubleValue();

		// chart background
		lstyle=convertLineStyle(getStringParam("CHART_BORDER",""));
		if (lstyle!=null) chart.border= lstyle;
		fstyle=convertFillStyle(getStringParam("CHART_FILL",""));
		if (fstyle!=null) chart.back= fstyle;

		// remove empty space on the right side of the x axis
		if (getBooleanParam("CHART_FULL_XAXIS",false)) chart.fullXAxis=true;
		double tmpDouble=this.getDoubleParam("CHART_SECOND_AXIS_MARGIN",new Double(0.1)).doubleValue();
		chart.secondYAxisMargin=tmpDouble;

		String backImageStr=getStringParam("BACK_IMAGE","");
		if (backImageStr.compareTo("")!=0)
		{
			java.awt.Image im2=null;
			String cb="";
			try
			{
				java.awt.MediaTracker mt2 = new java.awt.MediaTracker(this);
				if (this.isStandalone)
				{
					// load as we are in servlet

					java.io.FileInputStream in=null;
					byte[] b=null;
					int size=0;

					in=new java.io.FileInputStream(backImageStr);
					if (in!=null)
					{
						size=in.available();
						b=new byte[size];
						in.read(b);
						im2=Toolkit.getDefaultToolkit().createImage(b);
						in.close();
					}

				}
				else // load as we are in applet
				{
					cb=this.getCodeBase().toString();
					if (backImageStr.toLowerCase().indexOf("http://")>=0) cb="";

					im2=this.getImage(new java.net.URL(cb+backImageStr));

				}

				if (im2!=null)
				{
					mt2.addImage(im2,0); mt2.waitForID(0);
					int WidthIm = im2.getWidth(null);
					chart.backImage=im2;
				}

			}
			catch (Exception e2)
			{
				System.out.println("Error reading "+cb+backImageStr+": "+e2.getMessage());
			}


		}

		chart.repaintAll=true;
		chart.repaintAlways=true;
     	// Applet layout
    	this.setLayout(new java.awt.BorderLayout());

    	// add chart to applet
		chart.tmpImage=this.createImage(500,500);

		chart.virtualWidth=(int) this.getDoubleParam("CHART_WIDTH",new Double(0)).doubleValue();
		chart.virtualHeight=(int) this.getDoubleParam("CHART_HEIGHT",new Double(0)).doubleValue();


        if (this.getStringParam("DOUBLE_BUFFERING","").toUpperCase().compareTo("NO")==0) chart.doubleBuffering=false;

		if ((( chart.virtualWidth>0) || (chart.virtualHeight>0)) && (iChart.d==chart.d()) && (!this.isStandalone) )
		{
			boolean allowZoom=false;

    	    iChart iC= new iChart(chart,(getStringParam("CHART_ALLOW_ZOOM","").compareTo("TRUE")==0));

			if (getStringParam("CHART_MAX_ZOOM","").length()>0) iC.maxZoom=(int) this.getDoubleParam("CHART_MAX_ZOOM",new Double(0)).doubleValue();
			if (getStringParam("CHART_MIN_ZOOM","").length()>0) iC.minZoom=(int) this.getDoubleParam("CHART_MIN_ZOOM",new Double(0)).doubleValue();
			if (getStringParam("CHART_ZOOM_INC","").length()>0) iC.zoomIncrement=(int) this.getDoubleParam("CHART_ZOOM_INC",new Double(0)).doubleValue();


			this.add("Center",iC);
			this.doLayout();
			iC.init();
			interactive=true;

		}
		else
		{
			chart.virtualWidth=0;
			chart.virtualHeight=0;

			// used in servlet, no browser, use paint Direct
			if (this.isStandalone) paintDirect=true;

			if (paintDirect)
			{
				chart.setSize(this.getSize());
				gChart=chart;
				// force repaint
				if (!isStandalone)
				{
					tmpImage=null;
					this.paint(this.getGraphics());
				}
			}
			else
			{
				gChart=chart;
				this.add("Center",chart);
				this.doLayout();
			}


		}

		//this.paintAll(this.getGraphics());



	}


	public void update(Graphics g)
	{
		paint(g);
	}

	public void paint(Graphics g)
	{

		if ((interactive) || (!paintDirect))  super.paint(g);
  		else
  		{


			// if size changed force repaint
			if ((this.lastWidth!=this.getSize().width) || ( this.lastHeight!=this.getSize().height))
			{
				tmpImage=null;
				this.lastWidth=this.getSize().width;
				this.lastHeight=this.getSize().height;
			}

			if (tmpImage==null)
			{

				gChart.setSize(this.getSize());
				tmpImage=this.createImage(this.getSize().width,this.getSize().height);
				Graphics g2=tmpImage.getGraphics();
				gChart.paint(g2);
			}

			g.drawImage(tmpImage,0,0,null);
		}
	}

	// load data (parameters) from URL

	private void loadDataFromFile(String sFile)
	{
		String fileData="";
		String param="";
		String value="";
		boolean alreadyFound;


		// read the file and process the contents line by line
		try
		{
			java.io.BufferedReader in=null;


			// read url
			// if there is no ://  then add codebase
			if ( (sFile.indexOf(":/")==-1)) sFile=this.getCodeBase()+sFile;

			in=null;

			if (sFile.indexOf("file://")==0)
			{

				in = new java.io.BufferedReader(
				new java.io.FileReader(sFile.substring(7,sFile.length())));

			}
			else
			{

				java.net.URL u =new java.net.URL(sFile);
				//System.out.println("Opening: "+sFile);

				in = new java.io.BufferedReader(new java.io.InputStreamReader(u.openStream()));

			}

			//System.out.println("File opened");

			String inputLine="";
			while ((inputLine = in.readLine()) != null)
			{
				fileData=fileData+inputLine+((char) 13)+((char) 10);

			}
			//System.out.println("File closed");
			in.close();
		}
		catch (Exception e)
		{
			String err=e.getMessage();
			System.out.println("Could not open file: "+sFile+" "+e);
		}


		// split into lines
		String line="";
		int p;
		int p2;
		while (fileData.length()>0)
		{

			p=fileData.indexOf(""+((char) 13)+((char) 10));
			p2=fileData.indexOf(""+((char) 10));
			if ((p<=p2) && (p>=0))
			{	// if line ends with 13 +10
				line=fileData.substring(0,p);
				fileData=fileData.substring(p+2,fileData.length());
			}

			if ((p>p2) && (p2>=0))
			{	// if line ends only with 10
				line=fileData.substring(0,p2);
				fileData=fileData.substring(p2+1,fileData.length());
			}

			if ((p2==-1) && (p==-1))
			{
				line=fileData;
				fileData="";
			}

			// process line
			// split line, parameter=value
			p=line.indexOf("=");
			if (p>-1)
			{
				param=line.substring(0,p);
				value=line.substring(p+1,line.length());

				param=param.toUpperCase();

				// store key and value
				alreadyFound=false;
				// is the key already there?
				for (int h=0;h<loadedParametersCount;h++)
					if (loadedParameters[h].compareTo(param)==0)
					{
						loadedValues[h]=value;
						alreadyFound=true;
					}

				// new entry
				if (!alreadyFound)
				{
					loadedParameters[loadedParametersCount]=param;
					loadedValues[loadedParametersCount]=value;
					loadedParametersCount++;
				}

			}


		}



	}



	//Component initialization
	private void jbInit() throws Exception
	{
	}

	//Start the applet
	public void start()
	{
		//System.out.println("start");
		if (stopped) init();
		stopped=false;

		if ((this.triggerJS) || (reloadFrom.length()>0))
		{
			deamon=new chartD();
			deamon.applet=this;
			new Thread(deamon).start();
		}


	}

	//Stop the applet
	public void stop()
	{
		//System.out.println("stop");
		stopped=true;

		if (deamon!=null)  deamon.stop=true;
		deamon=null;
	}

	//Destroy the applet
	public void destroy()
	{
		// System.out.println("destroy");
		if (deamon!=null)  deamon.stop=true;
		deamon=null;

	}

	//Get Applet information
	public String getAppletInfo()
	{
		return "Applet Information";
	}

	//Get parameter info
	public String[][] getParameterInfo()
	{
		String[][] pinfo ={	{"Title", "String", ""},};
		return pinfo;
	}

	// Java script function
	public void rebuild(String Clear,String reReadFile)
	{

		if (Clear.compareTo("Y")==0)
		{
			loadedParametersCount=0;
		}

		if (reReadFile.compareTo("Y")==0)
		{
			// load parameters from file
			String pFile=getStringParam("DATAFILE","");
			if (pFile.length()>0) loadFromFile(pFile,"N");
		}

		buildChart();
	}

	public void loadFromFile(String psFile,String Clear)
	{


		if (Clear.compareTo("Y")==0)
		{
			loadedParametersCount=0;
		}

		loadDataFromFile(psFile);

	}

	public void setParameter(String param,String value)
	{
		boolean alreadyFound;

		// store key and value
		alreadyFound=false;
		// is the key already there?
		for (int h=0;h<loadedParametersCount;h++)
        	if (loadedParameters[h].compareTo(param)==0)
        	{
				loadedValues[h]=value;
				alreadyFound=true;
			}

		// new entry
		if (!alreadyFound)
		{
			loadedParameters[loadedParametersCount]=param;
			loadedValues[loadedParametersCount]=value;
			loadedParametersCount++;
		}
	}


	// chart listener
	public void paintUserExit(Chart c,Graphics g)
	{
		// paint values on screen, where the cursor is


		if ((showTips) && (c.selectedSerie.length()>0) &&  (c.selectedSeriePoint>=0))
		{

			for (int i=0;i<this.pSeriesNames.length;i++)
				if (this.pSeriesNames[i]!=null)
					if (this.pSeriesNames[i].compareTo(c.selectedSerie)==0)

						// serie found, get tip
						if (this.tips.length>i)
							if (this.tips[i]!=null)
								if (this.tips[i].length>c.selectedSeriePoint)
								{

									// now show tip

									// multiline
									String[] tip=this.convertList(tips[i][c.selectedSeriePoint],"\\n");

									g.setFont(tipFont);
									// value
									String val="" /*+(int) c.currentValueX+","*/ +(int) c.currentValueY ;
									int he=g.getFontMetrics().getHeight() + 4;
									int wi=4;

									for (int h=0;h<tip.length;h++)
										if ((g.getFontMetrics().stringWidth(tip[h])+ 4)>wi)
											wi=g.getFontMetrics().stringWidth(tip[h])+ 4;

									g.setColor(tipColor); // background
									g.fillRect(c.currentX,c.currentY-(he*tip.length),wi,he*tip.length);
									g.setColor(tipFontColor); // border
									g.drawRect(c.currentX,c.currentY-(he*tip.length),wi,he*tip.length);

									for (int h=0;h<tip.length;h++)
										g.drawString(tip[h],c.currentX+2,c.currentY-4-(he*(tip.length-h-1)));


									// do not draw posisiotn
									return;

								}

   		}

		if (showPosition)
			if ((c.currentX>0) && (c.currentY>0))
			{
				g.setFont(tipFont);
				// value
				String val="" /*+(int) c.currentValueX+","*/ +(int) c.currentValueY ;
				int he=g.getFontMetrics().getHeight() + 4;
				int wi=g.getFontMetrics().stringWidth(val)+4;

				g.setColor(tipColor); // background
				g.fillRect(c.currentX,c.currentY-he,wi,he);
				g.setColor(tipFontColor); // border
				g.drawRect(c.currentX,c.currentY-he,wi,he);
				g.drawString(val,c.currentX+2,c.currentY-4);
			}
	}

	public void mouseMoved(MouseEvent e)
	{

		// change cursor
		if ((this.activateHtmlLinks) || (this.triggerJavaScript))
		{
			if (gChart.selectedSerie.length()>0)
				this.setCursor(handCursor);
      		else
      			this.setCursor(pointerCursor);
		}

		if ((showPosition) || (showTips))
		{
			//gChart.paint(gChart.getGraphics());
			tmpImage=null; // in order  to force repainting
			paint(this.getGraphics());
		}

	}

	public void mouseExited(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
	public void mouseClicked(MouseEvent e)
	{

		for (int i=0;i<this.pSeriesNames.length;i++)
			if (this.pSeriesNames[i]!=null)
				if (this.pSeriesNames[i].compareTo(gChart.selectedSerie)==0)

					// serie found, get tip
					if (this.htmlLinks.length>i)
						if (this.htmlLinks[i]!=null)
							if (this.htmlLinks[i].length>gChart.selectedSeriePoint)
								if (this.htmlLinks[i][gChart.selectedSeriePoint].length()>0)
									try
									{
										this.getAppletContext().showDocument(new java.net.URL(htmlLinks[i][gChart.selectedSeriePoint]),this.htmlLinkTarget);
										break;
									}
									catch (Exception e1)
									{
										System.out.println(e1.getMessage());
									}


		if (this.triggerJavaScript)
			if (gChart.selectedSerie.length()>0)
				try
				{
					netscape.javascript.JSObject JS=netscape.javascript.JSObject.getWindow(this);

					Object[] o=new Object[2];
					o[0]=gChart.selectedSerie;
					o[1]="" + gChart.selectedSeriePoint;
					//System.out.println(""+gChart.selectedSeriePoint);
					JS.call("OnClickRChart",o);
				}
				catch (Exception e1)
				{
					System.out.println(e1.getMessage());
				}

	}

	private class chartD implements Runnable
	{

		public boolean stop=false;
		public Applet applet;

		public void run()
		{

			while (!stop)
			{

				// trigger JS
				if (triggerJS)
				{
					try
					{
						netscape.javascript.JSObject JS=netscape.javascript.JSObject.getWindow(applet);
						JS.call("OnRChart",null);
					}
					catch (Exception e1)
					{
						System.out.println(e1.getMessage());
					}
				}

				// new parameters
				if (reloadFrom.length()>0)
				{
					//System.out.println("loading "+reloadFrom);
					loadFromFile(reloadFrom,"N");
					buildChart();

				}

				try
				{
					Thread.currentThread().sleep(msecs);
				}
				catch (Exception e) {}


			}

		}
	}

}