import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import java.awt.geom.*;
import java.awt.print.*;
import java.awt.print.PrinterJob;
import java.text.*;

public class HTTPGetRelatorio extends HttpServlet
{
	public static ParamBasic param;

	public void init(ServletConfig config) throws ServletException
	{
		try
		{
			super.init(config);
			param = new ParamBasic();
		}
		catch (ServletException e)
		{
			throw e;
		}
	}

	public void doGet (HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
	{
		doPost( request, response );
	}

	public void doPost (HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
		int pagina;
		PrintWriter	output;
		StringBuffer buf = new StringBuffer();
		String buffer = new String();
		String aux = new String();
		int transac;

		response.setContentType("text/html");
		response.setHeader ("Pragma", "no-cache");
		response.setHeader ("Cache-Control", "no-cache");
		output = response.getWriter ();

		// Nao cria uma sessao (false) se uma nao existir
		HttpSession session = request.getSession(false);
		if(session == null)
		{
			buf.append( param.get_HTML_Interromper("Aviso", "No exite sesso habilitada"));
		}
		else
		{
			String userid = (String) session.getValue("userid");
			String username = (String) session.getValue("username");

			aux = request.getParameter("pagina");
			pagina = (aux == null) ? 0 : Integer.parseInt(aux);

			/**************************************************
			A variavel 'pagina" define a pgina a ser carregada

			pagina	= 0 "NULL"	(Indica que  um relatrio)
					= 1			(Transferencia de saldo)
					= 2			(Habilitacao avulsa)
					= 3			(Troca de ESN nica)
					= 4			(Troca de ESN Simultnea)
					= 5			(Alterao de Validade)
					= 6			(Devoluo de Valor de Extrato)
					= 7			(Impugnaes DCL)
					= 8			(Transferncia de Cargas DCL)
					= 9			(Incluso/Prorrogao do servio ICH promocional)
					= 10		(Cancelamento de recargas)
					= 11		(Batimento Crditos/Dbitos excepcionais)
			**************************************************/
			if ( pagina != 0 )
			{
				try
				{
					listaParam(output, pagina, userid, username);
				}
				catch (Exception ex)
				{
					buf.append( param.get_HTML_Interromper("Aviso", ex.getMessage()) );
					output.println( buf.toString() );
				}
			}
			else
			{
				/****************************************
				Obtem informaes para montar o relatrio
				*****************************************/
				try
				{
					buffer = 	recuperaParamBasics( request ) +
								param.xml_str("USERNAME",username) +
								param.xml_str("USERID", userid);

	System.out.println("Buffer = " + buffer);

					getRelatorio( output, buffer );
				}
				catch (Exception e)
				{
					buf.append( param.get_HTML_Interromper("Aviso", e.getMessage()) );
					output.println( buf.toString() );
				}
			}
		}
		output.close();
    }

	/***************************************
    Obtem parmetros passados para o ServLet
    ****************************************/
    private String recuperaParamBasics ( HttpServletRequest request )
	{
		StringBuffer buf = new StringBuffer();
		Enumeration e = request.getHeaderNames();

		e = request.getParameterNames();
		if (e.hasMoreElements())
		{
		   	while (e.hasMoreElements())
		   	{
				String name = (String)e.nextElement();
				buf.append ( param.xml_str(name.toUpperCase(),request.getParameter(name)) );
		   	}
		}
		return buf.toString();
	}

    /******************************
     Faz a solicitao do relatorio
    *******************************/
	private void getRelatorio( PrintWriter output, String buffer ) throws Exception
	{
		StringBuffer buf = new StringBuffer();

		buf.append( param.xml_ini() );

		buf.append( buffer );

		ClientPPS2 pps = new ClientPPS2();

		try
		{
			pps.runClient(buf.toString(),output);
			pps = null;
		}
		catch (Exception excep)
		{
			throw excep;
		}
	}

	/***************************************
	 Obtem parametros:	Lojas
	 					Estados do celular
	****************************************/
	private void listaParam(PrintWriter output, int pagina, String userid, String username) throws Exception
	{
		StringBuffer buf = new StringBuffer();

		buf.append( param.xml_ini() );
		buf.append( param.xml_transac(0) );
		buf.append( param.xml_str("USERID", userid) );
		buf.append( param.xml_str("NUMREL", pagina) );

		ClientPPS pps = new ClientPPS();

		try
		{
			String resp = pps.runClient(buf.toString());
			pps = null;
			String status = param.xml_get(resp, "STATUS");

			if ( !status.equals("OK") )
			{
				String mens_erro = param.xml_get(resp, "ERR_MENS");
				throw new Exception( mens_erro );
			}

			String lojas = param.xml_get(resp, "LOJA");
			String estados = param.xml_get(resp, "ESTADO");
			String mails = param.xml_get(resp, "MAIL");
			output.println(param.showHTML(param.get_Titulo(pagina - 1),
			pagina, lojas, estados, mails, userid, username));
		}
		catch (Exception e)
		{
			throw e;
		}
	}
}
