// Fig. 19.5: HTTPGetHomeValidaLogin.java
// Creating and sending a page to the client
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class HTTPMenu extends HttpServlet
{
	public static ParamBasic param;

	public void init(ServletConfig config) throws ServletException
	{
		try
		{
			super.init(config);
			param = new ParamBasic();
		}
		catch (ServletException e)
		{
			throw e;
		}
	}

	public void doGet( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException
	{
		try
		{
			doPost(request, response);
		}
		catch (ServletException se)
		{
			log(se.toString());
			throw se;
		}
		catch (IOException ioe)
		{
			log(ioe.toString());
			throw ioe;
		}
	}

	public void doPost( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException
	{
		PrintWriter output;
		String relat, resp;

		response.setContentType( "text/html" );		// content type
		response.setHeader ("Pragma", "no-cache");
		response.setHeader ("Cache-Control", "no-cache");
		output = response.getWriter();				// get writer

		// create and send HTML page to client
		StringBuffer buf = new StringBuffer();

		// Nao cria uma sessao (false) se uma nao existir
		HttpSession session = request.getSession(false);
		if(session == null)
		{
			buf.append( param.get_HTML_Interromper("Aviso", "No exite sesso habilitada"));
		}
		else
		{
			try
			{
				String userid = (String) session.getValue("userid");
				String username = (String) session.getValue("username");

				resp = getRelatorio(userid);
				relat = param.xml_get(resp, "RELAT");

				try
				{
					relatorio(output, username, relat);
				}
				catch (Exception e)
				{
					log(e.toString());
					buf.append( param.get_HTML_Interromper("Aviso - relatorio()", e.getMessage()) );
					output.print(buf.toString());
				}
			}
			catch (Exception e)
			{
				log(e.toString());
				buf.append( param.get_HTML_Interromper("Aviso - getRelatorio()", e.getMessage()) );
				output.print(buf.toString());
			}
		}

		output.close();							// close PrintWriter stream
	}

	// Obtem parametros do relatorio
	private String getRelatorio(String userid) throws Exception
	{
		try
		{
			StringBuffer buf = new StringBuffer();

			buf.append( param.xml_ini() );
			buf.append( param.xml_str("USERID", userid) );
			buf.append( param.xml_transac(98) );

			ClientPPS pps = new ClientPPS();

			try
			{
				String resp = pps.runClient(buf.toString());
				pps = null;
				String status = param.xml_get(resp, "STATUS");
				if ( !status.equals("OK") )
				{
					String mens_erro = param.xml_get(resp, "ERR_MENS");
					throw new Exception( mens_erro );
				}
				return resp;
			}
			catch (Exception e)
			{
				throw e;
			}
		}
		catch (Exception e)
		{
			throw e;
		}
	}

	private String getRotulo(HttpSession session)
	{
		return ("sessions.id: " + session.getId() + "<br>\n" +
				"created: " + new Date(session.getCreationTime()) + "<br>\n" +
				"lastaccessed: " + new Date(session.getLastAccessedTime()) + "<br>\n");
	}

	// Cria relatorio.html
	private void relatorio(PrintWriter output, String username, String relat)
	{
		output.println("<html>");
		output.println("<head>");
		output.println("<title>Relatrios PPS</title>");
		output.println("<STYLE TYPE=\"text/css\"><!--");
		output.println("H1");
		output.println("{");
		output.println("COLOR: gold;");
		output.println("FONT-FAMILY: Arial;");
		output.println("FONT-SIZE: 22pt;");
		output.println("FONT-WEIGHT: bold;");
		output.println("}");
		output.println("--></STYLE>");
		output.println("</head>");
		output.println("<body oncontextmenu=\"return false\" background=" + param.get_Fundo() + ">\n");
		output.println("<br><br>");
		output.println("<center>");
		output.println("<h1>Relatrios PPS</h1>");
		output.println("</center>");
		output.println("<center>");
		output.println("<TABLE border=\"2\" bordercolor=\"gold\">");
		output.println("<TR>");
		output.println("<TD>");
		output.println("<TABLE border=\"2\" bordercolor=\"white\">");
		output.println("<TR>");
		output.println("<TD>");
		output.println("<APPLET code=MenuButton.class codebase="+param.get_APPLET()+" Width=\"300\" Height=\"350\">");
		output.println("<param name=\"isHorizontal\" value=\"false\">");
		output.println("<param name=\"3DBorder\" value=\"false\">");
		output.println("<param name=\"buttonType\" value=\"1\">");
		output.println("<param name=\"status\" value=\"link\">");
		output.println("<param name=\"alignText\" value=\"left\">");
		output.println("<param name=\"backColor\" value=\"0071B7\">");
		output.println("<param name=\"backHighColor\" value=\"000080\">");
		output.println("<param name=\"fontColor\" value=\"ffffff\">");
		output.println("<param name=\"fontHighColor\" value=\"FFD700\">");
		output.println("<param name=\"font\" value=\"Arial,11,1\">");
		output.println("<param name=\"menuItems\"  value=\"");
		output.println("{Telesp Celular,http://www.telespcelular.com.br,_self,images/home.gif}");
		output.println("{-}");

		// Obtem o cdigo dos relatorios permitidos
		try
		{
			int tam, pos;
			String cod, descr, aux;

			tam=relat.length();
			pos=0;
			while(true)
			{
				cod = param.getSubstring(relat, pos);
				pos=pos+cod.length()+1;
				descr = param.getSubstring(relat, pos);
				pos=pos+descr.length()+1;
				aux = param.getRelatURL(cod, descr);
				if (aux != null) output.println(aux);
				if (pos >= tam) break;
			}
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
		};

		output.println("</applet>");
		output.println("</TD>");
		output.println("</TR>");
		output.println("</TABLE>");
		output.println("</TD>");
		output.println("</TR>");
		output.println("</TABLE>");
		output.println("<br>");
		output.println( param.get_Logo() );

		// Instrues para voltar tela
		output.println( "<input type=button value=\"Volta Pgina \" onClick=\"history.go(-1)\">" );

		output.println("</center>");
		output.println("</body>");
		output.println("</html>");
	}
}
