import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.net.URL;
import java.net.MalformedURLException;
import java.util.*;
import java.text.*;
import java.awt.List;
import javax.swing.*;

public class Informacao extends Panel implements ActionListener
{
	private Button btOk;
	private DataInfo data;
	private ComboLojaEst lojaEst;
	private MailForm email;
	private boolean permite = false;
	private String Mensagem;
	private URL pagina = null;
	private int perfil;
	private AppletContext appletContext;
	private int transac;
	private Dimension tamanho;
	public static final Parametro param = new Parametro();

	/*********
	Construtor
	**********/
	Informacao( int width,
				int height,
				AppletContext appletContext,
				int perfil,
				List lstLoja,
				List lstEstado,
				List lstMail,
				int transac,
				String[] codigo,
				String[] codestado)
	{
		super();

		this.perfil = perfil;
		this.appletContext = appletContext;
		this.transac = transac;

		tamanho = new Dimension(width,height);

		// Panel para intervalo de datas
		data = new DataInfo(this);
		lojaEst = new ComboLojaEst(this, lstLoja, lstEstado, codigo, codestado);
		email = new MailForm(lstMail);

		btOk = new Button();
		btOk.setLabel("        OK        ");
		btOk.setEnabled(false);
		btOk.addActionListener(this);

		Panel pnlDados1 = new Panel(new BorderLayout(5,5));
		pnlDados1.add(data, BorderLayout.NORTH);
		pnlDados1.add(lojaEst, BorderLayout.CENTER);

		Panel pnlDados2 = new Panel(new BorderLayout(5,5));
		pnlDados2.add(pnlDados1, BorderLayout.NORTH);
		pnlDados2.add(email, BorderLayout.CENTER);

		Panel pnlMsg = new Panel(new FlowLayout(FlowLayout.CENTER));
		pnlMsg.add(btOk);

		setLayout(new BorderLayout(2,2));
		add (pnlDados2, BorderLayout.NORTH);
		add (pnlMsg, BorderLayout.SOUTH);

		setBackground(param.get_BackColor());
		setForeground(param.get_ForeColor());
	}

	public void chkLojaFocus()
	{
		lojaEst.chkLojaFocus();
	}

	/**************************************
	Tratamento do evento do clique no boto
	***************************************/
	public void actionPerformed (ActionEvent e )
	{
		enviaInformacao();
	}

	/***************************************
	Envia informaes da tela para o servlet
	****************************************/
	private void enviaInformacao()
	{
		if ( permite )
		{
			try
			{
				if ( getTransaction() != 8 )
				{
					data.periodoValido();
				}
			}
			catch ( Exception e )
			{
				Mensagem = e.getMessage();
				JOptionPane.showMessageDialog(null, Mensagem, "Periodo invlido !",
													JOptionPane.ERROR_MESSAGE);
				checaInfo();	// Mantem boto de OK
				return;
			}

			try
			{
				//validaEmail();
				pagina = new URL(getURL());
				appletContext.showDocument(pagina);
			}
			catch( MalformedURLException murle )
			{
				JOptionPane.showMessageDialog(null, murle.getMessage(), "URL invlida !",
													JOptionPane.ERROR_MESSAGE);
			}
			catch (Exception ex)
			{
				JOptionPane.showMessageDialog(null, ex.getMessage(), "URL invlida !",
													JOptionPane.ERROR_MESSAGE);
			}

			permite = false;
			btOk.setEnabled(false);
		}
	}

	/***************************************************************
	Retorna a URL adequada de acordo com a transacao a ser executada
	****************************************************************/
	public String getURL() throws Exception
	{
		String dataIni, dataFim, address;

		try
		{
			if ( getTransaction() == 8 )
			{
				dataIni = "";
				dataFim = "";
			}
			else
			{
				dataIni = "&dataini="+data.getDataIniInv();
				dataFim = "&datafim="+data.getDataFimInv();
			}

			address =	param.get_homeRelat() + "?" + "transac=" + transac;
			if((dataIni != null) && (dataFim != null))
				address = address + dataIni + dataFim +	"&perfil=" + perfil;

			if ( lojaEst.getStateLoja() )
					address += "&" + "codLoja=" + lojaEst.getCodLoja();

			if ( lojaEst.getStateLogin() )
					address += "&" + "login=" + lojaEst.getLogin();

			if ( ( email.getEmailSize() != 0 ) && ( email.getEmailState() ) )
				address += "&" + "email=" + email.getEmail();

			if ( email.getTextState() )
				address += "&" + "texto=1";

			if (( transac == 5 ) && ( lojaEst.getStateEstado() ))
				address += "&" + "estado=" + lojaEst.getCodEstado();

			return address;
		}
		catch (Exception e)
		{
			throw e;
		}
	}

	/********************************************************************
	Define quando o boto OK estar habilitado ( verifica Datas e Login )
	*********************************************************************/
	public void checaInfo()
	{
		boolean ok = false;

		if (( data.getSizeDataIni() != 0 ) && ( data.getSizeDataFim() != 0 ) && ( data.getStatus() ))
		{
			ok = checaLojaLogin();
		}
		else if ( !data.getStatus() )
		{
			ok = checaLojaLogin();
		}

		btOk.setEnabled(ok);
		permite = ok;

	}

	/********************************
	Verifica o preenchimento do login
	*********************************/
	public boolean checaLojaLogin()
	{
		boolean ret;

		if ( lojaEst.getStateLogin() )
		{
			if  ( (lojaEst.getSizeLogin() != 0) && (!lojaEst.getBlankLogin()) ) ret = true;
			else ret = false;
		}
		else if ( lojaEst.getStateLoja() ) ret = true;
		else ret = false;

		if ( transac == 8 ) ret = true;

		return ret;
	}

	/******************
	Retorna a transacao
	*******************/
	public int getTransaction()
	{
		return transac;
	}
}