import java.awt.*;
import java.net.*;
import java.awt.event.*;
import java.awt.Label;
import java.awt.TextField;
import java.applet.Applet;
import java.applet.AppletContext;

import java.io.PrintStream;
import java.io.DataInputStream;
import java.io.IOException;
import javax.swing.*;

public class Login extends Applet
{
	private Button btOk;
	private URL newDocument;
	private String contexto;
	public static final Parametro param = new Parametro();
	public void init()
	{
		btOk = new Button();
		btOk.setLabel("   Ok   ");
		btOk.setEnabled(false);
		btOk.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					getURL();
				}
			});

		Titulo titulo = new Titulo("LOGIN",20,20);
		Usuario usr = new Usuario();

		Panel pnlButton = new Panel(new FlowLayout());
		pnlButton.add(btOk);

		Panel pnlLogin = new Panel(new BorderLayout(5,5));
		pnlLogin.add(titulo, BorderLayout.NORTH);
		pnlLogin.add(usr, BorderLayout.CENTER);
		pnlLogin.add(pnlButton, BorderLayout.SOUTH);

		Panel pnlDados = new Panel(new FlowLayout());
		pnlDados.add(pnlLogin);

		// Monta o Logotipo com usurio e nome
		Image image = getImage(getCodeBase(), param.LOGO);
		LogoUsuario logousuario = new LogoUsuario("?","?",image);

		setLayout(new BorderLayout(5,5));
		add(logousuario,"West");
		add(pnlDados,"East");

		setBackground(param.get_BackColor());
		setForeground(param.get_ForeColor());
		setFont(param.get_Fonte());
	}

	// Substitui o comando AppletContext.showDocument()
	public void getURL()
  	{
		String result;

    	try
    	{
			URL urlLogin = new URL(param.get_Login()+contexto);
			URLConnection connection = urlLogin.openConnection();

     		DataInputStream in = new DataInputStream(connection.getInputStream());
			result = in.readLine();
      		in.close();

      		String status = param.xml_get(result, "STATUS");
			if(status != null)
			{
				if(status.equals("OK"))
				{
					try
					{
						newDocument = new URL(param.get_Menu());
						AppletContext browser = getAppletContext();
						browser.showDocument ( newDocument, param.TARGET_WINDOW );
					}
					catch (Exception e)
					{
						JOptionPane.showMessageDialog(null, e.getMessage(), "Erro",
													JOptionPane.ERROR_MESSAGE);
					}
					newDocument = null;
				}
				else
				{
					System.out.println(status.substring(13,status.length()));
					if ( status.substring(13,status.length()).trim().equals("Senha invalida") )
						JOptionPane.showMessageDialog(null, "Senha invlida !", "Aviso",
													JOptionPane.ERROR_MESSAGE);
					else if ( status.startsWith("java.net.ConnectException") )
						JOptionPane.showMessageDialog(null, "Falha na conexo !", "Aviso",
													JOptionPane.ERROR_MESSAGE);
					else
						JOptionPane.showMessageDialog(null, status, "Aviso",
													JOptionPane.ERROR_MESSAGE);
				}
			}
			else
			{
				JOptionPane.showMessageDialog(null, "Sem resposta !", "Erro",
													JOptionPane.ERROR_MESSAGE);
			}
     	}
      	catch(MalformedURLException mue)
      	{
      		System.out.println("Illegal URL: " + mue);
    	}
    	catch(IOException ioe)
    	{
    		System.out.println("IOException: " + ioe);
    	}
    	catch(Exception e)
    	{
			System.out.println("Error: " + e);
		}
	}

	/***************************
	 Panel para entrada de dados
	****************************/
	private class Usuario extends Panel implements KeyListener
	{
		private TextField txtUsr;
		private TextField txtSen;
		private String focus;

		public Usuario()
		{
			focus=".";

			Label lblUsr = new Label("Usurio");
			Label lblSen = new Label("Senha");
			txtUsr = new TextField(12);
			txtUsr.setName("txtUsr");
			txtUsr.addKeyListener(this);
			txtUsr.setBackground(Color.white);
			txtUsr.setForeground(Color.black);

			txtSen = new TextField(12);
			txtSen.setName("txtSen");
			txtSen.setEchoChar('*');
			txtSen.addKeyListener(this);
			txtSen.setBackground(Color.white);
			txtSen.setForeground(Color.black);

			Panel pnlEsq = new Panel(new GridLayout(2,1,5,5));
			pnlEsq.add(lblUsr);
			pnlEsq.add(lblSen);

			Panel pnlDir = new Panel(new GridLayout(2,1,5,5));
			pnlDir.add(txtUsr);
			pnlDir.add(txtSen);

			setLayout(new BorderLayout(5,5));
			add(pnlEsq, BorderLayout.WEST);
			add(pnlDir, BorderLayout.CENTER);
			setBackground(param.get_BackColor());
			setForeground(param.get_ForeColor());
		}

		public void paint (Graphics g)
		{
			update(g);
		}

		public void update(Graphics g)
		{
			Dimension d = getSize();

			g.setColor(param.get_BackColor());
			g.fill3DRect(0, 0, d.width - 1, d.height - 1, true);

			g.setColor(Color.yellow);
			g.drawRoundRect(5, 5, d.width - 10, d.height - 10, 10, 10);
		}

		public Insets getInsets()
		{
			return new Insets(10,10,10,10);
		}

		public void keyTyped(KeyEvent e) {}
		public void keyPressed(KeyEvent e) {}
		public void keyReleased(KeyEvent e)
		{

			int keyCode = e.getKeyCode();

	        // Consiste o caracter TAB ou ENTER
	        if((keyCode == 9) || (keyCode == 10))
	        {
				if(focus.equals("txtUsr"))
				{
					try
					{
						txtSen.requestFocus();
					}
					catch(Exception e1) {};
				}

				if(focus.equals("txtSen"))
				{
					try
					{
						btOk.requestFocus();
						focus = "";
					}
					catch(Exception e2) {};
				}
			}

			habConfirma();
			focus = e.getComponent().getName();
		}

		private void habConfirma()
		{
			try
			{
				if ((txtUsr.getText().length() > 0) && (txtSen.getText().length() > 0))
				{
					String userID = param.criptografia(param.CRYPTO, txtUsr.getText().trim());
					String passWD = param.criptografia(param.CRYPTO, txtSen.getText().trim());
					contexto = "?userid="+userID+"&passwd="+passWD+param.getCtrl();
					btOk.setEnabled(true);
				}
				else
					btOk.setEnabled(false);
			}
			catch (Exception e) {};
		}
	}
}
