import java.awt.*;
import java.awt.event.*;

public class MailForm extends Panel implements ItemListener
{
	private Checkbox chkMail, chkText;
	private Choice choMail;
	private TextField txtEmail;
	public static final Parametro param = new Parametro();

	MailForm(List lstMail)
	{
		super();

		Label lblMail = new Label("Envie o relatrio para o grupo ou e-mail escolhido");
		lblMail.setFont(param.get_Fonte());
		lblMail.setBackground(param.get_BackColor());
		lblMail.setForeground(param.get_ForeColor());

		chkMail = new Checkbox("E-Mail");
		chkMail.setBackground(param.get_BackColor());
		chkMail.setState(false);
		chkMail.addItemListener(this);

		chkText = new Checkbox("Mensagem no formato TEXTO");
		chkText.setBackground(param.get_BackColor());
		chkText.setState(false);
		chkText.addItemListener(this);

		choMail = new Choice();
		choMail.setEnabled(false);
		choMail.setBackground(param.get_ForeColor());
		choMail.setForeground(param.get_WriteColor());
		try
		{
			for(int i=0; i<lstMail.getItemCount(); i++ ) choMail.add(lstMail.getItem(i));
		}
		catch (Exception e)
		{
			System.out.println( e.toString() );
		}

		Panel p1= new Panel();
		p1.setLayout(new BorderLayout());
		p1.add(chkMail,"West");
		p1.add(choMail,"Center");
		p1.add(chkText,"South");

		setLayout(new BorderLayout());
		add(lblMail,"North");
		add(p1,"Center");

		setBackground(param.get_BackColor());
		setForeground(param.get_ForeColor());
	}

	public void itemStateChanged(ItemEvent e)
	{
		if ( e.getSource() == chkMail )
		{
			if ( chkMail.getState() )
			{
				choMail.setEnabled(true);
				chkText.setEnabled(true);
			}
			else
			{
				choMail.setEnabled(false);
				chkText.setEnabled(false);
			}
		}
	}

	public String getEmail()
	{
		return choMail.getSelectedItem().trim();
	}

	public int getEmailSize()
	{
		return getEmail().length();
	}

	public boolean getEmailState()
	{
		return chkMail.getState();
	}

	public boolean getTextState()
	{
		return chkText.getState();
	}

	public void update (Graphics g)
	{
		paint(g);
	}

	public void paint(Graphics g)
	{
		Dimension d = getSize();

		g.setColor(param.get_BackColor());
		g.fill3DRect(0, 0, d.width - 1, d.height - 1, true);

		g.setColor(Color.yellow);
		g.drawRoundRect(5, 5, d.width - 10, d.height - 10, 10, 10);
	}

	public Insets getInsets()
	{
		return new Insets(10,10,10,10);
	}
}
