import java.awt.*;
import java.net.*;
import java.awt.event.*;
import java.awt.Label;
import java.awt.TextField;
import java.awt.Choice;
import java.applet.Applet;
import java.applet.AppletContext;

public class Celular extends Applet
{
	private Button btOk, btSair;
	private Dimension size;
	private URL newDocument;
	private String contexto;
	private String username;
	private Regiao reg;
	private static final Parametro param = new Parametro();

	private Font lbl_font = new Font("SansSerif", Font.PLAIN + Font.BOLD, 12);

	public final static Color BG = Color.lightGray;
	public final static Color FG = Color.black;

	public void init()
	{
		size = getSize();
		username = getParameter("username");

		btOk = new Button();
		btOk.setLabel("Ok");
		btOk.setEnabled(false);
		btOk.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					habilitaCadastro();
				}
			});

		btSair = new Button();
		btSair.setLabel("Volta");
		btSair.setEnabled(true);
		btSair.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					voltaPagina();
				}
			});

		Titulo titulo = new Titulo(username,20,20);
		reg = new Regiao();

		Panel panelSup = new Panel(new BorderLayout(5,5));
		panelSup.add(titulo, BorderLayout.NORTH);
		panelSup.add(reg, BorderLayout.CENTER);

		Panel panel2 = new Panel(new GridLayout(1,2,5,5));
		panel2.add(btOk);
		panel2.add(btSair);
		Panel panelInf = new Panel(new FlowLayout(FlowLayout.CENTER));
		panelInf.add(panel2);

		setLayout(new BorderLayout(5,5));
		add (panelSup, BorderLayout.NORTH);
		add (panelInf, BorderLayout.SOUTH);

		setBackground(BG);
		setForeground(FG);
		setSize(size);
	}

	// Habilita tela de cadastro
	private void habilitaCadastro()
	{
		if (reg.celularIsValid())
		{
			// Cria a URL
			try
			{
				newDocument = new URL(param.get_homeCliente()+contexto+param.getCtrl());
				AppletContext browser = getAppletContext();
				//browser.showDocument ( newDocument, "_self" );
				browser.showDocument ( newDocument, param.TARGET_WINDOW );
			}
			catch (Exception e)
			{
				System.out.println("URL Invalido");
			}
			newDocument = null;
		}
	}

	// Volta Pgina
	private void voltaPagina()
	{
		// Cria a URL
		try
		{
			newDocument = new URL(param.get_homeLogin());
			AppletContext browser = getAppletContext();
			browser.showDocument ( newDocument, param.TARGET_WINDOW );
		}
		catch (Exception e)
		{
			System.out.println("URL Invalido");
		}
		newDocument = null;
	}

	private class Regiao extends Panel implements KeyListener
	{
		private TextField txtCelular;
		private Choice chRegiao;
		private Dimension sizeP;

		public Regiao()
		{
			int mHeight, mWidth;

			mHeight = (int)(size.height * 0.6);
			mWidth = (int)(size.width);

			sizeP = new Dimension(mWidth, mHeight);
			txtCelular = new TextField(10);
			txtCelular.addKeyListener(this);

			chRegiao = new Choice();
			chRegiao.add("Amrica do Norte");
			chRegiao.add("Coria");

			setLayout(new BorderLayout(5,40));
			add(txtCelular, BorderLayout.NORTH);
			add(chRegiao, BorderLayout.SOUTH);
			setSize(sizeP);
		}

		public Dimension getPreferredSize()
		{
			return getMinimumSize();
		}

		public Dimension getMinimumSize()
		{
			return sizeP;
		}

		public void paint (Graphics g)
		{
			update(g);
		}

		public void update(Graphics g)
		{
			int largura, altura, posY1, posY2;

			largura = sizeP.width - 10;
			altura = (int)(sizeP.height * 0.5 - 20);
			posY1 = 10;
			posY2 = sizeP.height - altura - 1;

			g.setColor(Color.blue);
			g.setFont(lbl_font);
			g.drawRoundRect(5, posY1, largura, altura, 5, 5);
			g.drawString("Nmero do celular", 10, 10);

			g.drawRoundRect(5, posY2, largura, altura, 5, 5);
			g.drawString("Regio", 10, posY2);
		}

		public Insets getInsets()
		{
			return new Insets(20,10,10,10);
		}

		public void keyPressed(KeyEvent e) {}

		public void keyReleased(KeyEvent e)	{}

		public void keyTyped(KeyEvent e)
		{
			habConfirma();
		}

		private void habConfirma()
		{
			try
			{
				if (txtCelular.getText().length() > 9)
				{
					contexto = "?celular=" + txtCelular.getText().trim();
					btOk.setEnabled(true);
				}
				else
					btOk.setEnabled(false);
			}
			catch (Exception e) {};
		}

		public boolean celularIsValid()
		{
			try
			{
				char ch = (char) txtCelular.getText().trim().charAt(0);
				System.out.println("ch = " + ch);

				if (ch == '4')	return true;

				String mens = "O celular: " + txtCelular.getText().trim() + " no pertence a Global";
				FrameMensag aviso = new FrameMensag("Aviso", mens);
			}
			catch (Exception e)
			{
				System.out.println(e.toString());
			};
			return false;
		}
	}
}
