import java.awt.*;
import java.net.*;
import java.awt.event.*;
import java.awt.Label;
import java.awt.TextField;
import java.awt.Choice;
import java.applet.Applet;
import java.applet.AppletContext;

public class Cliente extends Applet
{
	private Button btOk, btSair;
	private Dimension size;
	private static final Parametro param = new Parametro();
	private DadosCliente cli;
	private Titulo titulo;
	private Status status;

	private String celular;
	private String cpf;
	private String cnpj;
	private String adesao;
	private String nome;
	private String tipo;
	private String endereco;
	private String cep;
	private String nome_empresa;
	private String nome_contato;
	private String fone_contato;
	private String esn;
	private String nam2;
	private String periodo_ini;
	private String periodo_fim;
	private String ltipo;

	private URL newDocument;
	private String contexto;
	private Font lbl_font = new Font("SansSerif", Font.PLAIN + Font.BOLD, 12);

	public final static Color BG = Color.lightGray;
	public final static Color FG = Color.black;

	public void init()
	{
		size = getSize();

		status = new Status("...",20,20);
		getParametros();
		titulo = new Titulo("Celular: " + celular + " - CLIENTE ROAMING CDMA v1.2",20,20);

		btOk = new Button();
		btOk.setLabel("Enviar");
		btOk.setEnabled(false);
		btOk.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					enviaDados();
				}
			});

		btSair = new Button();
		btSair.setLabel("Volta");
		btSair.setEnabled(true);
		btSair.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					voltaPagina();
				}
			});

		cli = new DadosCliente();

		Panel panelSup = new Panel(new BorderLayout(5,5));
		panelSup.add(titulo, BorderLayout.NORTH);
		panelSup.add(cli, BorderLayout.CENTER);

		Panel panel2 = new Panel(new GridLayout(1,3,5,5));
		panel2.add(btOk);
		panel2.add(btSair);

		Panel panelInf = new Panel(new FlowLayout(FlowLayout.CENTER));
		panelInf.add(panel2);

		Panel panel3 = new Panel(new BorderLayout(5,5) );
		panel3.add(panelInf, BorderLayout.NORTH);
		panel3.add(status, BorderLayout.SOUTH);

		setLayout(new BorderLayout(5,5));
		add (panelSup, BorderLayout.CENTER);
		add (panel3, BorderLayout.SOUTH);

		setBackground(BG);
		setForeground(FG);
		setSize(size);
	}

	// Envia dados
	private void enviaDados()
	{
		if(cli.dadosOk())
		{


			// Cria a URL
			try
			{
				newDocument = new URL(param.get_homeDados()+contexto+param.getCtrl());
				AppletContext browser = getAppletContext();
				browser.showDocument ( newDocument, param.TARGET_WINDOW );
			}
			catch (Exception e)
			{
				System.out.println("URL Invalido");
			}
			newDocument = null;
		}
	}

	// Volta Pgina
	private void voltaPagina()
	{
		// Cria a URL
		try
		{
			newDocument = new URL(param.get_homeCelular());
			AppletContext browser = getAppletContext();
			browser.showDocument ( newDocument, param.TARGET_WINDOW );
		}
		catch (Exception e)
		{
			System.out.println("URL Invalido");
		}
		newDocument = null;
	}

	// Obtem parametros
	private void getParametros()
	{
		celular = getParameter("celular");
		cpf = getParameter("codcli");
		cnpj = getParameter("cnpj");
		adesao = getParameter("adesao");
		nome = getParameter("nome");
		tipo = getParameter("tipo");
		endereco = getParameter("endereco");
		cep = getParameter("cep");
		nome_empresa = getParameter("nome_empresa");
		nome_contato = getParameter("nome_contato");
		fone_contato = getParameter("fone_contato");
		esn = getParameter("esn");
		nam2 = getParameter("nam2");
		periodo_ini = getParameter("periodo_ini");
		periodo_fim = getParameter("periodo_fim");
		ltipo = getParameter("ltipo");
		ltipo.replace('_', ' ');

		try
		{
			String xxx = getParameter("status");
			status.setMensag( xxx );
			System.out.println("xxx=" + xxx);
		}
		catch (Exception e)
		{
			System.out.println( e.toString() );
		};
	}

	private class DadosCliente extends Panel implements KeyListener, FocusListener
	{
		private TextField txtCPF, txtCNPJ, txtAdesao, txtNome, txtTipo;
		private TextField txtEnder, txtCEP, txtNomeEmpresa, txtNomeContato;
		private TextField txtFoneContato, txtESN, txtNAM2, txtPeriodoIni, txtPeriodoFim;
		private Choice chTipo;
		private Dimension sizeP;

		private final String MSG_CNPJ_INVALIDO = "CNPJ no possui qtd. mnima de caracteres";
		private final String MSG_CPF_INVALIDO = "CPF no possui qtd. mnima de caracteres";
		private final String MSG_ESN_INVALIDO = "ESN no possui a qtd. de caracteres necessrios";

		public DadosCliente()
		{
			int mHeight, mWidth;

			mHeight = (int)(size.height * 0.85);
			mWidth = (int)(size.width);
			sizeP = new Dimension(mWidth, mHeight);

			Label lblCPF = new Label("CPF");
			Label lblCNPJ = new Label("CNPJ");
			Label lblAdesao = new Label("Adeso");
			Label lblNome = new Label("Nome");
			Label lblTipo = new Label("Tipo Cliente");
			Label lblEnder = new Label("Endereo");
			Label lblCEP = new Label("CEP");
			Label lblNomeEmpresa = new Label("Nome Empresa");
			Label lblNomeContato = new Label("Nome Contato");
			Label lblFoneContato = new Label("Fone Contato");
			Label lblESN = new Label("ESN");
			Label lblNAM2 = new Label("NAM 2");
			Label lblPeriodo = new Label("Utilizao: de");
			Label lblAte = new Label("At");

			txtCPF = new TextField(cpf, 18);
			txtCPF.addKeyListener(this);

			txtCNPJ = new TextField(cnpj, 18);
			txtCNPJ.addKeyListener(this);

			txtAdesao = new TextField(adesao, 18);
			txtAdesao.setEnabled(false);
			txtAdesao.addKeyListener(this);

			txtNome = new TextField(nome, 60);
			txtNome.addKeyListener(this);

			txtEnder = new TextField(endereco, 60);
			txtEnder.addKeyListener(this);

			txtCEP = new TextField(cep, 10);
			txtCEP.addKeyListener(this);

			txtNomeEmpresa = new TextField(nome_empresa, 60);
			txtNomeEmpresa.addKeyListener(this);

			txtNomeContato = new TextField(nome_contato, 40);
			txtNomeContato.addKeyListener(this);

			txtFoneContato = new TextField(fone_contato, 18);
			txtFoneContato.addKeyListener(this);

			txtESN = new TextField(esn, 18);
			txtESN.addFocusListener(this);
			txtESN.addKeyListener(this);

			txtNAM2 = new TextField(nam2, 18);
			txtNAM2.setEnabled(false);
			txtNAM2.addKeyListener(this);

			txtPeriodoIni = new TextField(periodo_ini, 18);
			txtPeriodoIni.setEnabled(false);
			txtPeriodoIni.addKeyListener(this);

			txtPeriodoFim = new TextField(periodo_fim, 18);
			txtPeriodoFim.setEnabled(false);
			txtPeriodoFim.addKeyListener(this);

			char ch;
			String aux = "";
			chTipo = new Choice();
			chTipo.addKeyListener(this);
			int pos = 0;
			for(int i = 0; i < ltipo.length(); i++)
			{
				ch = ltipo.charAt(i);
				if(ch == ';')
				{
					chTipo.add(aux);
					if (getChaveTipo(aux).equals(tipo))	chTipo.select(pos);
					aux = "";
					pos++;
				}
				else
					aux += ch;
			}

			Panel p1 = new Panel(new GridLayout(10,1,5,5));
			p1.add(lblCPF);
			p1.add(lblNome);
			p1.add(lblTipo);
			p1.add(lblEnder);
			p1.add(lblCEP);
			p1.add(lblNomeEmpresa);
			p1.add(lblNomeContato);
			p1.add(lblESN);
			p1.add(lblNAM2);
			p1.add(lblPeriodo);

			Panel p2 = new Panel(new FlowLayout(FlowLayout.LEFT,0,0));
			p2.add(txtCPF);
			p2.add(lblCNPJ);
			p2.add(txtCNPJ);
			p2.add(lblAdesao);
			p2.add(txtAdesao);

			Panel pTipo = new Panel(new FlowLayout(FlowLayout.LEFT,0,0));
			pTipo.add(chTipo);

			Panel pCEP = new Panel(new FlowLayout(FlowLayout.LEFT,0,0));
			pCEP.add(txtCEP);

			Panel pContato = new Panel(new FlowLayout(FlowLayout.LEFT,0,0));
			pContato.add(txtNomeContato);
			pContato.add(lblFoneContato);
			pContato.add(txtFoneContato);

			Panel pPeriodo = new Panel(new FlowLayout(FlowLayout.LEFT,0,0));
			pPeriodo.add(txtPeriodoIni);
			pPeriodo.add(lblAte);
			pPeriodo.add(txtPeriodoFim);

			Panel pESN = new Panel(new FlowLayout(FlowLayout.LEFT,0,0));
			pESN.add(txtESN);

			Panel pNAM2 = new Panel(new FlowLayout(FlowLayout.LEFT,0,0));
			pNAM2.add(txtNAM2);

			Panel p5 = new Panel(new GridLayout(10,1,5,5));
			p5.add(p2);
			p5.add(txtNome);
			p5.add(pTipo);
			p5.add(txtEnder);
			p5.add(pCEP);
			p5.add(txtNomeEmpresa);
			p5.add(pContato);
			p5.add(pESN);
			p5.add(pNAM2);
			p5.add(pPeriodo);

			setLayout(new BorderLayout(10,10));
			add(p1, BorderLayout.WEST);
			add(p5, BorderLayout.EAST);
			setSize(sizeP);
		}

		public Dimension getPreferredSize()
		{
			return getMinimumSize();
		}

		public Dimension getMinimumSize()
		{
			return sizeP;
		}

		public void paint (Graphics g)
		{
			update(g);
		}

		public void update(Graphics g)
		{
			int largura, altura;

			largura = sizeP.width - 10;
			altura = (int)(sizeP.height - 10);

			g.setColor(Color.blue);
			g.setFont(lbl_font);
			g.drawRoundRect(5, 5, largura, altura, 5, 5);
		}

		public Insets getInsets()
		{
			return new Insets(20,10,10,10);
		}

		public void keyPressed(KeyEvent e) {}

		public void keyReleased(KeyEvent e)	{}

		public void keyTyped(KeyEvent e)
		{
			habConfirma();
		}

		private void habConfirma()
		{
			boolean ok = true;
			int tam;

			tam = getESN().length();
			if ( tam < 8 && tam > 0)
			{
				ok=false;
				status.setMensag( MSG_ESN_INVALIDO );
			}

			tam = getCNPJ().length();
			if ( tam < 11 && tam > 0)
			{
				ok=false;
				status.setMensag( MSG_CNPJ_INVALIDO );
			}

			tam = getCPF().length();
			if ( tam < 11 && tam > 0)
			{
				ok=false;
				status.setMensag( MSG_CPF_INVALIDO );
			}

			btOk.setEnabled(ok);
			if (ok) status.setMensag( "..." );
		}

		private boolean dadosOk()
		{
			String mens;

			if (getESN().length() != 8)
			{
				mens = "ESN " + getESN() + " invlido!\n\nDeve ter 8 caracteres.";
				FrameMensag aviso = new FrameMensag("Aviso", mens);
				btOk.setEnabled(false);
				return false;
			}

			if ( getCPF().length() < 11)
			{
				FrameMensag aviso = new FrameMensag("Aviso", MSG_CPF_INVALIDO);
				btOk.setEnabled(false);
				return false;
			}

			if (getCNPJ().length() > 0)
			{
				if (getNomeEmpresa().length() == 0)
				{
					mens = " obrigatrio informar a empresa referente ao CNPJ";
					FrameMensag aviso = new FrameMensag("Aviso", mens);
					btOk.setEnabled(false);
					return false;
				}

				if (getCNPJ().length() < 11)
				{
					FrameMensag aviso = new FrameMensag("Aviso", MSG_CNPJ_INVALIDO);
					btOk.setEnabled(false);
					return false;
				}
			}

			if (getNomeEmpresa().length() > 0)
			{
				if (getCNPJ().length() == 0)
				{
					mens = " obrigatrio informar o CNPJ referente a empresa";
					FrameMensag aviso = new FrameMensag("Aviso", mens);
					btOk.setEnabled(false);
					return false;
				}
			}

			StringBuffer buf = new StringBuffer();

			buf.append( param.xml_ini() );
			buf.append( param.xml_str("CELULAR", celular) );
			buf.append( param.xml_str("CODCLI", getCPF() ) );
			buf.append( param.xml_str("CNPJ", getCNPJ() ) );
			buf.append( param.xml_str("DTADESAO", getAdesao() ) );
			buf.append( param.xml_str("NOME", getNome() ) );
			buf.append( param.xml_str("TPCLIENTE", getTipo() ) );
			buf.append( param.xml_str("END", getEnder() ) );
			buf.append( param.xml_str("CEP", getCEP() ) );
			buf.append( param.xml_str("NMEMPRESA", getNomeEmpresa() ) );
			buf.append( param.xml_str("NMCONT", getNomeContato() ) );
			buf.append( param.xml_str("TLCONT", getFoneContato() ) );
			buf.append( param.xml_str("ESN", getESN() ) );
			buf.append( param.xml_str("NAM", getNAM2() ) );
			buf.append( param.xml_str("DTINIC", getPeriodoIni() ) );
			buf.append( param.xml_str("DTFIM", getPeriodoFim() ) );
			contexto = "?dados=" + buf.toString();
			return true;
		}

		private String getCPF()
		{
			return txtCPF.getText().trim();
		}

		private String getCNPJ()
		{
			return txtCNPJ.getText().trim();
		}

		private String getAdesao()
		{
			return txtAdesao.getText().trim();
		}

		private String getNome()
		{
			return txtNome.getText().trim();
		}

		private String getEnder()
		{
			return txtEnder.getText().trim();
		}

		private String getCEP()
		{
			return txtCEP.getText().trim();
		}

		private String getNomeEmpresa()
		{
			return txtNomeEmpresa.getText().trim();
		}

		private String getNomeContato()
		{
			return txtNomeContato.getText().trim();
		}

		private String getFoneContato()
		{
			return txtFoneContato.getText().trim();
		}

		private String getESN()
		{
			return txtESN.getText().trim();
		}

		private String getNAM2()
		{
			return txtNAM2.getText().trim();
		}

		private String getPeriodoIni()
		{
			return txtPeriodoIni.getText().trim();
		}

		private String getPeriodoFim()
		{
			return txtPeriodoFim.getText().trim();
		}

		private String getTipo()
		{
			return getChaveTipo(chTipo.getSelectedItem().trim());
		}

		// Retorna a chave para o tipo de cliente selecionado
		private String getChaveTipo(String aux)
		{
			int i = aux.indexOf("=");
			if (i > 0) aux = aux.substring(0, i);

			return aux;
		}

		// Trata os eventos do foco
		public void focusGained(FocusEvent e) {}
		public void focusLost(FocusEvent e)
		{
			String aux1 = getESN().toUpperCase();
			String aux2 = "";
			char ch;
			for(int x=0; x<aux1.length(); x++)
			{
				ch = (char) (char) aux1.charAt(x);
				switch (ch)
				{
					case 'A':
					case 'B':
					case 'C':
					case 'D':
					case 'E':
					case 'F':
					case '0':
					case '1':
					case '2':
					case '3':
					case '4':
					case '5':
					case '6':
					case '7':
					case '8':
					case '9':	aux2 += ch;
								break;
				}
			}
			txtESN.setText(aux2);
		}
	}
}
