// Fig. 19.5: HTTPGetHomeCelular.java
// Creating and sending a page to the client
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class HTTPGetHomeCelular extends HttpServlet
{
	private Parametro param = new Parametro();

	public void doGet( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException
	{
		PrintWriter output;
		String usuario, senha;

System.out.println("Chamou o HTTPGetHomeCelular...");

		response.setContentType( "text/html" );		// content type
		output = response.getWriter();				// get writer

		// create and send HTML page to client
		StringBuffer buf = new StringBuffer();

		try
		{
			// Cria uma sessao (false) se uma nao existir
			HttpSession session = request.getSession(false);
			if(session == null)
			{
				buf.append( param.get_HTML_Interromper("Aviso", "No exite sesso habilitada") );
			}
			else
			{
				buf.append( param.get_HTML_Inicio( param.get_homeTitulo(), getRotulo(session)) );
				buf.append( param.get_codeCelular() );
			}
		}
		catch (Exception e)
		{
			buf.append( param.get_HTML_Interromper("Erro", e.toString()));
		}

		buf.append( param.get_HTML_Fim() );
      	output.println( buf.toString() );
		output.close();								// close PrintWriter stream
	}

	private String getRotulo(HttpSession session)
	{
		return ("sessions.id: " + session.getId() + "<br>\n" +
				"created: " + new Date(session.getCreationTime()) + "<br>\n" +
				"lastaccessed: " + new Date(session.getLastAccessedTime()) + "<br>\n");
	}
}
