// Fig. 19.5: HTTPGetHomeCliente.java
// Creating and sending a page to the client
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class HTTPGetHomeCliente extends HttpServlet
{
	private Parametro param = new Parametro();

	public void doGet( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException
	{
		PrintWriter output;
		String celular, username;

System.out.println("Chamou o HTTPGetHomeCliente...");

		celular = request.getParameter("celular");

		response.setContentType( "text/html" );		// content type
		output = response.getWriter();				// get writer

		// create and send HTML page to client
		StringBuffer buf = new StringBuffer();

		// Nao cria uma sessao (false) se uma nao existir
		HttpSession session = request.getSession(false);
		if(session == null)
		{
			buf.append( param.get_HTML_Interromper("Aviso", "No exite sesso habilitada"));
		}
		else
		{
			try
			{
				String aux = validaCelular(celular, session);
				buf.append( aux );
			}
			catch (Exception e)
			{
				log(e.toString());

				username = (String) session.getValue("username");
				String codErro = param.getCodigoErro(e.getMessage());
				String descrErro = param.getDescricaoErro(e.getMessage());
				buf.append( param.get_HTML_Celular(codErro, descrErro, username) );
				//buf.append( param.get_HTML_Interromper("Erro", e.getMessage()));
			}
		}

		buf.append( param.get_HTML_Fim() );
		System.out.println( buf.toString() );

      	output.println( buf.toString() );
		output.close();							// close PrintWriter stream
	}

	// Valida o celular
	private String validaCelular(String celular, HttpSession session) throws Exception
	{
		String aux;
		StringBuffer buf;

		buf = new StringBuffer();
		buf.append( param.xml_ini() );
		buf.append( param.xml_str("CELULAR", celular) );
		buf.append( param.xml_transac(1) );

		ClientPPS pps = new ClientPPS();

		try
		{
			String resp = pps.runClient(buf.toString());
			pps = null;
			String status = param.xml_get(resp, "STATUS");

			System.out.println("status="+status);
			if ( !(status.equals("OK") || status.equals("-5")) )
			{
				String mens_erro = param.xml_get(resp, "ERR_MENS");
				throw new Exception( mens_erro );
			}

			buf = new StringBuffer();
			buf.append( param.get_HTML_Inicio( param.get_homeTitulo(), getRotulo(session)) );
			buf.append( param.get_codeCliente() );

			aux = param.xml_get(resp, "CELULAR");
			buf.append( param.criaParam("celular", 0, aux));

			aux = param.xml_get(resp, "CODCLI");
			buf.append( param.criaParam("codcli", 0, aux));

			aux = param.xml_get(resp, "CNPJ");
			buf.append( param.criaParam("cnpj", 0, aux));

			aux = param.xml_get(resp, "DTADESAO");
			buf.append( param.criaParam("adesao", 0, aux));

			aux = param.xml_get(resp, "NOME");
			buf.append( param.criaParam("nome", 0, aux));

			aux = param.xml_get(resp, "TPCLIENTE");
			buf.append( param.criaParam("tipo", 0, aux));

			aux = param.xml_get(resp, "END");
			buf.append( param.criaParam("endereco", 0, aux));

			aux = param.xml_get(resp, "CEP");
			buf.append( param.criaParam("cep", 0, aux));

			aux = param.xml_get(resp, "NMEMPRESA");
			buf.append( param.criaParam("nome_empresa", 0, aux));

			aux = param.xml_get(resp, "NMCONT");
			buf.append( param.criaParam("nome_contato", 0, aux));

			aux = param.xml_get(resp, "TLCONT");
			buf.append( param.criaParam("fone_contato", 0, aux));

			aux = param.xml_get(resp, "ESN");
			buf.append( param.criaParam("esn", 0, aux));

			aux = param.xml_get(resp, "NAM");
			buf.append( param.criaParam("nam2", 0, aux));

			aux = param.xml_get(resp, "DTINIC");
			buf.append( param.criaParam("periodo_ini", 0, aux));

			aux = param.xml_get(resp, "DTFIM");
			buf.append( param.criaParam("periodo_fim", 0, aux));

			aux = (String) session.getValue("ltipo");
			buf.append( param.criaParam("ltipo", 0, aux));

			buf.append( param.criaParam("status", 0, "..."));

			System.out.println( buf.toString() );
			return buf.toString();
		}
		catch (Exception e)
		{
			throw e;
		}
	}

	private String getRotulo(HttpSession session)
	{
		return ("sessions.id: " + session.getId() + "<br>\n" +
				"created: " + new Date(session.getCreationTime()) + "<br>\n" +
				"lastaccessed: " + new Date(session.getLastAccessedTime()) + "<br>\n");
	}
}
