// Fig. 19.5: HTTPGetHomeValidaLogin.java
// Creating and sending a page to the client
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class HTTPPostHome extends HttpServlet
{
	private Parametro param = new Parametro();

	public void doGet( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException
	{
System.out.println("Chamou o HTTPPostHome...");

		try
		{
			doPost(request, response);
		}
		catch (ServletException se)
		{
			log(se.toString());
			throw se;
		}
		catch (IOException ioe)
		{
			log(ioe.toString());
			throw ioe;
		}
	}

	public void doPost( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException
	{
		PrintWriter output;
		String dados;

		dados = request.getParameter("dados");

		response.setContentType( "text/html" );		// content type
		output = response.getWriter();				// get writer

		// create and send HTML page to client
		StringBuffer buf = new StringBuffer();

		try
		{
			HttpSession session = request.getSession(false);

			if (session == null)
				buf.append( param.get_HTML_Interromper("Aviso", "Sesso desabilitada") );
			else
			{
				String usuario = (String) session.getValue("usuario");
				String username = (String) session.getValue("username");
				if (usuario == null || username == null)
					buf.append( param.get_HTML_Interromper("Aviso", "Usurio desativado") );
				else
				{
					// Grava dados no PPS
					try
					{
						gravaDados(dados, usuario);
						buf.append( param.get_HTML_Celular("Ok!", "Operao efetuada com sucesso!", username) );
					}
					catch (Exception e)
					{
						log(e.toString());

						//String codErro = param.getCodigoErro(e.getMessage());
						String descrErro = param.getDescricaoErro(e.getMessage());

						//buf.append( param.get_HTML_Celular(codErro, descrErro, username) );

						buf.append ( devolveTela(dados, descrErro, session) );
					}
				}
			}
		}
		catch (Exception e)
		{
			buf.append( param.get_HTML_Interromper("Aviso", e.getMessage()) );
		}

		buf.append( param.get_HTML_Fim() );
System.out.println( buf.toString() );
      	output.println( buf.toString() );
		output.close();							// close PrintWriter stream
	}

	private void gravaDados(String dados, String usuario) throws Exception
	{
		StringBuffer buf = new StringBuffer();

		buf.append( param.xml_ini() );
		buf.append( dados );
		buf.append( param.xml_str("USER", usuario) );
		buf.append( param.xml_transac(2) );

		ClientPPS pps = new ClientPPS();

		try
		{
			String resp = pps.runClient(buf.toString());
			pps = null;
			String status = param.xml_get(resp, "STATUS");

			System.out.println("status do gravaDados="+status);
			if ( !status.equals("OK") )
			{
				String mens_erro = param.xml_get(resp, "ERR_MENS");
				throw new Exception( mens_erro );
			}
		}
		catch (Exception e)
		{
			throw e;
		}
	}

	// Devolve a tela para cadastro
	private String devolveTela(String resp, String status, HttpSession session)
	{
		String aux;
		StringBuffer buf = new StringBuffer();

		buf.append( param.get_HTML_Inicio( param.get_homeTitulo(), getRotulo(session)) );
		buf.append( param.get_codeCliente() );

		aux = param.xml_get(resp, "CELULAR");
		buf.append( param.criaParam("celular", 0, aux));

		aux = param.xml_get(resp, "CODCLI");
		buf.append( param.criaParam("codcli", 0, aux));

		aux = param.xml_get(resp, "CNPJ");
		buf.append( param.criaParam("cnpj", 0, aux));

		aux = param.xml_get(resp, "DTADESAO");
		buf.append( param.criaParam("adesao", 0, aux));

		aux = param.xml_get(resp, "NOME");
		buf.append( param.criaParam("nome", 0, aux));

		aux = param.xml_get(resp, "TPCLIENTE");
		buf.append( param.criaParam("tipo", 0, aux));

		aux = param.xml_get(resp, "END");
		buf.append( param.criaParam("endereco", 0, aux));

		aux = param.xml_get(resp, "CEP");
		buf.append( param.criaParam("cep", 0, aux));

		aux = param.xml_get(resp, "NMEMPRESA");
		buf.append( param.criaParam("nome_empresa", 0, aux));

		aux = param.xml_get(resp, "NMCONT");
		buf.append( param.criaParam("nome_contato", 0, aux));

		aux = param.xml_get(resp, "TLCONT");
		buf.append( param.criaParam("fone_contato", 0, aux));

		aux = param.xml_get(resp, "ESN");
		buf.append( param.criaParam("esn", 0, aux));

		aux = param.xml_get(resp, "NAM");
		buf.append( param.criaParam("nam2", 0, aux));

		aux = param.xml_get(resp, "DTINIC");
		buf.append( param.criaParam("periodo_ini", 0, aux));

		aux = param.xml_get(resp, "DTFIM");
		buf.append( param.criaParam("periodo_fim", 0, aux));

		aux = (String) session.getValue("ltipo");
		buf.append( param.criaParam("ltipo", 0, aux));

		buf.append( param.criaParam("status", 0, status));

		System.out.println( buf.toString() );
		return buf.toString();
	}

	private String getRotulo(HttpSession session)
	{
		return ("sessions.id: " + session.getId() + "<br>\n" +
				"created: " + new Date(session.getCreationTime()) + "<br>\n" +
				"lastaccessed: " + new Date(session.getLastAccessedTime()) + "<br>\n");
	}
}
