import java.awt.event.*;
import java.awt.Label;
import java.awt.TextField;
import java.awt.*;

public class Usuario extends Panel
{
	private String username, inicSessao;
	private Dimension size;

	private Font lbl_font = new Font("Arial", Font.ITALIC, 12);
	private Font msg_font = new Font("Arial", Font.PLAIN, 12);

	public final static Color BG = Color.lightGray;
	public final static Color FG = Color.black;

	public Usuario(String username, String inicSessao)
	{
		this.username = username;
		this.inicSessao = inicSessao;


		Label lblNome = new Label("Nome:");
		TextField txtNome = new TextField(username);
		Label lblSessao = new Label("Inicio sesso:");
		TextField txtSessao = new TextField(inicSessao);

		size = getSize();
		setBackground(BG);
		setForeground(FG);
		setLayout(new FlowLayout(5));
		add(lblNome);
		add(txtNome);
		add(lblSessao);
		add(txtSessao);
	}

	public Dimension getPreferredSize()
	{
		return getMinimumSize();
	}

	public Dimension getMinimumSize()
	{
		return size;
	}

	public void paint (Graphics g)
	{
		update(g);
	}

	public void update(Graphics g)
	{
		g.setColor(Color.blue);
		g.drawRoundRect(1, 1, size.width - 3, size.height - 3, 10, 10);
	}

	public Insets getInsets()
	{
		return new Insets(5,5,5,5);
	}
}
